<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_dropeditor
 *
 * @copyright   Copyright (C) 2005 - 2014 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

JLoader::register('InstallerModelInstall', JPATH_ADMINISTRATOR . '/components/com_installer/models/install.php');

/**
 * Link manager controller class.
 *
 * @package     Joomla.Administrator
 * @subpackage  com_dropeditor
 * @since       1.6
 */
class DropeditorControllerLink extends JControllerLegacy {
	/**
	 * Method to get a model object, loading it if required.
	 *
	 * @param   string  $name    The model name. Optional.
	 * @param   string  $prefix  The class prefix. Optional.
	 * @param   array   $config  Configuration array for model. Optional (note, the empty array is atypical compared to other models).
	 *
	 * @return  JModelLegacy  The model.
	 *
	 * @since   3.2
	 */
	public function getModel($name = 'Link', $prefix = 'DropeditorModel', $config = array())
	{
		$model = parent::getModel($name, $prefix, $config);

		return $model;
	}

	public function getItems() {
		$input = JFactory::getApplication()->input;
		$parent_id = $input->getInt('id');
		$comp = $input->get('comp', null, 'RAW');
		$model = $this->getModel();

		if (!$parent_id) {
			$cats = $model->getItems($comp);
		} else {
			$cats = $model->getItems($comp, $parent_id);
		}

		$this->exit_status(true, $cats);
	}

	/**
	 * Return a json response
	 * @param $status
	 * @param array $datas array of datas to return with the json string
	 *
	 */
	private function exit_status($status,$datas=array()){
		$response = array('status'=>$status,'datas'=>$datas);
		echo json_encode($datas);
		JFactory::getApplication()->close();
	}
}