<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_dropeditor
 *
 * @copyright   Copyright (C) 2005 - 2014 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

class DropeditorControllerMedia extends JControllerLegacy
{
	/**
	 * Method to get a model object, loading it if required.
	 *
	 * @param   string  $name    The model name. Optional.
	 * @param   string  $prefix  The class prefix. Optional.
	 * @param   array   $config  Configuration array for model. Optional (note, the empty array is atypical compared to other models).
	 *
	 * @return  JModelLegacy  The model.
	 *
	 * @since   2.3
	 */
	public function getModel($name = 'Media', $prefix = 'DropeditorModel', $config = array())
	{
		$model = parent::getModel($name, $prefix, $config);

		return $model;
	}

	/**
	 * Method to get video information
	 */
	public function getVideoInfo() {
		$input = JFactory::getApplication()->input;
		$vid = $input->get('video_id', null, 'RAW');
		$type = $input->get('video_type', null, 'RAW');

		$vInfo = DropeditorHelper::getVideoInfo($vid, $type);
		if (!empty($vInfo)) {
			$this->exit_status(true, $vInfo);
		} else {
			$this->exit_status(false, array('msg' => JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_FAIL')));
		}
	}

	/**
	 *  Method to get list media files and folders
	 */
	public function getItemsList(){
		$inputs = JFactory::getApplication()->input;
		$current = $inputs->getString('cFolder', '', 'RAW');
		$parent = $inputs->getString('cParent', '', 'RAW');
		if ($parent == '#') $parent = '';
		$type = $inputs->getString('cType', '', 'RAW');
		$model = $this->getModel();

		$list = $model->getList($type, $current, $parent);

		echo json_encode($list);
		JFactory::getApplication()->close();
	}

	/**
	 * Return a json response
	 * @param $status
	 * @param array $datas array of datas to return with the json string
	 *
	 */
	private function exit_status($status,$datas=array()){
		$response = array('status'=>$status,'datas'=>$datas);
		echo json_encode($response);
		JFactory::getApplication()->close();
	}
}