<?php
/** 
 * Dropfiles
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropfiles
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


//-- No direct access
defined('_JEXEC') || die('=;)');


jimport('joomla.plugin.plugin');
jimport( 'joomla.application.categories' );

/**
 * Content Plugin.
 *
 * @package    dropfiles
 * @subpackage Plugin
 */
class plgContentdropfiles extends JPlugin
{
    public static $Once=1;
    public static $DropboxOnce=1;
    /**
     * Example before display content method
     *
     * Method is called by the view and the results are imploded and displayed in a placeholder
     *
     * @param  string  $context     The context for the content passed to the plugin.
     * @param  object  &$article    The content object.  Note $article->text is also available
     * @param  object  &$params     The content params
     * @param  int     $limitstart  The 'page' number
     *
     * @return string
     */
    public function onContentPrepare($context, &$article, &$params, $limitstart)
    {
        JLoader::register('DropfilesFilesHelper', JPATH_ADMINISTRATOR.'/components/com_dropfiles/helpers/files.php');
//        $cont = explode('.', $context);
//        if($cont[0]=='com_content'){
        $this->context = $context;
            //Replace category
            $article->text = preg_replace_callback('@<img[^>]*?data\-dropfilescategory="([0-9]+)".*?>@', array($this,'replace'),$article->text);
            //Replace single file
            $article->text = preg_replace_callback('@<img[^>]*?data\-dropfilesfile="([0-9A-Za-z:\id_-]*)".*?>@', array($this,'replaceSingle'),$article->text);
//        }
        /*
         * Sync page code use cUrl
         *
         * */
        $componentParams=JComponentHelper::getParams('com_dropfiles');

        if($componentParams->get('google_credentials') !=null)  {
            $curSyncInterval = $this->curSyncInterval();
            $sync_time = (int)$componentParams->get('sync_time');
            $sync_method = $componentParams->get('sync_method');
            if ($curSyncInterval >= $sync_time && $sync_method == 'sync_page_curl') {
                $cUrl = curl_init();
                curl_setopt($cUrl, CURLOPT_URL, JUri::root() . 'index.php?option=com_dropfiles&task=googledrive.googlesync');
				curl_setopt ($cUrl, CURLOPT_RETURNTRANSFER, 1);
                curl_exec($cUrl);
                curl_close($cUrl);

                $cUrl = curl_init();
                curl_setopt($cUrl, CURLOPT_URL, JUri::root().'index.php?option=com_dropfiles&task=frontgoogle.index');
				curl_setopt ($cUrl, CURLOPT_RETURNTRANSFER, 1);
                curl_exec($cUrl);
                curl_close($cUrl);
            }
            if ($curSyncInterval >= $sync_time && $sync_method == 'sync_page_curl_ajax' && self::$Once==1) {
				$doc = JFactory::getDocument();
				JLoader::register('DropfilesBase', JPATH_ADMINISTRATOR . '/components/com_dropfiles/classes/dropfilesBase.php');
                if (!DropfilesBase::isJoomla30()) {

                    $doc->addScript(JURI::base('true') . '/components/com_dropfiles/assets/js/jquery-noconflict.js');
                }
                $script = "jQuery(document).ready(function(){
                                jQuery.ajax({
                                    url:'index.php?option=com_dropfiles&task=googledrive.googlesync'
                                }).done(function( data ) {
                                    jQuery.ajax({
                                        url:'index.php?option=com_dropfiles&task=frontgoogle.index'
                                    });
                                });
                            });";
                $doc->addScriptDeclaration($script);

				self::$Once=0;
            }
        }

        if($componentParams->get('dropbox_token') !='')  {
            $curSyncInterval = $this->curSyncIntervalDropbox();
            $sync_time = (int)$componentParams->get('dropbox_sync_time');
            $sync_method = $componentParams->get('dropbox_sync_method');
            if ($curSyncInterval >= $sync_time && $sync_method == 'dropbox_sync_page_curl') {
                $cUrl = curl_init();
                curl_setopt($cUrl, CURLOPT_URL, JUri::root() . 'index.php?option=com_dropfiles&task=dropbox.sync');
                curl_setopt ($cUrl, CURLOPT_RETURNTRANSFER, 1);
                curl_exec($cUrl);
                curl_close($cUrl);

                $cUrl = curl_init();
                curl_setopt($cUrl, CURLOPT_URL, JUri::root().'index.php?option=com_dropfiles&task=frontdropbox.index');
                curl_setopt ($cUrl, CURLOPT_RETURNTRANSFER, 1);
                curl_exec($cUrl);
                curl_close($cUrl);
            }
            if ($curSyncInterval >= $sync_time && $sync_method == 'dropbox_sync_page_curl_ajax' && self::$DropboxOnce==1) {
                $doc = JFactory::getDocument();
                JLoader::register('DropfilesBase', JPATH_ADMINISTRATOR . '/components/com_dropfiles/classes/dropfilesBase.php');
                if (!DropfilesBase::isJoomla30()) {

                    $doc->addScript(JURI::base('true') . '/components/com_dropfiles/assets/js/jquery-noconflict.js');
                }
                $script = "jQuery(document).ready(function(){
                        jQuery.ajax({
                            url:'index.php?option=com_dropfiles&task=dropbox.sync'
                        }).done(function( data ) {
                             jQuery.ajax({
                                url:'index.php?option=com_dropfiles&task=frontdropbox.index'
                            });
                        });
                    });";
                $doc->addScriptDeclaration($script);

                self::$DropboxOnce=0;
            }
        }

        return true;
    }
    
    public function onDropfilesContentPrepare($context, &$article){
        $foo = null;
        $this->onContentPrepare($context, $article,$foo,$foo);
    }


    private function replace($match){
        jimport('joomla.application.component.model');
        JLoader::register('DropfilesBase', JPATH_ADMINISTRATOR.'/components/com_dropfiles/classes/dropfilesBase.php');
        JLoader::register('DropfilesGoogle', JPATH_ADMINISTRATOR.'/components/com_dropfiles/classes/dropfilesGoogle.php');
        JModelLegacy::addIncludePath(JPATH_ROOT.'/components/com_dropfiles/models/','dropfilesModel');
       
	dropfilesBase::loadLanguage();
        
        $modelFiles = JModelLegacy::getInstance('Frontfiles','dropfilesModel');
        $modelConfig = JModelLegacy::getInstance('Frontconfig','dropfilesModel');
        $modelCategories = JModelLegacy::getInstance('Frontcategories','dropfilesModel');
        $modelCategory = JModelLegacy::getInstance('Frontcategory','dropfilesModel');
        $modelGoogle = JModelLegacy::getInstance('Frontgoogle','dropfilesModel');
        $modelDropbox = JModelLegacy::getInstance('Frontdropbox','dropfilesModel');

        $modelFiles->getState('onsenfout'); //To autopopulate state
        $modelFiles->setState('filter.category_id', (int)$match[1]); 
        $modelCategories->getState('onsenfout'); //To autopopulate state
        $modelCategories->setState('category.id', (int)$match[1]);


        $category = $modelCategory->getCategory((int)$match[1]);
        if(!$category){
            return '';
        }
        $user	= JFactory::getUser();
        $categories = $modelCategories->getItems();
        $params = $modelConfig->getParams($category->id);
        $dropfiles_params = JComponentHelper::getParams('com_dropfiles');
        if ($dropfiles_params->get('categoryrestriction', 'accesslevel') == 'accesslevel') {

            if(!in_array($category->access,$user->getAuthorisedViewLevels()) ) {
                return '';
            }
            $modelFiles->setState('filter.access', true);

        } else {
            //check permission by user group
            $modelFiles->setState('filter.access', false);
            $usergroup = isset($params->params->usergroup) ? $params->params->usergroup : array();

            $result=array_intersect($user->getAuthorisedGroups(),$usergroup);
            if (count($result)) {} else {return '';}
        }

        if ($dropfiles_params->get('restrictfile', 0)) {
            $user = JFactory::getUser();
            $user_id = $user->id;

            $canview = isset($params->params->canview) ? $params->params->canview : 0;
            if ($user_id) {
                if ($canview == $user_id || $canview == 0) {

                } else { return '';}
            } else {
                if ($canview == 0) {

                } else {
                    return '';
                }
            }
        }
        if($category->type=='googledrive'){
            $google = new dropfilesGoogle();
            if(isset($params->params->ordering)){
                $ordering = $params->params->ordering;
            }else{
                $ordering = 'ordering';
            }
            if(isset($params->params->orderingdir)){
                $direction  = $params->params->orderingdir;
            }else{
                $direction = 'asc';
            }
            //$files = $google->listFiles($category->cloud_id,$ordering,$direction);
            $files = $modelGoogle->getItems($category->cloud_id,$ordering, $direction);
            if($files===false){
                JFactory::getApplication()->enqueueMessage($google->getLastError(), 'error');
                return '';
            }
        } elseif ($category->type=='dropbox') {

            if(isset($params->params->ordering)){
                $ordering = $params->params->ordering;
            }else{
                $ordering = 'ordering';
            }
            if(isset($params->params->orderingdir)){
                $direction  = $params->params->orderingdir;
            }else{
                $direction = 'asc';
            }
            $files = $modelDropbox->getItems($category->cloud_id,$ordering, $direction);
        } else{
            if (isset($params->params->ordering)){
                $modelFiles->setState('list.ordering',$params->params->ordering);
            }
            if(isset($params->params->orderingdir)){
                $modelFiles->setState('list.direction',$params->params->orderingdir);
            }
            $files = $modelFiles->getItems();
        }
        $files = DropfilesFilesHelper::addInfosToFile($files,$category);

        if($this->context === 'com_finder.indexer'){
            $theme = 'indexer';
        }else{
            if(!empty($params)){
                $theme = $params->theme;
            }else{
                $theme = 'default';
            }
        }
        $componentParams = JComponentHelper::getParams('com_dropfiles');

        if ($componentParams->get('loadthemecategory', 1) == 0) {
            $params->params = $this->loadParams($theme, $params->params, $componentParams);
        }

        JPluginHelper::importPlugin('dropfilesthemes');
        $dispatcher = JDispatcher::getInstance();
        $result = $dispatcher->trigger('onShowFrontCategory', array(array('files' => $files,'category'=>$category,'categories'=>$categories,'params'=>is_object($params)?$params->params:'','theme'=>$theme)));

        if(!empty($result[0])){
            JHtml::_('behavior.framework');

	    $doc = JFactory::getDocument();
            $doc->addStyleSheet(JURI::base('true').'/components/com_dropfiles/assets/css/front.css');
            if($componentParams->get('usegoogleviewer',1)==1){

                JLoader::register('DropfilesBase', JPATH_ADMINISTRATOR.'/components/com_droppics/classes/dropfilesBase.php');

                JHtml::_('jquery.framework');


                $doc->addStyleSheet(JURI::base('true').'/components/com_dropfiles/assets/css/video-js.css');
                $doc->addScript(JURI::base('true').'/components/com_dropfiles/assets/js/video.js');                              
                $doc->addScript(JURI::base('true').'/components/com_dropfiles/assets/js/colorbox.init.js');                
            }
	    $doc->addScriptDeclaration('dropfilesBaseUrl="'.JURI::base().'";');
            $doc->addScriptDeclaration('dropfilesRootUrl="'.JURI::root(true).'/'.'";');
            return $result[0];
        }
        return '';
    }

    /**
     * load theme params
     * @param string $theme
     * @param null $cat_params
     * @param null $global_params
     * @return stdClass
     */
    function loadParams($theme = 'default', $cat_params = null, $global_params = null) {

        $ob = new stdClass();
        if ($theme == '') $theme = 'default';
        foreach ((array)$cat_params as $key => $val) {
            if ($theme == 'default') {
                $ob->$key = $global_params->get($theme . '_'.$key, $val);
            } else {
                $ob->$key = $global_params->get($key, $val);
            }
        }

        return $ob;
    }

    /**
     * Replace a single image
     * @param type $match
     * @return string 
     */
    private function replaceSingle($match){
        jimport('joomla.application.component.model');
        JLoader::register('DropfilesBase', JPATH_ADMINISTRATOR.'/components/com_dropfiles/classes/dropfilesBase.php');
	JLoader::register('DropfilesGoogle', JPATH_ADMINISTRATOR.'/components/com_dropfiles/classes/dropfilesGoogle.php');
        JModelLegacy::addIncludePath(JPATH_ROOT.'/components/com_dropfiles/models/','DropfilesModelFrontfile');
        JModelLegacy::addIncludePath(JPATH_ROOT.'/components/com_dropfiles/models/','DropfilesModelFrontconfig');
	dropfilesBase::loadLanguage();
        
        $modelFile = JModelLegacy::getInstance('Frontfile','dropfilesModel');
        $modelConfig = JModelLegacy::getInstance('Frontconfig','dropfilesModel');
        $modelCategory = JModelLegacy::getInstance('Frontcategory','dropfilesModel');	
        $modelDropbox = JModelLegacy::getInstance('Frontdropbox','dropfilesModel');

        preg_match('@.*data\-dropfilesfilecategory="([0-9]+)".*@', $match[0],$matchCat);
        
        if(!empty($matchCat)){
            $category = $modelCategory->getCategory((int)$matchCat[1]);
            if(!$category){
                return '';
            }
        }else{
            $file = $modelFile->getFile((int)$match[1]);
            if($file===null){
                return '';
            }
            $category = $modelCategory->getCategory($file->catid);
            if(!$category){
                return '';
            }
        }
        
        if($category->type=='googledrive'){
            $modelGoogle = JModelLegacy::getInstance('Frontgoogle','dropfilesModel');
            $file = $modelGoogle->getFile($match[1]);
            $file->id = $file->file_id;
            $file->file = $file->title.'.'.$file->ext;
        }elseif ($category->type == 'dropbox') {
            $file = $modelDropbox->getFile($match[1]);
        } else {
            $file = $modelFile->getFile((int)$match[1]);
        }
        $file = DropfilesFilesHelper::addInfosToFile(json_decode(json_encode($file), false),$category);

        $dropfiles_params = JComponentHelper::getParams('com_dropfiles');
        if ($dropfiles_params->get('restrictfile', 0)) {
            $user = JFactory::getUser();
            $user_id = $user->id;
            $canview = isset($file->canview) ? $file->canview : 0;
            if ($user_id) {
                if ($canview == $user_id || $canview == 0) {

                } else { return '';}
            } else {
                if ($canview == 0) {

                } else {
                    return '';
                }
            }
        }

        //Access check already done in category model
        $catmod = JCategories::getInstance('Dropfiles');
        $jcategory = $catmod->get($category->id);
        if (!$jcategory) {
                return '';
        }
        
        $params = $modelConfig->getParams($jcategory->id);        
        if($this->context === 'com_finder.indexer'){
            $theme = 'indexer';
        } else {           
            $theme = 'default';           
        }
        
        JPluginHelper::importPlugin('dropfilesthemes');
        $dispatcher = JDispatcher::getInstance();
        $result = $dispatcher->trigger('onShowFrontFile', array(array('file' => $file,'category'=>$category,'params'=>$params->params,'theme'=>$theme)));
        
        if(!empty($result[0])){
            $componentParams = JComponentHelper::getParams('com_dropfiles');
			$doc = JFactory::getDocument();

            $doc->addStyleSheet(JURI::base('true').'/components/com_dropfiles/assets/css/front.css');
            if($componentParams->get('usegoogleviewer',1)==1){

                JLoader::register('DropfilesBase', JPATH_ADMINISTRATOR.'/components/com_droppics/classes/dropfilesBase.php');
                JHtml::_('jquery.framework');


                $doc->addStyleSheet(JURI::base('true').'/components/com_dropfiles/assets/css/video-js.css');
                $doc->addScript(JURI::base('true').'/components/com_dropfiles/assets/js/video.js');               
                $doc->addScript(JURI::base('true').'/components/com_dropfiles/assets/js/colorbox.init.js');                
            }
            
            $bg_color = $componentParams->get('singlebg',"#444444") ;
            $hover_color = $componentParams->get('singlehover',"#888888") ;
            $font_color =  $componentParams->get('singlefontcolor', '#ffffff');            
            $singleStyle = '' ;
            if ($bg_color != '') {
                $singleStyle .= ".dropfiles-single-file .dropfiles-file-link {
                    background-color: " . $bg_color . "  !important;
                }";
            } 
            if ($font_color != '') { 
                $singleStyle .= " .dropfiles-single-file .dropfiles-file-link a, .dropfiles-single-file
                    .dropfiles-file-link a .droptitle {
                     color: ". $font_color . "  !important;
                     text-decoration: none !important;
                }";
                $singleStyle .= " .dropfiles-single-file .dropfiles-file-link a:hover {
                     background:  none !important;
                }";
            }
        
            if ($hover_color != '') { 
                $singleStyle .= " .dropfiles-single-file .dropfiles-file-link a:hover, .dropfiles-single-file
                    .dropfiles-file-link a .droptitle:hover {
                    color:" .$hover_color. " !important;
                }" ;
            } 
            
            $doc->addStyleDeclaration($singleStyle);
            $doc->addScriptDeclaration('dropfilesBaseUrl="'.JURI::base().'";');
            return $result[0];
        }
        return '';
    }
    private function curSyncInterval(){

        //get last_log param
        $params = JComponentHelper::getParams('com_dropfiles');
        if($params->get('last_log') != null){
            $last_log=$params->get('last_log');
            $time_old=(int)strtotime($last_log);
        }
        else{
            $time_old=0;
        }

        $time_new=(int)strtotime(date('Y-m-d H:i:s'));
        $timeInterval=$time_new-$time_old;
        $curtime=$timeInterval/60;

        return $curtime;
    }

    private function curSyncIntervalDropbox(){

        //get last_log param
        $params = JComponentHelper::getParams('com_dropfiles');
        if($params->get('dropbox_last_log') != null){
            $last_log=$params->get('dropbox_last_log');
            $time_old=(int)strtotime($last_log);
        }
        else{
            $time_old=0;
        }

        $time_new=(int)strtotime(date('Y-m-d H:i:s'));
        $timeInterval=$time_new-$time_old;
        $curtime=$timeInterval/60;

        return $curtime;
    }

}
