<?php
/**
 * @version     1.0.0
 * @package     Dropfiles Links for JCE
 * @author      JoomUnited http://www.joomunited.com
 * @copyright   Copyright © 2015 JoomUnited. All rights reserved.
 * @license     GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

defined('_WF_EXT') or die('Restrict Access!');

class DropfileslinksDropfiles extends JObject
{
    public $_option = 'com_dropfiles';
    public $_task = 'getFiles';

    public function __construct()
    {
    }

    public function getInstance()
    {
        static $instance;

        if (!is_object($instance)) {
            $instance = new DropfileslinksDropfiles();
        }
        return $instance;
    }

    public function getOption()
    {
        return $this->_option;
    }

    public function getTask()
    {
        return $this->_task;
    }

    public function getList()
    {
        $advlink = WFEditorPlugin::getInstance();
        $list = '';
        if ($advlink->checkAccess('dropfileslinks.dropfiles', '1')) {
            $list  = '<li id="index.php?option=com_dropfiles&task=getFiles" class="folder nolink">';
            $list .= '<div class="uk-tree-row"><a href="Cannot insert category link!">';
            $list .=    '<span class="uk-tree-icon folder content nolink"></span>';
            $list .=    '<span class="uk-tree-text">' . JText::_('Dropfiles') . '</span>';
            $list .= '</a></div>';
            $list .= '</li>';
        }
        return $list;
    }

    public function _getItems($id_cat = null)
    {
        JLoader::register('DropfilesFilesHelper', JPATH_ADMINISTRATOR . '/components/com_dropfiles/helpers/files.php');
        if (!class_exists('DropfilesFilesHelper')) {
            // Throw error to users
            return array(
                array(
                    'class' => 'file error',
                    'name' => 'Error while loading files. Dropfiles not exist!',
                    'id' => 'Error!'
                )
            );
        }

        $dbo = JFactory::getDbo();
        // Get all child categories
        $query = 'SELECT id AS pid, title AS name FROM #__categories WHERE extension = "com_dropfiles" AND published = 1 AND parent_id = '.$id_cat.' ORDER BY lft';
        $dbo->setQuery($query);
        $items = $dbo->loadAssocList();

        foreach ($items as $key => $item) {
            $items[$key]['class'] = 'folder content nolink';
            $items[$key]['id']    = 'index.php?option=com_dropfiles&task=getFiles&id=' . $item['pid'];
        }

        // Return immediately if in root category coz no files here
        if ($id_cat == 1) return $items;

        // Get all child files
        $query = 'SELECT i.id AS aid, i.title, i.ext, i.catid , c.title AS cat_title FROM #__dropfiles_files AS i INNER JOIN #__categories AS c ON i.catid = c.id WHERE i.catid ='.$id_cat.' AND i.state = 1 ORDER BY i.ordering';
        $dbo->setQuery($query);
        $files = $dbo->loadAssocList();

        foreach ($files as $key => $file) {
            $files[$key]['name']  = $file['title'].'.'.$file['ext'];
            $files[$key]['class'] = 'file';
            $file_url             = DropfilesFilesHelper::genUrl($file['aid'], $file['catid'], $file['cat_title'], '',$file['text']);
            $files[$key]['id']    = $file_url;
        }

        // Append child files after child categories
        $items = array_merge($items, $files);

        return $items;
    }

    public function getLinks($args)
    {
        $id = isset($args->id) ? $args->id : 1;
        $items = $this->_getItems($id);

        return $items;
    }
}