<?php
/**
 * @version     1.0.0
 * @package     Dropfiles Links for JCE
 * @author      JoomUnited http://www.joomunited.com
 * @copyright   Copyright © 2015 JoomUnited. All rights reserved.
 * @license     GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

defined('_WF_EXT') or die('Restricted Access!');

class WFLinkBrowser_Dropfiles extends JObject
{
    var $_option = array();
    var $_adapters = array();

    public function __construct()
    {
        jimport('joomla.filesystem.folder');
        jimport('joomla.filesystem.file');

        $path = dirname(__FILE__).DS.'dropfileslinks';
        $files = JFolder::files($path, '\.(php)$');

        if (!empty($files)) {
            foreach ($files as $file) {
                require_once ($path. DS . $file);
                $classname = 'Dropfileslinks'.ucfirst(basename($file, '.php'));
                $this->_adapters[] = new $classname;
            }
        }
    }

    public function getInstance()
    {
        static $instance;

        if (!is_object($instance)) {
            $instance = new WFLinkBrowser_Dropfiles();
        }

        return $instance;
    }

    public function display()
    {

    }

    public function isEnabled()
    {
        $wf = WFEditorPlugin::getInstance();
        return $wf->checkAccess($wf->getName() . '.links.dropfileslinks', 1);
    }

    public function getOption()
    {
        foreach ($this->_adapters as $adapter)
        {
            $this->_option[] = $adapter->getOption();
        }
        return $this->_option;
    }

    public function getList()
    {
        $list = '';

        foreach ($this->_adapters as $adapter)
        {
            $list .= $adapter->getList();
        }
        return $list;
    }

    public function getLinks($args)
    {
        foreach ($this->_adapters as $adapter) {
            if ($adapter->getOption() == $args->option) {
                if (property_exists($args, 'task')) {
                    $task = $args->task;
                } else {
                    $task = 'getFiles';
                }

                if ($adapter->getTask() == $task) {
                    return $adapter->getLinks($args);
                }
            }
        }
    }
}