/** 
 * Dropfiles
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropfiles
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */
jQuery(document).ready(function($) {
    if(typeof(Dropfiles)=='undefined'){
        Dropfiles ={};
        Dropfiles.can = {};
        Dropfiles.can.create=false;
        Dropfiles.can.edit=false;
        Dropfiles.can.delete=false;
        Dropfiles.maxfilesize = 10;
        Dropfiles.selection = {};
    }
    /**
     * Click to Sync with Google Drive
     */
    $('#btn-sync-gg').click(function (e) {
        e.preventDefault();
        var $btn = $(this).html('Syncing');
        $(this).attr('disabled', true);
        $.ajax({
            url: 'index.php?option=com_dropfiles&task=googledrive.googlesync'
        }).done(function (data) {
            if (Dropfiles.indexgoogle) {
                $.ajax({
                    url     :   Dropfiles.ajaxurl + 'index.php?option=com_dropfiles&task=frontgoogle.index',
                    type    : 'POST',
                    data    :   {}
                }).done(function(data){
                    // business logic...
                    $btn.button('reset');
                    window.location.reload();
                });
            } else {
                // business logic...
                $btn.button('reset');
                window.location.reload();
            }

        });
    });
    /**
     * Click to Sync with Dropbox
     */
    $('#btn-sync-dropbox').click(function (e) {
        e.preventDefault();
        var $btn = $(this).html('Syncing');
        $(this).attr('disabled', true);
        $.ajax({
            url: 'index.php?option=com_dropfiles&task=dropbox.sync'
        }).done(function (data) {
            $.ajax({
                url     :   Dropfiles.ajaxurl + 'index.php?option=com_dropfiles&task=frontdropbox.index',
                type    : 'POST',
                data    :   {}
            }).done(function(data){
                window.location.reload();
            });
            // business logic...
            $btn.button('reset');
        });
    });
    /**
     * Left side panel show/hide
     */
    $('#df-panel-toggle').toggle(
        function (e) {
            e.preventDefault();
            $('#mycategories').animate({left:-305},300);
            if($('#mybootstrap').parent().prop('tagName') === 'DIV'){$('#pwrapper').css({'margin-left':0});}
            else{$('#pwrapper').css({'margin-left':12});}
            $('#df-panel-toggle span').css({'right':'-25px'}).removeClass('icon-arrow-left-2').addClass('icon-arrow-right-2');
        },
        function(e){
            e.preventDefault();
            if($('#mybootstrap').parent().prop('tagName') === 'DIV'){$('#mycategories').animate({left:20},300);}
            else{$('#mycategories').animate({left:0},300);}
            $('#pwrapper').css({'margin-left':320});
            $('#df-panel-toggle span').css({'right':'0px'}).removeClass('icon-arrow-right-2').addClass('icon-arrow-left-2');
        }
    );
    /**
     * Init sortable files 
     * Save order after each sort
     */
    if(Dropfiles.can.edit || (Dropfiles.can.editown && Dropfiles.author=== $('#categorieslist li.active').data('author'))){
        $('#preview').sortable({ 
            placeholder: 'highlight file',
            revert: 300,
            distance: 5,
            tolerance: "pointer",
            items: ".file",
            appendTo: "body",
            cursorAt: {top:0, left: 0 },
            helper : function(e,item){               
                filename = $(item).find('.title').text() + "." + $(item).find('.type').text();                      
                count = $('#preview').find('.file.selected').length; 
                if(count>1) {
                    return $( "<div id='file-handle' class='ui-widget-header' ><div>"+ filename + "</div><span class='fCount'>"+count+"</span></div>" );
                }else {
                    return $( "<div id='file-handle' class='ui-widget-header' ><div>"+ filename +"</div></div>" );
                }               
            },
            update : function(){
                var json='';
                id_category = jQuery('input[name=id_category]').val();
                $.each($('#preview .file'),function(i,val){
                    if(json!==''){
                        json+=',';
                    }
                    json+='"'+i+'":"'+$(val).data('id-file')+'"';
                });
                json = '{'+json+'}';
                $.ajax({
                    url     :   "index.php?option=com_dropfiles&task=files.reorder&idcat="+id_category,
                    type    :   "POST",
                    data    :  {order: json }
                });
            },
            /** Prevent firefox bug positionnement **/
            start: function (event, ui) {
                $(ui.helper).css('width','auto');
//                $(ui.helper).find('td').each(function(i,e){
//                    $(e).css('width',$('#preview .restable thead th:nth-child('+(i+1)+')').width());
//                });
                
                var userAgent = navigator.userAgent.toLowerCase();
                if( ui.helper !== "undefined" && userAgent.match(/firefox/) ){
                    ui.helper.css('position','absolute') ;
                }
                
                ui.placeholder.html("<td colspan='8'></td>");
                //ui.placeholder.height(ui.helper.height());
            },
            beforeStop: function (event, ui) {
                var userAgent = navigator.userAgent.toLowerCase();
                if( ui.offset !== "undefined" && userAgent.match(/firefox/) ){
                    ui.helper.css('margin-top', 0);
                }
            }
        });
    }
    $('#preview').disableSelection();
    
    /* init menu actions */
    initMenu();
    
    initThemeBtn();
    
    /* Load category */
//updatepreview();
    

    /* Load nestable */
    if(Dropfiles.can.edit || (Dropfiles.can.editown && Dropfiles.author=== $('#categorieslist li.active').data('author'))){
        $('.nested').nestable().on('change', function(event, e){
            var isCloudItem=$(e).find('a.t i.google-drive-icon').length;
            var isDropboxItem=$(e).find('a.t i.dropbox-icon').length;
            var itemChangeType='default';
            if(isCloudItem>0){
                itemChangeType='googledrive';
            } else if (isDropboxItem > 0) {
                itemChangeType = 'dropbox';
            }
            pk = $(e).data('id-category');
            if($(e).prev('li').length===0){
                position = 'first-child';
                if($(e).parents('li').length===0){
                    //root
                    ref = 0;
                }else{
                    ref = $(e).parents('li').data('id-category');
                }
            }else{
                position = 'after';
                ref = $(e).prev('li').data('id-category');
            }
            $.ajax({
                url     :   "index.php?option=com_dropfiles&task=categories.order&pk="+pk+"&position="+position+"&ref="+ref+"&dragType="+itemChangeType,
                type    :   "POST"
            }).done(function(data){
                result = jQuery.parseJSON(data);
                if(result.response===true){
    
                }else{
                    bootbox.alert(result.response);
                }
            });
        });
        if(Dropfiles.collapse===true){
            $('.nested').nestable('collapseAll');
        }
    }
    
    var ctrlDown = false;
    $(window).on("keydown", function(event) {
        if (event.which === 17) {
            ctrlDown = true;
        }
    }).on("keyup", function(event) {
        ctrlDown = false;
    });
    
    catDroppable = function() {
        $("#categorieslist li.dd-item > .dd-content").droppable({
            accept: '.file',
            hoverClass: "dd-content-hover",
            tolerance: "pointer",
            drop: function( event, ui ) {

                $(this).addClass( "ui-state-highlight" );
                cat_target = $(event.target).parent().data("id-category");                
                current_cat = $("#categorieslist .dd-item.active").data('id-category');                                                                           
                if (current_cat != cat_target) {
                    count = $('#preview').find('.file.selected').length;  
                    if(count>0) { //multiple file   
                        iFile = 0;                                            
                        $('#preview').find('.file.selected').each(function(){
                            id_file = $(this).data("id-file");
                            if (ctrlDown) { //copy file         
                                $.ajax({
                                    url: "index.php?option=com_dropfiles&task=files.copyfile&id_category=" + cat_target + '&active_category='+current_cat+'&id_file=' + id_file,
                                    type: "POST"
                                }).done(function (data) {     
                                    iFile++;
                                    if(iFile== count) {                           
                                        $.gritter.add({text:Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_FILES_COPIED', 'Files copied with success!')});
                                    }
                                });
                            }else {
                                $.ajax({
                                    url: "index.php?option=com_dropfiles&task=files.movefile&id_category=" + cat_target + '&active_category='+current_cat+'&id_file=' + id_file,
                                    type: "POST",
                                    dataType: "json",
                                }).done(function (result) {
                                    iFile++;                                      
                                    if(typeof result.datas.id_file  != "undefined") {
                                        $('tr[data-id-file="'+ result.datas.id_file +'"]').remove();    
                                    }
                                    if(iFile== count) {  
                                        $.gritter.add({text:Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_FILES_MOVED', 'Files moved with success!')});
                                    }
                                });
                            }
                        })
                    }
                    else {  //single file
                        id_file = $(ui.draggable).data("id-file");
                        if (ctrlDown) { //copy file         
                                $.ajax({
                                    url: "index.php?option=com_dropfiles&task=files.copyfile&id_category=" + cat_target + '&active_category='+current_cat+'&id_file=' + id_file,
                                    type: "POST"
                                }).done(function (data) {
                                    $.gritter.add({text:Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_FILE_COPIED', 'File copied with success!')});
                                });
                        }else {
                                $.ajax({
                                    url: "index.php?option=com_dropfiles&task=files.movefile&id_category=" + cat_target + '&active_category='+current_cat+'&id_file=' + id_file,
                                    type: "POST"
                                }).done(function (data) {
                                    $('tr[data-id-file="'+id_file+'"]').remove();                                    
                                    $.gritter.add({text:Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_FILE_MOVED', 'File moved with success!')});
                                });                                                                   
                        }
                    }                    
                }                
                $(this).removeClass( "ui-state-highlight" );   
            }
        });
    }   
    catDroppable();
    
     //override Joomla.submitbutton
    var oldJoomlaSubmition = Joomla.submitbutton;   
    var selectedFiles = [];
    var lastAction = '';
    var sourceCat = 0;    
    Joomla.submitbutton = function($task) {
        if($task == 'files.uncheck') {
            selectedFiles = [];
            $('.file').removeClass('selected');
            $('.dropfiles-btn-toolbar').hide();
            $('.dropfiles-number-files').remove();
            showCategory();
        }
        else if($task == 'files.delete') {
            bootbox.confirm(Joomla.JText._('COM_DROPFILES_JS_ARE_YOU_SURE', 'Are you sure') + '?', function (result) {
                if (result === true) {
                    sourceCat = $('#categorieslist li.active').data('id-category');
                    selectedFiles = [];
                    $('#preview .file.selected').each(function (index) {
                        selectedFiles.push($(this).data('id-file'));
                    })
                    cat_target = $('#categorieslist li.active').data('id-category');
                    if (cat_target == sourceCat) {
                        while (selectedFiles.length > 0) {
                            id_file = selectedFiles.pop();
                            $.ajax({
                                url: "index.php?option=com_dropfiles&task=files.delete&id_file=" + id_file + "&id_cat=" + sourceCat,
                                type: "POST"
                            }).done(function (data) {
                                result = jQuery.parseJSON(data);
                                if (result === true) {
                                    $('tr[data-id-file="' + id_file + '"]').fadeOut(500, function () {
                                        $(this).remove();
                                        $('.fileblock #fileparams').empty();
                                        updatepreview(cat_target);
                                        $.gritter.add({text: Joomla.JText._('COM_DROPFILES_JS_FILES_REMOVED', 'File(s) removed with success!')});
                                    });
                                } else {
                                    bootbox.alert(result.response);
                                }
                            });
                        }
                    }
                }
            });
            return false;
        }
        else if ($task == 'files.download') {
            $('#preview .file.selected').each(function (index) {
                var link = document.createElement("a");
                link.download = '';
                link.href = $(this).data('linkdownload');
                $('body').append(link);
                link.click();
                $(link).remove();
            });
        }
        else {
            oldJoomlaSubmition($task);
        }
        
    }
    
    //Check what is loaded via editor
    if(typeof(gcaninsert)!=='undefined' && gcaninsert===true){
        if(typeof(window.parent.tinyMCE)!=='undefined'){
            content = window.parent.tinyMCE.get(e_name).selection.getContent();
            imgparent = window.parent.tinyMCE.get(e_name).selection.getNode().parentNode;
            exp = '<img.*data\-dropfilesfile="([0-9a-zA-Z_]+)".*?>';
            file = content.match(exp);
            exp = '<img.*data\-dropfilescategory="([0-9]+)".*?>';
            category = content.match(exp);
            exp = '<img.*data\-dropfilesfilecategory="([0-9]+)".*?>';
            filecategory = content.match(exp);
            Dropfiles.selection = new Array();
            Dropfiles.selection.content = content;

            if(file!==null && filecategory!==null){
                if(file!==null){
                    elem = $(content).filter('img[data-dropfilesfile='+file[1]+']');
                    Dropfiles.selection.selection = elem;
                    Dropfiles.selection.file = file[1];
                }
                if(filecategory!==null){
                    Dropfiles.selection.category = filecategory[1];
                    $('#categorieslist li').removeClass('active');
                    $('#categorieslist li[data-id-category="'+filecategory[1]+'"]').addClass('active');
                    $('input[name=id_category]').val(filecategory[1]);
                    updatepreview(filecategory[1],file[1]);
                }
            }else if(category!==null){
                Dropfiles.selection.category = category[1];
                $('#categorieslist li').removeClass('active');
                $('#categorieslist li[data-id-category="'+category[1]+'"]').addClass('active');
                $('input[name=id_category]').val(category[1]);
                updatepreview(category[1]);
                loadGalleryParams();
            }else{
                updatepreview();
                loadGalleryParams();
            }
        }else if(typeof window.parent.CKEDITOR != 'undefined'){
            var ckEditor = window.parent.CKEDITOR.instances[e_name];  
            imgElement = ckEditor.getSelection().getSelectedElement();
            if(typeof imgElement != "undefined" && imgElement != null ) {
                file = imgElement.getAttribute('data-dropfilesfile');
                category = imgElement.getAttribute('data-dropfilescategory');
                filecategory = imgElement.getAttribute('data-dropfilesfilecategory');
                Dropfiles.selection = new Array();

                if(file!==null && filecategory!==null){
                    if(file!==null){
                        Dropfiles.selection.selection = imgElement;
                        Dropfiles.selection.file = file;
                    }
                    if(filecategory!==null){
                        Dropfiles.selection.category = filecategory;
                        $('#categorieslist li').removeClass('active');
                        $('#categorieslist li[data-id-category="'+filecategory+'"]').addClass('active');
                        $('input[name=id_category]').val(filecategory);
                        updatepreview(filecategory,file);
                    }
                }else if(category!==null){
                    Dropfiles.selection.category = category;
                    $('#categorieslist li').removeClass('active');
                    $('#categorieslist li[data-id-category="'+category+'"]').addClass('active');
                    $('input[name=id_category]').val(category);
                    updatepreview(category);
                    loadGalleryParams();
                }else{
                    updatepreview();
                    loadGalleryParams();
                }
            }else{
                updatepreview();
                loadGalleryParams();
            }
        }else{
            updatepreview();
            loadGalleryParams();
        }
    }else{
        /* Load gallery */
        updatepreview();
    }
    
    /* Init version dropbox */
    initDropboxVersion($('#fileversion'));
    $('#upload_button_version').on('click',function(){
        $('#upload_input_version').trigger('click');
        return false;
    });

    /* Init File import */
    if(Dropfiles.can.config){
        $('#jao').jaofiletree({ 
            script  : 'index.php?option=com_dropfiles&task=connector.listdir&tmpl=component',
            usecheckboxes : 'files',
            showroot : '/'
        });
    }
    $('#importFilesBtn').click(function(){
        id_category = $('input[name=id_category]').val();
        var files= '';
        $($('#jao').jaofiletree('getchecked')).each(function(){files+='&files[]='+this.file;});
        if(files===''){
            return;
        }
        $.ajax({
            url     :   "index.php?option=com_dropfiles&task=files.import&"+$('#categoryToken').attr('name') + "=1&id_category="+id_category,
            type    : 'GET',
            data    :   files
        }).done(function(data){
            result = jQuery.parseJSON(data);
            if(result.response===true){
                bootbox.alert(result.datas.nb+Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_X_FILES_IMPORTED', ' files imported'));
                updatepreview(id_category);
            }else{
                if(typeof(result.datas)!=='undefined' && result.datas=='noerror'){
                    
                }else{
                    bootbox.alert(result.response);
                }
            }
        });
        return false;
    });
    $('#selectAllImportFiles').click(function(){
        $('#filesimport input[type="checkbox"]').attr('checked', true);
    });
    $('#unselectAllImportFiles').click(function(){
        $('#filesimport input[type="checkbox"]').attr('checked', false);
    });
    

    function showCategory(){
        $('.fileblock').fadeOut();
        $('#insertfile').fadeOut();
        if( $('#filesimport').length >0 ) {
            $('.categoryblock').fadeIn();
        }else {
            $('#updateGroup').animate({'width' : '80%'});
            $('#rightcol').animate({'width' : '0'});
        }
    }

    function showFile(e){
        $('.categoryblock').fadeOut();
        $('.fileblock').fadeIn();
        $('#insertfile').fadeIn();
        $('#rightcol').animate({'width' : '300px'});
    }

    
    /**
     * Reload a category preview
     * @param id_category
     * @param id_file
     */
    function updatepreview(id_category,id_file,order,order_dir){
        $('#preview').contents().remove();
        if(typeof(id_category)==="undefined" || id_category===null){
                id_category = $('#categorieslist li.active').data('id-category');
            if(typeof(id_category)==='undefined'){
                $('#insertcategory').hide();
                return; 
            }
            $('input[name=id_category]').val(id_category);
        }else{
           // $('#preview')
        }
        loading('#wpreview');
        url = "index.php?option=com_dropfiles&view=files&format=raw&id_category="+id_category;
        if(typeof(order)==='string'){
            url = url + '&orderCol='+order;
        }        
        if(order_dir==='asc'){
            url = url + '&orderDir=desc';
        }else if(order_dir==='desc'){
            url = url + '&orderDir=asc';
        }
        $.ajax({
            url     :   url,
            type    :   "POST"
        }).done(function(data){
            $('#preview').html($(data));
            rloading('#wpreview');
            if(Dropfiles.can.edit || (Dropfiles.can.editown && Dropfiles.author=== $('#categorieslist li.active').data('author'))){
                var remote_file = (Dropfiles.addRemoteFile == 1) ? '<a href="" id="add_remote_file" class="btn btn-large btn-primary">'+Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_ADD_REMOTE_FILE', 'Add remote file')+'</a> ' : '';
                $('<div id="dropbox">'
                    + '<span class="message">'
                    +   Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_DROP_FILES_HERE', 'Drop files here to upload')
                    +   '.<i> '+Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_USE_UPLOAD_BUTTON', 'Or use the button below')+'</i>'
                    + '</span><input class="hide" type="file" id="upload_input" multiple="">'
                    + remote_file
                    + '<a href="" id="upload_button" class="btn btn-large btn-primary">'
                    +   Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_SELECT_FILES', 'Select files')
                    + '</a>'
                    + '</div><div class="clr">'
                    + '</div>')
                    .appendTo('#preview');

                $('#add_remote_file').on('click', function(e) {                  
                    e.preventDefault();                   
                    var allowed = Dropfiles.allowedext; 
                    allowed = allowed.split(','); 
                    allowed.sort();                      
                    var allowed_select = '<select id="dropfiles-remote-type">';
                    $.each(allowed, function(i,v) {
                        allowed_select += '<option value="'+v+'">' +v+ '</option>';
                    });
                    allowed_select += '</select>';
                    bootbox.dialog('<div class="form-horizontal dropfiles-remote-form"> ' +
                        '<div class="control-group"> ' +
                        '<label class=" control-label" for="dropfiles-remote-title">'+ Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_REMOTE_FILE_TITLE', 'title')+'</label> ' +
                        '<div class="controls"> ' +
                        '<input id="dropfiles-remote-title" name="dropfiles-remote-title" type="text" placeholder="'+Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_REMOTE_FILE_TITLE', 'title')+'" class=""> ' +
                        '</div> ' +
                        '</div> ' +
                        '<div class="control-group"> ' +
                        '<label class="control-label" for="dropfiles-remote-url">'+Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_REMOTE_FILE_REMOTE_URL', 'Remote URL')+'</label> ' +
                        '<div class="controls">'+
                        '<input id="dropfiles-remote-url" name="dropfiles-remote-url" type="text" placeholder="'+Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_REMOTE_FILE_URL', 'URL')+'" class=""> ' +
                        '</div> </div>' +
                        '<div class="control-group"> ' +
                        '<label class="control-label" for="dropfiles-remote-type">'+Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_REMOTE_FILE_TYPE', 'File Type')+'</label> ' +
                        '<div class="controls">'+
                        allowed_select +
                        '</div> </div>' +
                        '</div>',
                        [{
                            "label" : Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_SAVE', 'Save') ,
                            "class" : "btn-primary",
                            "callback": function() {
                                var category_id = $('input[name=id_category]').val();
                                var remote_title = $('#dropfiles-remote-title');
                                var remote_url = $('#dropfiles-remote-url');
                                var remote_type = $('#dropfiles-remote-type');
                                var ajax_url = "index.php?option=com_dropfiles&task=files.addremoteurl&id_category=" + category_id + '&remote_title=' + remote_title.val() +'&remote_url=' + remote_url.val() + '&remote_type=' + remote_type.val();

                                $.ajax({
                                    url: ajax_url,
                                    type: "POST"
                                }).done(function (data) {

                                    result = $.parseJSON(data);
                                    if (result.response === true) {
                                        updatepreview();
                                    } else {
                                        bootbox.alert(result.response);
                                    }
                                    $('.remote-dialog').remove();

                                });
                            }
                        }, {
                            "label" : Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_CANCEL', 'Cancel'),
                            "class" : "s",
                            "callback": function() {
                                $('.remote-dialog').remove();
                            }
                        }],
                        {
                            classes : 'remote-dialog'
                        }

                    );
                    return false;
                });
            }
            $('#preview .restable').restable({
                type : 'hideCols',
                priority : {0:'persistent' , 1: 'persistent', 2:'persistent'},
                hideColsDefault: [4, 5]
            });

            if(Dropfiles.can.edit || (Dropfiles.can.editown && Dropfiles.author=== $('#categorieslist li.active').data('author'))){
                if($('#preview .currentOrderingCol').data('ordering')==='ordering'){
                    $('#preview').sortable('enable');
                    $('#preview').sortable('refresh');
                }else{
                    $('#preview').sortable('disable');
                }

                $('#preview .file').each(function() {
                    $(this).append('<td class="hidden draghandle"></td>');
                });

                $('#preview').find('.file').draggable({
                    handle: '.draghandle',
                    appendTo: "body",
                    cursorAt: { left: 0, top: 0 },
                    helper: function( event ) {   
                        filename = $(this).find('.title').text() + "." + $(this).find('.type').text();
                        count = $('#preview').find('.file.selected').length; 
                        if(count>1) {
                            return $( "<div id='file-handle' class='ui-widget-header' ><div>"+ filename + "</div><span class='fCount'>"+count+"</span></div>" );
                        }else {
                            return $( "<div id='file-handle' class='ui-widget-header' ><div>"+ filename +"</div></div>" );
                        }
                    }
                });
            }

            if(Dropfiles.can.edit || (Dropfiles.can.editown && Dropfiles.author=== $('#categorieslist li.active').data('author'))){
                initUploadBtn();
            }
                        
            /** Init ordering **/
            $('#preview .restable thead a').click(function(e){
                e.preventDefault();
                updatepreview(null,null,$(this).data('ordering'),$(this).data('direction'));
                if($(this).data('direction')==='asc'){
                    direction = 'desc';
                }else{
                    direction = 'asc';
                }
                $('#jform_params_ordering option[value="'+$(this).data('ordering')+'"]').attr('selected','selected').parent().animate({'background-color':'#ACFFCD'});
                $('#jform_params_orderingdir option[value="'+direction+'"]').attr('selected','selected').parent().animate({'background-color':'#ACFFCD'});
            });
            
            /** Init files **/
            $(document).unbind('click.window').bind('click.window',function(e){
                
                if($(e.target).is('#rightcol') || 
                    $(e.target).parents('#rightcol').length>0 ||
                    $(e.target).parents('#rightcol').length>0 || 
                    $(e.target).is('.modal-backdrop') || 
                    $(e.target).parents('.bootbox.modal').length>0 ||
                    $(e.target).parents('.mce-container').length>0 ||
                    $(e.target).parents('.tagit-autocomplete').length>0 ||
                    $(e.target).parents('#toolbar-copy').length> 0 ||
                    $(e.target).parents('#toolbar-scissors').length> 0 ||
                    $(e.target).parents('.ui-datepicker-header').length> 0 ||
                    $(e.target).parents('.calendar').length> 0
                    ){
                    return;
                }
                if ($(e.target).is('#dropfiles-delete')) return;

                $('#preview .file').removeClass('selected');
                $('.dropfiles-btn-toolbar').hide();
                showCategory();
            });        

            $('#preview .file').unbind('click').click(function(e){
               iselected = $(this).find('tr.selected').length;
                         
                    //Allow multiselect
                    if (!e.ctrlKey){
                        $('#preview .file.selected').removeClass('selected');
                    }
               if(iselected===0){
                    $(this).addClass('selected');
               }

               if($('#preview .file.selected').length==1){
                   if(Dropfiles.can.edit || (Dropfiles.can.editown && Dropfiles.author=== $('#categorieslist li.active').data('author'))){
                        loadFileParams();
                        loadVersions();
                    }                    
                   showFile(this);
                   $('.dropfiles-btn-toolbar').show();
               }else{
                    showCategory();
               }
               e.stopPropagation();
            });

            
            
            $('#wpreview').unbind();
            initDropbox($('#wpreview'));

            theme = $('input[name=theme]').val();
            $('#themeselect .themebtn').removeClass('selected');
            $('#themeselect a[data-theme='+theme+']').addClass('selected');

            if(typeof(id_file)!=="undefined" && id_file!==null){
                $('#preview .file[data-id-file='+id_file+']').trigger('click');
            }else{
                showCategory();
                if(typeof(order)==='undefined'){
                    loadGalleryParams();
                }
            }

            rloading('#wpreview');
        });
        initEditBtn();
    }
     
    /**
     * Init the file edit btn
     */
    function initEditBtn(){
        $('.wbtn a.edit').unbind('click').click(function(e){  
            that = this;
            id_file = $(that).parents('.wimg').find('img.img').data('id-file');
            $.ajax({
                url     :   "index.php?option=com_dropfiles&view=file&format=raw&id="+id_file,
                type    :   "POST"
            }).done(function(data){
                bootbox.dialog(data,[{'label':Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_SAVE', 'Save'),'class':'btn-success','callback':function(){
                    var p = '';
                    $('#file-form .dropfilesinput').each(function(index){
                        p = p + $(this).attr('name')+ '=' + $(this).attr('value') + '&';
                    });
                    $.ajax({
                            url     :   $('#file-form').attr('action'),
                            type    :   'POST',
                            data    :   p
                    }).done(function(data){

                    });
                }},{'label':Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_CANCEL', 'Cancel'),'class':'btn-warning'}],{header:Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_IMAGE_PARAMETERS', 'Image parameters')});

            });
            return false;
        });
    }


    function loadGalleryParams(){
        if(!Dropfiles.can.edit && !(Dropfiles.can.editown && Dropfiles.author=== $('#categorieslist li.active').data('author'))){
            return;
        }
        id_category = $('input[name=id_category]').val();
        showCategory();
        loading('#galleryparams');
        
        $.ajax({
            url     :   "index.php?option=com_dropfiles&task=category.edit&layout=form&id="+id_category
        }).done(function(data){
            $('#galleryparams').html(data);
            $('.minicolors').minicolors();
            if($('#galleryparams .field-user-wrapper').length>0 ) {
                $('#galleryparams .field-user-wrapper').fieldUser();
                $('#galleryparams .user-clear').click(function(e){ 
                    e.preventDefault(); 
                    $('#jform_params_canview').val('');  
                    $('#jform_params_canview_id').val('');  
                })
            }
            $('#jform_params_usergroup').chosen();
            if(Dropfiles.categoryrestriction == 'accesslevel') {
                $('#jform_params_usergroup').parent().hide();
                $('#jform_params_usergroup-lbl').hide();
            } else {
                $('#jform_access').parent().hide();
                $('#jform_access-lbl').hide();
            }

            $('#galleryparams .dropfilesparams button[type="submit"]').click(function(e){
                e.preventDefault();
                id_category = $('input[name=id_category]').val();
                $.ajax({
                    url     :   "index.php?option=com_dropfiles&task=category.setparams&id="+id_category,
                    type    :   "POST",
                    data    :    $('.dropfilesparams').serialize()
                }).done(function(data){

                    result = jQuery.parseJSON(data);
                    if(result.response===true){
                        $.gritter.add({text:Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_SAVED', 'Saved')});
                        updatepreview();                        
                    }else{
                        bootbox.alert(result.response);
                    }

                });                
                return false;
            });
            rloading('#galleryparams');
        });
    }

    function initThemeBtn(){
        $('#themeselect .themebtn').on('click', function(e){
            e.preventDefault();
            id_category = $('input[name=id_category]').val();
            theme = $(this).data('theme');
            $.ajax({
                url     :   'index.php?option=com_dropfiles&task=config.setTheme&theme='+theme+'&id='+id_category,
                type    :   'POST'
            }).done(function(data){
                $('.themesblock #themeselect .themebtn').removeClass('selected');
                $('.themesblock #themeselect a[data-theme='+theme+']').addClass('selected');
                result = jQuery.parseJSON(data);
                if(result===true){
                    loadGalleryParams();
                }
            });
        });
    }

    function loadFileParams(){
        id_category = $('input[name=id_category]').val();
        id_file = jQuery('.file.selected').data('id-file');
        is_remoteurl = jQuery('.file.selected').hasClass('is-remote-url');
        loading('#rightcol');
        
        $.ajax({
            url     :   "index.php?option=com_dropfiles&task=file.edit&layout=form&id="+id_file+"&catid="+id_category
        }).done(function(data){
            $('#fileparams').html(data);      
            if( $('#fileparams .field-user-wrapper').length>0) {
                $('#fileparams .field-user-wrapper').fieldUser();
                $('#fileparams .user-clear').click(function(e){ 
                    e.preventDefault();                 
                    $('#jform_canview').val('');  $('#jform_canview_id').val('');                  
                } )
            }
            if (is_remoteurl) {
                $('.dropfilesparams').find('.dropfiles-hide').removeClass('dropfiles-hide');
            }

            $('#jform_params_usergroup').chosen();
            if(typeof(JoomlaCalendar) != "undefined") { //joomla version>= 3.7
                elements = document.querySelectorAll(".field-calendar");
                for (i = 0; i < elements.length; i++) {
                    JoomlaCalendar.init(elements[i]);
                }
            } else {
                Calendar.setup({
                    // Id of the input field
                    inputField: "jform_created_time",
                    // Format of the input field
                    ifFormat: "%Y-%m-%d %H:%M:%S",
                    // Trigger for the calendar (button ID)
                    button: "jform_created_time_img",
                    // Alignment (defaults to "Bl")
                    align: "Tl",
                    cache: true,
                    singleClick: true
                });
                Calendar.setup({
                    // Id of the input field
                    inputField: "jform_modified_time",
                    // Format of the input field
                    ifFormat: "%Y-%m-%d %H:%M:%S",
                    // Trigger for the calendar (button ID)
                    button: "jform_modified_time_img",
                    // Alignment (defaults to "Bl")
                    align: "Tl",
                    cache: true,
                    singleClick: true
                });
                Calendar.setup({
                    // Id of the input field
                    inputField: "jform_publish",
                    // Format of the input field
                    ifFormat: "%Y-%m-%d %H:%M:%S",
                    // Trigger for the calendar (button ID)
                    button: "jform_publish_img",
                    // Alignment (defaults to "Bl")
                    align: "Tl",
                    cache: true,
                    singleClick: true
                });

                Calendar.setup({
                    // Id of the input field
                    inputField: "jform_publish_down",
                    // Format of the input field
                    ifFormat: "%Y-%m-%d %H:%M:%S",
                    // Trigger for the calendar (button ID)
                    button: "jform_publish_down_img",
                    // Alignment (defaults to "Bl")
                    align: "Tl",
                    cache: true,
                    singleClick: true
                });
            }

            // Turn radios into btn-group
            $('.radio.btn-group label').addClass('btn');
            $('.btn-group label:not(.active)').click(function()
            {
                var label = $(this);
                var input = $('#' + label.attr('for'));

                if (!input.prop('checked')) {
                    label.closest('.btn-group').find('label').removeClass('active btn-success btn-danger btn-primary');
                    input.prop('checked', true);
                    if(input.val()==0) {
                        label.addClass('active btn-danger');
                    }else {
                        label.addClass('active btn-success');
                    }                    
                    
                    input.trigger('change');
                }
            });
            $('.btn-group input[checked=checked]').each(function()
            {
                if( $(this).val() == 0) {
                  $('label[for=' + $(this).attr('id') + ']').addClass('active btn-danger');  
                }else {
                  $('label[for=' + $(this).attr('id') + ']').addClass('active btn-success');  
                }
                  
            });

            $(".googleblock").find('#jform_created_time').parent().parent().hide();
            $(".googleblock").find('label[for="jform_created_time"]').hide();

            $(".googleblock").find('#jform_modified_time').parent().parent().hide();
            $(".googleblock").find('label[for="jform_modified_time"]').hide();



           // SqueezeBox.initialize(SqueezeBox_options);
            if(typeof(SqueezeBox)!=='undefined'){
                SqueezeBox.assign($('.paraminput a.modal').get(), {
                    parse: 'rel'
                });
            };

            $('#fileparams .dropfilesparams button[type="submit"]').click(function(e){
                e.preventDefault();
                id_file = jQuery('.file.selected').data('id-file');
                id_category = $('input[name=id_category]').val();

                $.ajax({
                    url     :   "index.php?option=com_dropfiles&task=file.save&id="+id_file+"&catid="+id_category,
                    type    :   "POST",
                    data    :   $('.dropfilesparams').serialize()
                }).done(function(data){
                    result = jQuery.parseJSON(data);
                    if(result.response===true){
                        $.gritter.add({text:Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_SAVED', 'Saved')});
                        //loadFileParams();
                    }else{
                        bootbox.alert(result.response);
                    }
                    loadFileParams();
                    updatepreview(null,id_file);
                });                
                return false;
            });
            rloading('#rightcol');
        });
    }

    function loadVersions(){
        id_category = $('input[name=id_category]').val();
        id_file = jQuery('.file.selected').data('id-file');
        loading('#fileversion');
        $.ajax({
            url     :   "index.php?option=com_dropfiles&view=files&layout=versions&format=raw&id_file="+id_file+"&id_category="+id_category
        }).done(function(data){
            $('#versions_content').html(data);
            $('#versions_content a.trash').click(function(){
                that = this;
                bootbox.confirm(Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_ARE_YOU_SURE', 'Are you sure')+'?',function(result){
                    if(result===true){
                        id = $(that).data('id');
                        vid = $(that).data('vid');
                        $.ajax({
                            url     :   "index.php?option=com_dropfiles&task=file.deleteVersion&vid="+vid+"&id="+id+"&id_file="+id_file+"&catid="+id_category,
                            type    :   "POST"
                        }).done(function(data){
                            result = jQuery.parseJSON(data);
                            if(result.response===true){
                                $(that).parents('tr').remove();
                            }else{
                                bootbox.alert(result.response);
                            }
                        });
                    }
                });
                return false;
            });

            $('#versions_content a.restore').click(function(e){
                e.preventDefault();
                that = this;
                file_ext = jQuery('.file.selected .txt').text();
                file_title = jQuery('.file.selected .title').text();
                bootbox.confirm(Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_ARE_YOU_SURE_RESTORE_FILE', 'Are you sure you want to restore this file by a previous version?') ,function(result){
                    if(result===true){
                        vid = $(that).data('vid');
                        id = $(that).data('id');
                        catid = $(that).data('catid');
                        $.ajax({
                            url     :  "index.php?option=com_dropfiles&task=file.restoreVersion&id="+id+"&vid="+vid+"&id_file="+id_file+"&catid="+id_category,
                            type    :   "POST"
                        }).done(function(data){
                            result = jQuery.parseJSON(data);
                            if(result.response===true){
                                $(that).parents('tr').remove();
                                id_file = jQuery('.file.selected').data('id-file');
                                updatepreview(null,id_file);

                            }else{
                                bootbox.alert(result.response);
                            }

                        });
                    }
                });

                return false;
            });

            rloading('#fileversion');
        });
    }

    function initUploadBtn(){
        
        $('#upload_button').on('click',function(e){
            e.preventDefault();
            
            $('#upload_input').trigger('click');
            return false;
        });
    }

    /**
     * Click on new category btn
     */

    $('.btn-index-google').on('click', function(e) {
        e.preventDefault();
        var $this = $(this);
        $this.attr('disabled', true);
        $this.html('Indexing Google Drive');
        $.ajax({
            url     :   $(this).attr('href'),
            type    : 'POST',
            data    :   {}
        }).done(function(data){
            $this.attr('disabled', false);
            $this.html('Index Google Drive');
        })
    });
    /**
     * Init the dropbox 
     **/    
    function initDropbox(dropbox){
        dropbox.filedrop({
                paramname:'pic',
                fallback_id:'upload_input',
                maxfiles: 30,
                maxfilesize:  Dropfiles.maxfilesize,
                queuefiles: 2,
                data: {
                    id_category : function(){
                        return $('input[name=id_category]').val(); 
                    }
                },
                url: 'index.php?option=com_dropfiles&task=files.upload',

                uploadFinished:function(i,file,response){
                    if(typeof(response)==='string'){
                            bootbox.alert('<div>'+response+'</div>');
                    }
                    if(response.response===true){
                        $.data(file).addClass('done');
                        $.data(file).find('img').data('id-file', response.datas.id_file);
                    }else{
                        bootbox.alert(response.response);
                        $.data(file).remove();
                    }
                },

                error: function(err, file) {
                        switch(err) {
                                case 'BrowserNotSupported':
                                        if(files !== undefined ) {
                                            bootbox.alert(Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_BROWSER_NOT_SUPPORT_HTML5', 'Your browser does not support HTML5 file uploads!'));
                                        }
                                        break;
                                case 'TooManyFiles':
                                        bootbox.alert(Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_TOO_ANY_FILES','Too many files')+'!');
                                        break;
                                case 'FileTooLarge':
                                        bootbox.alert(file.name+' '+Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_FILE_TOO_LARGE', 'is too large')+'!');
                                        break;
                                default:
                                        break;
                        }
                },

                // Called before each upload is started
                beforeEach: function(file){
                },

                uploadStarted:function(i, file, len){

                    var preview = $('<div class="file uploadplaceholder">'+
                        '<span class="uploaded"></span>'+
                        '<div class="progress progress-striped active">'+
                        '<div class="bar"></div>'+
                        '</div>'+
                        '</div>');
                        var reader = new FileReader();

                        $('#preview .restable').after(preview);
                        $('.hide-list-files').append(preview);
                        $.data(file,preview);
                },

                progressUpdated: function(i, file, progress) {
                        $.data(file).find('.progress .bar').width(progress+'%');
                },
                
                afterAll: function(){
                    $('#preview .progress').delay(300).fadeIn(300).hide(300, function(){
                      $(this).remove();
                    });
                    $('#preview .uploaded').delay(300).fadeIn(300).hide(300, function(){
                      $(this).remove();
                    });
                    $('#preview .file').delay(1200).show(1200,function(){
                        $(this).removeClass('done placeholder');
                    });
                    updatepreview();
                },
                rename : function(name){
                    function fetchAscii(obj){
                            var convertedObj = '';
                            for(i = 0; i < obj.length; i++)
                            { 
                                  var asciiChar = obj.charCodeAt(i);
                                  convertedObj += '&#' + asciiChar + ';';
                            } 
                            return convertedObj;
                    }
                    return fetchAscii(name);
                }
        });
    }

    /**
     * Init the dropbox 
     **/    
    function initDropboxVersion(dropbox){
        dropbox.filedrop({
                paramname:'pic',
                fallback_id:'upload_input_version',
                maxfiles: 1,
                maxfilesize: Dropfiles.maxfilesize,
                queuefiles: 1,
                data: {
                    id_file : function(){
                        return $('.file.selected').data('id-file');
                    },
                    id_category : function(){
                        return $('input[name=id_category]').val();
                    },
                    ext : function(){
                        return $('.file.selected').find('.type').html();
                    }
                },
                url: 'index.php?option=com_dropfiles&task=files.version',

                uploadFinished:function(i,file,response){

                    if(response.response===true){
                    
                    }else{
                        bootbox.alert(response.response);
                        $('#dropbox_version .progress').addClass('hide');
                        $('#dropbox_version .upload').removeClass('hide');
                    }
                },

                error: function(err, file) {

                        switch(err) {
                                case 'BrowserNotSupported':
                                        if(files !== undefined ) {
                                            bootbox.alert(Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_BROWSER_NOT_SUPPORT_HTML5', 'Your browser does not support HTML5 file uploads!'));
                                        }
                                        break;
                                case 'TooManyFiles':
                                        bootbox.alert(Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_TOO_ANY_FILES','Too many files')+'!');
                                        break;
                                case 'FileTooLarge':
                                        bootbox.alert(file.name+' '+Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_FILE_TOO_LARGE', 'is too large')+'!');
                                        break;
                                default:
                                        break;
                        }
                },

                // Called before each upload is started
                beforeEach: function(file){

                },

                uploadStarted:function(i, file, len){
                    $('#dropbox_version .upload').addClass('hide');
                    $('#dropbox_version .progress').removeClass('hide');
                },

                progressUpdated: function(i, file, progress) {
                    $('#dropbox_version .progress .bar').width(progress+'%');
                },
                
                afterAll: function(){
                    $('#dropbox_version .progress').addClass('hide');
                    $('#dropbox_version .upload').removeClass('hide');
                    id_file = $('.file.selected').data('id-file');
                    updatepreview(null,id_file);
                },
                rename : function(name){
                    ext = name.substr(name.lastIndexOf('.'),name.length);
                    name = name.substr(0, name.lastIndexOf('.'));
                    var pattern_accent = new Array("é", "è", "ê", "ë", "ç", "à", "â", "ä", "î", "ï", "ù", "ô", "ó", "ö"); 
                    var pattern_replace_accent = new Array("e", "e", "e", "e", "c", "a", "a", "a", "i", "i", "u", "o", "o", "o");
                    name = preg_replace (pattern_accent, pattern_replace_accent,name);
                    
                    name = name.replace(/\s+/gi, '-');
                    name = name.replace(/[^a-zA-Z0-9\-]/gi, '');                    
                    return name+ext;
                }
        });
    }

    
        /* Title edition */
    function initMenu(){
        /**
        * Click on delete category btn
        */
       $('#categorieslist .dd-content .trash').unbind('click').on('click',function(){
           id_category = $(this).closest('li').data('id-category');
           bootbox.confirm(Joomla.JText._('COM_DROPEDITOR_DROPFILES_JS_WANT_DELETE_CATEGORY','Do you really want to delete "')+$(this).parent().find('.title').text()+'"?', function(result) {
               if(result===true){
                   $.ajax({
                       url     :   "index.php?option=com_dropfiles&task=categories.delete&id_category="+id_category,
                       type    :   'POST',
                       data    :   $('#categoryToken').attr('name') + '=1'
                   }).done(function(data){
                       result = jQuery.parseJSON(data);
                       if(result.response===true){
                           $('#mycategories #categorieslist li[data-id-category='+id_category+']').remove();
                           $('#preview').contents().remove();
                           first = $('#mycategories #categorieslist li dd-content').first();
                           if(first.length>0){
                               first.click();
                           }else{
                               $('#insertcategory').hide();
                           }
                       }else{
                           bootbox.alert(result.response);
                       }
                   });
               }
           });
           return false;
       });
       
        /* Set the active category on menu click */
        $('#categorieslist .dd-content').unbind('click').click(function(e){
            id_category = $(this).parent().data('id-category');
            $('input[name=id_category]').val(id_category);

            $('#categorieslist li').removeClass('active');
            $(this).parent().addClass('active');
            if ($(this).parent().find('.google-drive-icon').length > 0) {
                $('#rightcol .fileblock').addClass('googleblock');
                $('#rightcol .categoryblock').addClass('catgoogleblock');
            } else {
                $('#rightcol .fileblock').removeClass('googleblock');
                $('#rightcol .categoryblock').removeClass('catgoogleblock');
            }
            updatepreview(id_category);
            return false;
        });
        
        $('#categorieslist .dd-content a.edit').unbind().click(function(e){
            e.stopPropagation();
            $this = this;
            link = $(this).parent().find('a span.title');
            oldTitle = link.text();
            $(link).attr('contentEditable',true);
            $(link).addClass('editable');
            $(link).selectText();

            $('#categorieslist a span.editable').bind('click.mm',hstop);  //let's click on the editable object
            $(link).bind('keypress.mm',hpress); //let's press enter to validate new title'
            $('*').not($(link)).bind('click.mm',houtside);

            function unbindall(){
                $('#categorieslist a span').unbind('click.mm',hstop);  //let's click on the editable object
                $(link).unbind('keypress.mm',hpress); //let's press enter to validate new title'
                $('*').not($(link)).unbind('click.mm',houtside);
            }

            //Validation       
            function hstop(event){
                event.stopPropagation();
                return false;
            }

            //Press enter
            function hpress(e){
                if ( e.which == 13 ) {
                    e.preventDefault();
                    unbindall();
                    updateTitle($(link).text());
                    $(link).removeAttr('contentEditable');
                    $(link).removeClass('editable');
                }
            }

            //click outside
            function houtside(e){
                unbindall();
                updateTitle($(link).text());
                $(link).removeAttr('contentEditable');
                $(link).removeClass('editable');
            }


            function updateTitle(title){
                id_category = $(link).parents('li').data('id-category');
                if(title!==''){
                    $.ajax({
                        url     :   "index.php?option=com_dropfiles&task=category.setTitle&id_category="+id_category+'&title='+ encodeURIComponent(title),
                        type    :   "POST"
                    }).done(function(data){
                        result = jQuery.parseJSON(data);
                        if(result===true){
                            return true;
                        }
                        $(link).text(oldTitle);
                        return false;
                    });
                }else{
                    $(link).text(oldTitle);
                    return false;
                }
                $(link).parent().css('white-space','normal');
                setTimeout(function(){
                    $(link).parent().css('white-space','');
                  }, 200);

            }
        });
    }
    
    (function(){
        $('#patchHtaccess').click(function(){
            $.ajax({
                url :   'index.php?option=com_dropfiles&view=patch&tmpl=component&format=raw'
            }).done(function(data){
                bootbox.alert(data);
            });
        });
    })();
    
    function loading(e){
        $(e).addClass('dploadingcontainer');
        $(e).append('<div class="dploading"></div>');
    }
    function rloading(e){
        $(e).removeClass('dploadingcontainer');
        $(e).find('div.dploading').remove();
    }

    function setCookie(cname, cvalue) {
        var d = new Date();
        d.setTime(d.getTime() + (30*(60*60*24*1000))); // set cookie time to 30 days
        var expires = "expires="+ d.toUTCString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    }
    $('.updateHideBtn').click(function () {
        $('#updateGroup').hide(300);
        setCookie('dropfiles_hide_update', 1)
    })

});

/**
* Insert the current category into a content editor
*/
function insertCategory(){
    id_category = jQuery('input[name=id_category]').val();
    dir = decodeURIComponent(getUrlVar('path'));
    code = '<img src="'+dir+'/components/com_dropfiles/assets/images/t.gif"'+
                'data-dropfilescategory="'+id_category+'"'+
                'style="background: url('+dir+'/components/com_dropfiles/assets/images/folder_download.png) no-repeat scroll center center #D6D6D6;'+
                'border: 2px dashed #888888;'+
                'height: 200px;'+
                'border-radius: 10px;'+
                'width: 99%;" data-category="'+id_category+'" />';
    return code;
}

/**
* Insert the current file into a content editor
*/
function insertFile(){
    id_file = jQuery('.file.selected').data('id-file');
    id_category = jQuery('input[name=id_category]').val();
    dir = decodeURIComponent(getUrlVar('path'));
    code = '<img src="'+dir+'/components/com_dropfiles/assets/images/t.gif"'+
                'data-dropfilesfile="'+id_file+'"'+
                'data-dropfilesfilecategory="'+id_category+'"'+
                'style="background: url('+dir+'/components/com_dropfiles/assets/images/file_download.png) no-repeat scroll center center #444444;'+
                'height: 100px;'+
                'border-radius: 10px;'+
                'width: 99%;" data-file="'+id_file+'" />';
    return code;
}

//From http://jquery-howto.blogspot.fr/2009/09/get-url-parameters-values-with-jquery.html
function getUrlVars()
{
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}

function getUrlVar(v){
    if(typeof(getUrlVars()[v])!=="undefined"){
        return getUrlVars()[v];
    }
    return null;
}

function preg_replace (array_pattern, array_pattern_replace, my_string) {var new_string = String (my_string);for (i=0; i<array_pattern.length; i++) {var reg_exp= RegExp(array_pattern[i], "gi");var val_to_replace = array_pattern_replace[i];new_string = new_string.replace (reg_exp, val_to_replace);}return new_string;}

//https://gist.github.com/ncr/399624
jQuery.fn.single_double_click = function(single_click_callback, double_click_callback, timeout) {
  return this.each(function(){
    var clicks = 0, self = this;
    jQuery(this).click(function(event){
      clicks++;
      if (clicks == 1) {
        setTimeout(function(){
          if(clicks == 1) {
            single_click_callback.call(self, event);
          } else {
            double_click_callback.call(self, event);
          }
          clicks = 0;
        }, timeout || 300);
      }
    });
  });
}


function jInsertFieldValue(value, id) {
    var $ = jQuery.noConflict();
    var old_value = $("#" + id).val();
    if (old_value != value) {
        var $elem = $("#" + id);
        $elem.val(value);
        $elem.trigger("change");
        if (typeof($elem.get(0).onchange) === "function") {
            $elem.get(0).onchange();
        }
        jMediaRefreshPreview(id);
    }
}

function jMediaRefreshPreview(id) {
    var $ = jQuery.noConflict();
    var value = $("#" + id).val();
    var $img = $("#" + id + "_preview");
    var basepath = $("#" + id).data("basepath");

    if ($img.length) {
        if (value) {
            $img.attr("src", basepath + value);
            $("#" + id + "_preview_empty").hide();
            $("#" + id + "_preview_img").show()
        } else {
            $img.attr("src", "");
            $("#" + id + "_preview_empty").show();
            $("#" + id + "_preview_img").hide();
        }
    }
}

function jModalClose() {
    SqueezeBox.close();
}