<?php
/** 
 * Dropfiles
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropfiles
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

//-- No direct access
defined('_JEXEC') || die('=;)');


jimport('joomla.application.component.controller');
jimport( 'joomla.filesystem.file' );

class dropfilesControllerFrontfile extends JControllerLegacy
{
    public function getModel($name = 'frontfile', $prefix = 'dropfilesModel', $config = array('ignore_request' => true))
    {
            $model = parent::getModel($name, $prefix, $config);

            return $model;
    }


    public function download(){
        $model = $this->getModel('frontfile');
        
        $id = JFactory::getApplication()->input->getString('id', 0);
        $catid = JFactory::getApplication()->input->getInt('catid', 0);
        
        $catmod = $this->getModel('frontcategory');
        
        $category = $catmod->getCategory($catid);
        $user	= JFactory::getUser();
        $groups	= $user->getAuthorisedViewLevels();

        $config = JComponentHelper::getParams('com_dropfiles');
        if ($config->get('categoryrestriction', 'accesslevel') == 'accesslevel') {
            if (!in_array($category->access, $groups)) {
                $token = JRequest::getString('token');
                $modelTokens =  $this->getModel('tokens');
                $modelTokens->removeTokens();
                $tokenId = $modelTokens->tokenExists($token);
                if($tokenId){
                    $modelTokens->updateToken($tokenId);
                }else{
                    $this->setRedirect('index.php',JText::_('JERROR_ALERTNOAUTHOR'));
                    $this->redirect();
                }
            }
        } else {
            $modelConfig = $this->getModel('frontconfig');
            $params = $modelConfig->getParams($catid);
            $usergroup = isset($params->params->usergroup) ? $params->params->usergroup : array();
            $user	= JFactory::getUser();
            $result=array_intersect($user->getAuthorisedGroups(),$usergroup);

            if (!count($result)){
                $token = JRequest::getString('token');
                $modelTokens =  $this->getModel('tokens');
                $modelTokens->removeTokens();
                $tokenId = $modelTokens->tokenExists($token);
                if($tokenId){
                    $modelTokens->updateToken($tokenId);
                }else{
                    $this->setRedirect('index.php',JText::_('JERROR_ALERTNOAUTHOR'));
                    $this->redirect();
                }
            }

        }


        $author_user_id = 0;
        $file = array();
        switch ($category->type) {
            case 'googledrive':
                JLoader::register('DropfilesGoogle', JPATH_ADMINISTRATOR.'/components/com_dropfiles/classes/dropfilesGoogle.php');
                $google = new dropfilesGoogle();
                $preview = JFactory::getApplication()->input->getString('preview', 0);
                $file = $google->download($id,$category->cloud_id, null, $preview);

                if(!is_object($file)){
                    $this->setRedirect('index.php');
                    $this->redirect();
                }
                
                //$google->incrHits($id);
                $modelGoogle = $this->getModel('Frontgoogle');
                $modelGoogle->incrHits($id);                
                $model->addCountChart($id);

                $file2 = $modelGoogle->getFile( $id ) ;
                if($file2) {
                    $author_user_id = $file2->author;
                }

                header('Content-Disposition: attachment; filename="'.htmlspecialchars($file->title.'.'.$file->ext).'"');
                header('Content-Description: File Transfer');
                header('Content-Type: application/octet-stream');
                header('Content-Transfer-Encoding: binary');
                header('Expires: 0');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');
                if($file->size !=0){header('Content-Length: ' . $file->size);}
                ob_clean();
                flush();
                echo $file->datas;

                break;
            case 'dropbox':
                JLoader::register('DropfilesDropbox', JPATH_ADMINISTRATOR.'/components/com_dropfiles/classes/dropfilesDropbox.php');
                JLoader::register('DropfilesFilesHelper', JPATH_ADMINISTRATOR.'/components/com_dropfiles/helpers/files.php');

                $dropCate = new dropfilesDropbox();
                $rev = JFactory::getApplication()->input->getString('vid', '');
                if ($rev != '') {
                    $dropCate->downloadVersion($id, $rev);
                } else {
                    list($file,$fMeta) = $dropCate->downloadDropbox($id);
                    $ext = strtolower(pathinfo($fMeta['path_lower'], PATHINFO_EXTENSION));

                    $preview = JFactory::getApplication()->input->getString('preview', 0);
                    if ($preview) {
                        $contenType = DropfilesFilesHelper::mime_type($ext);
                    } else {
                        $contenType = 'application/octet-stream';
                    }

                    $modelDropbox = $this->getModel('Frontdropbox');
                    $modelDropbox->incrHits($id);
                    $model->addCountChart($id);

                    $file2 = $modelDropbox->getFile( $id ) ;
                    if($file2) {
                        $author_user_id = $file2->author;
                    }

                    @ob_end_clean();
                    ob_start();
                    header('Content-Disposition: attachment; filename="' . $fMeta['name'] . '"');
                    header('Content-Description: File Transfer');
                    header('Content-Type: ' . $contenType);
                    header('Content-Transfer-Encoding: binary');
                    header('Expires: 0');
                    header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                    header('Pragma: public');

                    header('Content-Length: ' . (int)$fMeta['size']);
                    ob_clean();
                    flush();
                    readfile($file);
                    unlink($file);

                }

                break;
            default:
                $file = $model->getFile($id);
                if(!$file){
                    $this->setRedirect('index.php');
                    $this->redirect();
                }
                $model->hit($id);
                $model->addCountChart($id);

                $modelFiles =  $this->getModel('frontfile');
                $file2 = $modelFiles->getFile( $id) ;
                if($file2) {
                    $author_user_id = $file2->author;
                }

                if($file->id){
                    if (strpos($file->file, 'http') !== false) {
                        header('Location: ' . $file->file);
                    } else {
                        $preview = JFactory::getApplication()->input->getString('preview', 0);
                        if($preview) {
                            JLoader::register('DropfilesFilesHelper', JPATH_ADMINISTRATOR.'/components/com_dropfiles/helpers/files.php');
                            $contenType = DropfilesFilesHelper::mime_type($file->ext);
                        }else {
                            $contenType = 'application/octet-stream';
                        }
                        JLoader::register('DropfilesBase', JPATH_ADMINISTRATOR.'/components/com_dropfiles/classes/dropfilesBase.php');
                        $sysfile = dropfilesBase::getFilesPath($file->catid).'/'.$file->file;
                        if(file_exists($sysfile)) {

                            if ($config->get('open_pdf_in', 0) == 1 && $file->ext == 'pdf' && $preview == 1) {
                                header('Content-Disposition: inline; filename="'.htmlspecialchars($file->title.'.'.$file->ext).'"');
                            } else {
                                header('Content-Disposition: attachment; filename="'.htmlspecialchars($file->title.'.'.$file->ext).'"');
                            }

                            header('Content-Description: File Transfer');
                            header('Content-Type: '.$contenType);
                            header('Content-Transfer-Encoding: binary');
                            header('Expires: 0');
                            header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                            header('Pragma: public');
                            header('Content-Length: ' . filesize($sysfile));
                            ob_clean();

                            $params = JComponentHelper::getParams('com_dropfiles');
                            if($params->get('readfiletype',0)==0){
                                flush();
                                readfile($sysfile);
                            }else{
                                ob_end_flush();
                                $handle = fopen($sysfile, "rb");
                                while (!feof($handle)) {
                                    echo fread($handle, 1000);
                                }
                            }

                        }
                    }

                }
                break;
        }




        $params = JComponentHelper::getParams('com_dropfiles');

        $email_title = JText::_('COM_DROPEDITOR_DROPFILES_EMAIL_DOWNLOAD_EVENT_TITLE');

        if ($params->get('download_event_subject', '') != '') {
            $email_title = $params->get('download_event_subject', '');
        }

        $email_body = $params->get('download_event_editor', DropfilesHelper::getHTMLEmail('file-downloaded.html'));
        $email_body = str_replace('components/com_dropfiles/assets/images/icon-download.png', JUri::root().'components/com_dropfiles/assets/images/icon-download.png', $email_body);
        $email_body = str_replace('{category}', $category->title, $email_body);
        $email_body = str_replace('{website_url}', JUri::root(), $email_body);
        $email_body = str_replace('{file_name}', $file->title, $email_body);

        if ($params->get('file_owner', 0) == 1 && $params->get('download_event', 0) == 1) {
            $user = JFactory::getUser($author_user_id);
            $email_body = str_replace('{username}', $user->name, $email_body);
            DropfilesHelper::sendMail($user->email,$email_title, $email_body);
        }

        if ($params->get('category_owner', 0) == 1 && $params->get('download_event', 0) == 1) {
            $user = JFactory::getUser($category->created_user_id);
            $email_body = str_replace('{username}', $user->name, $email_body);
            DropfilesHelper::sendMail($user->email,$email_title, $email_body);
        }

        if ($params->get('download_event_additional_email', '') != '' && $params->get('download_event', 0) == 1) {
            DropfilesHelper::sendMail($params->get('download_event_additional_email', ''),$email_title, $email_body);
        }

        if ($params->get('download_event_additional_email', '') != '' && $params->get('download_event', 1) == 1) {
            $emails = explode(',', $params->get('download_event_additional_email', ''));
            if (!empty($emails)) {
                foreach ($emails as $email) {
                    DropfilesHelper::sendMail($email,$email_title, $email_body);
                }
            }
        }

        if ($params->get('notify_super_admin', 0) == 1 && $params->get('download_event', 0) == 1) {
            $users = DropfilesHelper::getSuperAdmins();

            if (count($users)) {
                foreach ($users as $item) {

                    $user = JFactory::getUser($item->user_id);
                    $email_body = str_replace('{username}', $user->name, $email_body);
                    DropfilesHelper::sendMail($user->email,$email_title, $email_body);

                }
            }
        }


        jexit();
    }


    public function getSubs() {
        $modelCats = JModelLegacy::getInstance('Frontcategories','dropfilesModel');        
        $catid = JFactory::getApplication()->input->getInt('id', 0);

        $modelCats->setState('category.id',$catid);
        //$modelCats->setState('filter.parentId',$catid);

        $cats = $modelCats->getItems(true);

        if(count($cats)) {
            foreach ($cats as $cat) {
                $cat->count_child = $modelCats->getSubCategoriesCount($cat->id);
            }
        }
        echo json_encode($cats);
        die();
    }
}