<?php
/**
 * Dropfiles
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropfiles
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// no direct access
defined('_JEXEC') or die;

jimport('joomla.access.access');


class DropfilesModelFrontfile extends JModelLegacy
{

    /**
     * Methode to retrieve file
     * @param int $id_file
     * @return object file, false if an error occurs
     */
    public function getFile($id)
    {
        $dbo = $this->getDbo();
        $query = $dbo->getQuery(true);
        $query->select('*');
        $query->from('#__dropfiles_files');

        $query->where('id=' . (int)$id);
        // Filter by publish dates.
        $nullDate = $dbo->quote($dbo->getNullDate());
        $date = JFactory::getDate();

        $nowDate = $dbo->quote($date->toSql());

        $query->where('(publish = ' . $nullDate . ' OR publish <= ' . $nowDate . ')');
        $query->where('(publish_down = ' . $nullDate . ' OR publish_down >= ' . $nowDate . ')');
        $query->where('state = 1');
        $dbo->setQuery($query);

        if (!$dbo->query()) {
            return false;
        }
        return $dbo->loadObject();
    }

    public function hit($id)
    {
        $dbo = $this->getDbo();
        $query = 'UPDATE #__dropfiles_files SET hits=(hits+1) WHERE id=' . (int)$id;

        $dbo->setQuery($query);

        if (!$dbo->query()) {
            return false;
        }
        return true;
    }

    /**
     * Add a record to db
     * @param $file_id
     * @param $date
     *
     * @return bool|mixed
     *
     * @since version
     */
    public function addChart($file_id, $date)
    {
        $dbo = $this->getDbo();
        $query = 'INSERT INTO #__dropfiles_statistics (related_id,type,date,count) VALUES (' . $dbo->quote($file_id) . ',"default","' . $date . '",1)';
        $dbo->setQuery($query);
        if ($dbo->query()) {
            return $dbo->insertid();
        }
        return false;
    }

    /**
     * Add count chart for file
     * @param $file_id
     *
     * @return bool
     *
     * @since version
     */
    public function addCountChart($file_id)
    {
        $date = date("Y-m-d");
        $dbo = $this->getDbo();
        $querycheck = 'SELECT * FROM #__dropfiles_statistics WHERE related_id=' . $dbo->quote($file_id) . ' AND date=' . $dbo->quote($date) . '';
        $dbo->setQuery($querycheck);
        $object = $dbo->loadObject();

        if ($object) {
            $query = 'UPDATE #__dropfiles_statistics SET count=(count+1) WHERE related_id=' . $dbo->quote($file_id) . ' AND date=' . $dbo->quote($date) . '';
            $dbo->setQuery($query);

            if (!$dbo->query()) {
                return false;
            }
        } else {
            $this->addChart($file_id, $date);
        }
        return true;
    }
}