<?php
/** 
 * Dropfiles
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropfiles
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// No direct access.
defined('_JEXEC') or die;

JHtml::_('behavior.keepalive');
JHtml::_('behavior.framework');
JHtml::_('behavior.colorpicker');
JHtml::_('behavior.framework');
JHtml::_('behavior.calendar');
jimport('joomla.application.component.helper');
JHtml::_('script', 'jui/chosen.jquery.min.js', false, true, false, false);
JHtml::_('stylesheet', 'jui/chosen.css', false, true);

$function	= JRequest::getCmd('function', 'jInsertCategory');

JText::script('COM_DROPEDITOR_DROPFILES_JS_DROP_FILES_HERE');
JText::script('COM_DROPEDITOR_DROPFILES_JS_DROP_FILES_HERE');
JText::script('COM_DROPEDITOR_DROPFILES_JS_USE_UPLOAD_BUTTON');
JText::script('COM_DROPEDITOR_DROPFILES_JS_USE_UPLOAD_BUTTON');
JText::script('COM_DROPEDITOR_DROPFILES_JS_ADD_REMOTE_FILE');
JText::script('COM_DROPEDITOR_DROPFILES_JS_ARE_YOU_SURE');
JText::script('COM_DROPEDITOR_DROPFILES_JS_DELETE');
JText::script('COM_DROPEDITOR_DROPFILES_JS_EDIT');
JText::script('COM_DROPEDITOR_DROPFILES_JS_BROWSER_NOT_SUPPORT_HTML5');
JText::script('COM_DROPEDITOR_DROPFILES_JS_TOO_ANY_FILES');
JText::script('COM_DROPEDITOR_DROPFILES_JS_FILE_TOO_LARGE');
JText::script('COM_DROPEDITOR_DROPFILES_JS_ONLY_IMAGE_ALLOWED');
JText::script('COM_DROPEDITOR_DROPFILES_JS_DBLCLICK_TO_EDIT_TITLE');
JText::script('COM_DROPEDITOR_DROPFILES_JS_WANT_DELETE_CATEGORY');
JText::script('COM_DROPEDITOR_DROPFILES_JS_SELECT_FILES');
JText::script('COM_DROPEDITOR_DROPFILES_JS_IMAGE_PARAMETERS');
JText::script('COM_DROPEDITOR_DROPFILES_JS_CANCEL');
JText::script('COM_DROPEDITOR_DROPFILES_JS_OK');
JText::script('COM_DROPEDITOR_DROPFILES_JS_CONFIRM');
JText::script('COM_DROPEDITOR_DROPFILES_JS_SAVE');
JText::script('COM_DROPEDITOR_DROPFILES_JS_X_FILES_IMPORTED');
JText::script('COM_DROPEDITOR_DROPFILES_JS_WAIT_UPLOADING');
JText::script('COM_DROPEDITOR_DROPFILES_JS_FILE_MOVED');
JText::script('COM_DROPEDITOR_DROPFILES_JS_FILE_COPIED');
JText::script('COM_DROPEDITOR_DROPFILES_JS_FILES_MOVED');
JText::script('COM_DROPEDITOR_DROPFILES_JS_FILES_COPIED');
JText::script('COM_DROPEDITOR_DROPFILES_JS_NO_FILES_SELETED');
JText::script('COM_DROPEDITOR_DROPFILES_JS_NO_FILES_COPIED_CUT');
JText::script('COM_DROPEDITOR_DROPFILES_DEFAULT_FRONT_COLUMNS');
JText::script('COM_DROPEDITOR_DROPFILES_JS_REMOTE_FILE_TITLE');
JText::script('COM_DROPEDITOR_DROPFILES_JS_REMOTE_FILE_URL');
JText::script('COM_DROPEDITOR_DROPFILES_JS_REMOTE_FILE_REMOTE_URL');
JText::script('COM_DROPEDITOR_DROPFILES_JS_REMOTE_FILE_TYPE');
JText::script('COM_DROPEDITOR_DROPFILES_JS_SAVED');

$params = JComponentHelper::getParams('com_dropfiles');
$doc = JFactory::getDocument();
$doc->addScript(JURI::root().'components/com_dropfiles/assets/js/fielduser.min.js');
$doc->addScriptDeclaration('gcaninsert='.(JRequest::getBool('caninsert',false)?'true':'false').';');
$doc->addScriptDeclaration('e_name="'.JRequest::getString('e_name').'";');

$collapse = DropfilesBase::getParam('catcollapsed',0);
$declaration = 
            "if(typeof(Dropfiles)=='undefined'){"
          . "     Dropfiles={};"
          . "}"
          . "Dropfiles.can = {};"
          . "Dropfiles.can.config=".(int)$this->canDo->get('core.admin').";"
          . "Dropfiles.can.edit=".(int)$this->canDo->get('core.edit').";"
          . "Dropfiles.can.editown=".(int)$this->canDo->get('core.edit.own').";"
          . "Dropfiles.can.delete=".(int)$this->canDo->get('core.delete').";"
		  . "Dropfiles.author=".(int)JFactory::getUser()->id.";"
          . "Dropfiles.collapse=".($collapse?'true':'false').";"
          . "Dropfiles.version='".dropfilesComponentHelper::getVersion()."';"
          . "Dropfiles.maxfilesize = ".$params->get('maxinputfile',10).";"
          . "Dropfiles.addRemoteFile = ".(int)$params->get('addremotefile',0).";"
          . "Dropfiles.indexgoogle = ".(int)$params->get('indexgoogle',1).";"
          . "Dropfiles.ajaxurl = '".JUri::root()."';"
          . "Dropfiles.categoryrestriction = '".$params->get('categoryrestriction', 'accesslevel')."';"
          . "Dropfiles.allowedext = '".$params->get('allowedext','7z,ace,bz2,dmg,gz,rar,tgz,zip,csv,doc,docx,html,key,keynote,odp,ods,odt,pages,pdf,pps,ppt,pptx,rtf,tex,txt,xls,xlsx,xml,bmp,exif,gif,ico,jpeg,jpg,png,psd,tif,tiff,aac,aif,aiff,alac,amr,au,cdda,flac,m3u,m4a,m4p,mid,mp3,mp4,mpa,ogg,pac,ra,wav,wma,3gp,asf,avi,flv,m4v,mkv,mov,mpeg,mpg,rm,swf,vob,wmv')."';";

$doc->addScriptDeclaration($declaration);
?>
<div id="mybootstrap"class="<?php if(dropfilesBase::isJoomla30()) echo 'joomla30'; ?> <?php if(dropfilesBase::isJoomla25()) echo 'joomla25'; ?>">
    <?php echo $this->loadTemplate('cats'); ?>
    
    <div id="pwrapper">
        <div id="wpreview">
            <div class="dropfiles-btn-toolbar" id="dropfiles-toolbar">
                <div class="btn-wrapper">
                    <button onclick="Joomla.submitbutton('files.delete')" class="btn btn-small" id="dropfiles-delete">
                        <span class="icon-trash"></span>
                        <?php echo JText::_('COM_DROPEDITOR_DROPFILES_DELETE_FILES'); ?></button>
                </div>
                <div class="btn-wrapper">
                    <button onclick="Joomla.submitbutton('files.download')" class="btn btn-small"
                            id="dropfiles-download">
                        <span class="icon-download"></span>
                        <?php echo JText::_('COM_DROPEDITOR_DROPFILES_DOWNLOAD_FILES'); ?></button>
                </div>
                <div class="btn-wrapper">
                    <button onclick="Joomla.submitbutton('files.uncheck')" class="btn btn-small" id="dropfiles-uncheck">
                        <span class="icon-remove"></span>
                        <?php echo JText::_('COM_DROPEDITOR_DROPFILES_UNCHECK'); ?></button>
                </div>
            </div>
            <div id="preview"></div>
        </div>
        <input type="hidden" name="id_category" value="" />

        <?php if (!isset($_COOKIE['dropfiles_hide_update'])) : ?>
            <div id="updateGroup" class="col-xs-12">
                <div id="updateInfo">
                    <p style="text-transform: uppercase; font-weight: bold"><?php echo JText::_('COM_DROPEDITOR_DROPFILES_CTRL_UPDATE_TITLE') ?></p>
                    <p id="updateDesc"><?php echo JText::_('COM_DROPEDITOR_DROPFILES_CTRL_UPDATE_DESC') ?></p>
                </div>
                <button type="button" class="notice-dismiss updateHideBtn"></button>
                <a class="updateBtn" href="https://www.joomunited.com/products/dropfiles" target="_blank" title="<?php echo JText::_('COM_DROPEDITOR_DROPFILES_CTRL_UPDATE_TITLE') ?>"><?php echo JText::_('COM_DROPEDITOR_DROPFILES_CTRL_UPDATE_MORE') ?></a>
                <a class="updateBtn updateHideBtn" href="#" onclick="return false" title="<?php echo JText::_('COM_DROPEDITOR_DROPFILES_CTRL_UPDATE_HIDE') ?>"><?php echo JText::_('COM_DROPEDITOR_DROPFILES_CTRL_UPDATE_HIDE') ?></a>
            </div>
        <?php endif; ?>
    </div>

    <div id="rightcol" class="">
        <?php if(JRequest::getBool('caninsert')): ?>
            <a id="insertfile" class="btn btn-flat-active" style="display: none;" href="" onclick="if (window.parent) {window.parent.jInsertEditorText(insertFile(),'<?php echo JFactory::getApplication()->input->getVar('e_name');?>');window.parent.SqueezeBox.close();}"><?php echo JText::_('COM_DROPEDITOR_DROPFILES_LAYOUT_DROPFILES_INSERT_FILE'); ?></a>
        <?php endif; ?>

        <div>
            <div class="categoryblock" style="display: none">
                <?php if($this->importFiles && $this->canDo->get('core.admin')): ?>
                    <div class="well">
                        <h4><?php echo JText::_('COM_DROPEDITOR_DROPFILES_LAYOUT_DROPFILES_IMPORT'); ?></h4>
                        <div id="filesimport">
                            <div id="jao"></div>
                            <div class="center">
                                <button class="btn btn-mini" id="selectAllImportFiles" type="button">Select all</button>
                                <button class="btn btn-large" id="importFilesBtn" type="button"><?php echo JText::_('COM_DROPEDITOR_DROPFILES_LAYOUT_DROPFILES_IMPORT_BTN'); ?></button>
                                <button class="btn btn-mini" id="unselectAllImportFiles" type="button">Unselect all</button>
                            </div>
                        </div>
                    </div>
                <?php endif; ?>
            </div>
            <?php if($this->canDo->get('core.edit') || $this->canDo->get('core.edit.own')): ?>
            <div class="fileblock" style="display: none;">


                <div class="well">
                    <h4><?php echo JText::_('COM_DROPEDITOR_DROPFILES_LAYOUT_DROPFILES_PARAMETERS'); ?></h4>
                    <div id="fileparams">

                    </div>
                </div>

            </div>
            <?php endif; ?>
        </div>
    </div>
</div>
<form id="adminDropfiles" name="adminDropfiles">
    <?php
    $f_modified_time = $this->fieldSet['jform_modified_time'] ;
    echo  '<div style="display: none">'.$f_modified_time->renderField().'</div>';
    ?>
</form>