<?php
/**
 * Dropfiles
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropfiles
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') or die;


class DropfilesViewFiles extends JViewLegacy
{

	protected $state;

	/**
	 * Display the view
	 */
	public function display($tpl = null){
            $modelCategory = JModelLegacy::getInstance('Category','dropfilesModel');

            if(JRequest::getCmd('layout')=='form'){
                $this->form = $modelCategory->getForm();
            }elseif(JRequest::getCmd('layout')=='versions'){
                $category_id = JFactory::getApplication()->input->getInt('id_category', 0);
                $file_id = JFactory::getApplication()->input->getString('id_file', 0);
                $model = $this->getModel();

                $category = $modelCategory->getCategory($category_id);

                if(!$category){
                    return '';
                }

                if($category->type=='googledrive'){
                    $google = new dropfilesGoogle();
                    $files = $google->listVersions($file_id);
                }elseif($category->type == 'dropbox') {
                    $dropbox = new dropfilesDropbox();
                    $files = $dropbox->displayDropboxVersionInfo($file_id);
                }else{
                    $files = $model->getVersions($file_id);
                }
                $content = '';
                if(!empty($files)){

                    $content .= '<table>';
                    foreach ($files as $file) {
                        $content .= '<tr>';
                        $rev = '';
                        if($category->type=='dropbox'){
                            $version = '1';
                            $data_id = $file->id;
                            $rev = $file->meta_id;
                        }else if ($category->type == 'googledrive'){
                            $version = $file->id_version;
                            $data_id = $file->id_version;
                            $rev = '';
                        }else{
                            $version = '1';
                            $data_id = $file->id;
                            $rev = '';
                        }
                        $content .= '<td><a title="'. date("H:i:s",strtotime($file->created_time)) .'" href="index.php?option=com_dropfiles&task=file.download&version='.$version.'&vid='.$rev.'&id='.$data_id.'&catid='.$category_id.'" target="_blank">';
                        $content .= date("Y M d",strtotime($file->created_time)).' ';
                        $content .= '</a></td>';
                        $content .= '<td>'.DropfilesFilesHelper::bytesToSize($file->size).'</td>';

                            $content .= '<td><a data-id="'.$data_id.'" data-vid="'.$rev.'" href="#" class="restore"><i class="icon-restore"></i></a></td>';
                            $content .= '<td><a data-id="'.$data_id.'" data-vid="'.$rev.'" href="#" class="trash"><i class="icon-trash"></i></a></td>';

                        $content .= '</tr>';
                    }
                    $content .= '</table>';

                }
                echo $content;
            }else{
                $category_id = JFactory::getApplication()->input->getInt('id_category', 0);
                $model = $this->getModel();

                $modelConfig = JModelLegacy::getInstance('Config','dropfilesModel');
                $category = $modelCategory->getCategory($category_id);
                $params = $modelConfig->getParams($category->id);
                if(!$params){
                    $params = new stdClass();
                    $params->ordering = 'ordering';
                    $params->orderingdir = 'asc';
                }
                if($category->type=='googledrive'){
                    $google = new dropfilesGoogle();

                    $ordering = JFactory::getApplication()->input->getCmd('orderCol',$params->ordering);
                    if($ordering!==null){
                        if(!in_array($ordering, array('ordering','ext','title','description','created_time','size','version','hits'))){
                            $ordering = 'ordering';
                        }else{
                            $direction = JFactory::getApplication()->input->getCmd('orderDir',$params->orderingdir);
                            if($direction!=='desc'){
                                $direction = 'asc';
                            }
                        }
                    }else{
                        $ordering = 'ordering';
                    }
                    $modelGoogle = JModelLegacy::getInstance('Googlefiles','dropfilesModel') ;
                    $files = $modelGoogle->getItems($category->cloud_id,$ordering, $direction);
                    //$files = $google->listFiles($category->cloud_id,$ordering,$direction);
                    if($files===false){
                        echo '<div class="alert alert-danger">'.$google->getLastError().'</div>';
                        return '';
                    }
                }elseif ($category->type=='dropbox') {

                    $ordering = JFactory::getApplication()->input->getCmd('orderCol',$params->ordering);
                    if($ordering!==null){
                        if(!in_array($ordering, array('ordering','ext','title','description','created_time','size','version','hits'))){
                            $ordering = 'ordering';
                        }else{
                            $direction = JFactory::getApplication()->input->getCmd('orderDir',$params->orderingdir);
                            if($direction!=='desc'){
                                $direction = 'asc';
                            }
                        }
                    }else{
                        $ordering = 'ordering';
                    }
                    $modelDropbox = JModelLegacy::getInstance('frontdropbox','dropfilesModel') ;
                    $files = $modelDropbox->getItems($category->cloud_id,$ordering, $direction);

                } else{
                    $files = $model->getItems();
                    $ordering = $model->getState('list.ordering',false);
                    $direction = $model->getState('list.direction',false);
                }
                $theme = $modelCategory->getCategoryTheme(JFactory::getApplication()->input->getInt('id_category', 0));

                $canDo = DropfilesHelper::getActions();
                if($canDo->get('core.edit') || $canDo->get('core.edit.own')){
                    $canOrder = true;
                }else{
                    $canOrder = false;
                }

                $content = '<table class="restable">';
                $content .= '<thead><tr>';
                foreach (   array(
                                'ordering' => array('#',''),
                                'title'=>array(JText::_('COM_DROPEDITOR_DROPFILES_FIELD_FILE_TITLE_LABEL'),'essential'),
                                'size'=>array(JText::_('COM_DROPEDITOR_DROPFILES_FIELD_FILE_FILESIZE_LABEL'),''),
                                'created_time'=> array(JText::_('COM_DROPEDITOR_DROPFILES_FIELD_FILE_DATEADDED_LABEL'),''),
                                'version'=>array(JText::_('COM_DROPEDITOR_DROPFILES_FIELD_FILE_VERSION_LABEL'),''),
                                'hits' => array(JText::_('COM_DROPEDITOR_DROPFILES_FIELD_HITS_LABEL'),'')
                            )
                        as $row => $title)
                {
                    $content .= '<th class="'.$title[1].'">';
                    if($canOrder){
                        $content .= '<a href="#" class="'.($ordering===$row?'currentOrderingCol':'').'" data-ordering="'.$row.'" data-direction="'.$direction.'">';
                    }
                    $content .= $title[0];

                    if($row===$ordering){
                        $icon = 'icon-arrow-'.($direction==='asc'?'up':'down');
                        if(dropfilesBase::isJoomla30()){
                            $icon .= '-3';
                        }
                        $content .= ' <i class="'.$icon.'"></i>';
                    }

                    if($canOrder){
                        $content .= '</a>';
                    }
                    $content .= '</th>';
                }
                $content .= '</tr></thead>';
                $content .= '<tbody>';

                if(dropfilesBase::isJoomla25()){
                    $iconOrder = 'icon-move';
                }else{
                    $iconOrder = 'icon-menu';
                }
                foreach ($files as $file){
                    $httpcheck = isset($file->file) ? $file->file : '';
                    $remote_file = preg_match("(http://|https://)", $httpcheck) ? 'is-remote-url' : '';
                    $unpublish = $file->state == 0 ? 'dropfiles-unpublished' : '';
                    $link_download = 'index.php?option=com_dropfiles&task=file.download&id=' . $file->id;
                    $link_download .= '&catid=' . (isset($file->catid) ? $file->catid : $category->id);

                    $content .= '<tr class="file '.$remote_file.' '.$unpublish.'" data-id-file="'.$file->id.'" data-linkdownload="' . $link_download . '" >';
                        $content .=     '<td class="type">';
                        $content .=         $file->ext;
                        $content .=     '</td>';
                        $content .=     '<td class="title">';
                        $content .=         $file->title;
                        $content .=     '</td>';
                        $content .=     '<td class="size">';
                        if($file->size>0){
                        $content .=         DropfilesFilesHelper::bytesToSize($file->size);
                    } else{
                        $content .='unknown';
                        }
                        $content .=     '</td>';
                        $content .=     '<td class="created">';
                        $date =             new JDate($file->created_time);
                        $content .=         $date->format('Y-m-d');
                        $content .=     '</td>';
                        $content .=     '<td class="version">';
                        $content .=         $file->version;
                        $content .=     '</td>';
                        $content .=     '<td class="hits">';
                        $content .=         $file->hits.' '.JText::_('COM_DROPEDITOR_DROPFILES_LAYOUT_DROPFILES_HITS');
                        $content .=     '</td>';
                        $content .= '</tr>';
                }
                $content .= '</tbody>';
                $content .= '</table>';
                $content .= '<input type="hidden" name="theme" value="'.strtolower($theme).'">';
                echo $content;
            }
//            parent::display($tpl);
	}
}
