/**
 * @license Copyright (c) 2003-2015, CKSource - Frederico Knabben. All rights reserved.
 * For licensing, see LICENSE.md or http://ckeditor.com/license
 */

CKEDITOR.dialog.add('bgcolorbutton', function (editor) {
    var config = editor.config;
    var dialog, picker, pickerContents,
        lang = editor.lang.colorbutton,
        // Actual UI color value.
        uiColor = editor.getUiColor(),
        pickerId = 'cke_uicolor_picker' + CKEDITOR.tools.getNextNumber();

    function setNewUiColor(color) {
        if (color) {
            var font_type = jQuery('input[name="color_type_radio"]:checked').val();
            editor.removeStyle(new CKEDITOR.style(config[ 'colorButton_backStyle' ], {color: 'inherit'}));
            var colorStyle = config[ 'colorButton_backStyle' ];
            colorStyle.childRule = function (element) {
                return !(element.is('a') || element.getElementsByTag('a').count()) || isUnstylable(element);
            };

            editor.applyStyle(new CKEDITOR.style(colorStyle, {color: color}));
        }

        editor.fire('saveSnapshot');
    }

    function isUnstylable(ele) {
        return (ele.getAttribute('contentEditable') == 'false') || ele.getAttribute('data-nostyle');
    }

    var height_dialog = 200;
    var html = '<input type="text" id="hue-bgfont_gminicolors" class="form-control bgfont_gminicolors" data-control="hue" value="#555555">';
    html+= '<span class="input-group-btn">';
    html+= '<button class="btn_action btn_remove_color bgcolor_btn_remove" type="button">' + lang.defaultColorTitle + '</button>';
    html+= '<button class="btn_action btn_apply bgcolor_btn_apply" type="button">' + lang.apply + '</button>';
    html+='</span>';

    pickerContents = {
        id: 'yuiColorPicker',
        type: 'html',
        html: html,
        onLoad: function () {
            jQuery('.bgfont_gminicolors').each(function () {
                jQuery(this).gminicolors({
                    control: jQuery(this).attr('data-control') || 'hue',
                    defaultValue: jQuery(this).attr('data-defaultValue') || '',
                    format: jQuery(this).attr('data-format') || 'hex',
                    keywords: jQuery(this).attr('data-keywords') || '',
                    inline: jQuery(this).attr('data-inline') === 'true',
                    letterCase: jQuery(this).attr('data-letterCase') || 'lowercase',
                    opacity: jQuery(this).attr('data-opacity'),
                    position: jQuery(this).attr('data-position') || 'bottom left',
                    change: function (value, opacity) {
                        if (!value)
                            return;
                    },
                    theme: 'bootstrap'
                });
            });


            jQuery('.bgcolor_btn_apply').on('click',function(){
                setNewUiColor(jQuery('.bgfont_gminicolors.gminicolors-input').val());
                CKEDITOR.dialog.getCurrent().hide()
            });

            jQuery('.bgcolor_btn_remove').on('click',function(){
                editor.removeStyle(new CKEDITOR.style(config[ 'colorButton_backStyle' ], {color: 'inherit'}));
                CKEDITOR.dialog.getCurrent().hide()
            });
        }
    };

    return {
        title: lang.bgColorTitle,
        minWidth: 310,
        minHeight: height_dialog,
        onLoad: function () {
            dialog = this;
            this.setupContent();
            // #3808
            if (CKEDITOR.env.ie7Compat)
                dialog.parts.contents.setStyle('overflow', 'hidden');
        },
        contents: [{
            id: 'tab1',
            label: '',
            title: '',
            expand: false,
            padding: 0,
            elements: [
                pickerContents,
                {
                    id: 'tab1',
                    type: 'vbox',
                    children: []
                }
            ]
        }],
        buttons : false
//                buttons: [CKEDITOR.dialog.okButton]

    };
});
