/**
 * @license Copyright (c) 2003-2015, CKSource - Frederico Knabben. All rights reserved.
 * For licensing, see LICENSE.md or http://ckeditor.com/license
 */

CKEDITOR.dialog.add('colorbutton', function (editor) {
    var config = editor.config;
    var dialog, picker, pickerContents,
        // Actual UI color value.
        uiColor = editor.getUiColor(),
        pickerId = 'cke_uicolor_picker' + CKEDITOR.tools.getNextNumber();
    var lang = editor.lang.colorbutton;
    console.log(lang);
    function setNewUiColor(color) {
        if (color) {
            var font_type = jQuery('input[name="color_type_radio"]:checked').val();
            editor.removeStyle(new CKEDITOR.style(config[ 'colorButton_foreStyle' ], {color: 'inherit'}));
            var colorStyle = config[ 'colorButton_foreStyle' ];
            colorStyle.childRule = function (element) {
                return !(element.is('a') || element.getElementsByTag('a').count()) || isUnstylable(element);
            };

            editor.applyStyle(new CKEDITOR.style(colorStyle, {color: color}));
        }

        editor.fire('saveSnapshot');
    }

    function isUnstylable(ele) {
        return (ele.getAttribute('contentEditable') == 'false') || ele.getAttribute('data-nostyle');
    }

    if(typeof custom_font_colors !="undefined" && custom_font_colors == 0){
        var height_dialog = 200;
        var html = '<input type="text" id="hue-font_gminicolors" class="form-control font_gminicolors" data-control="hue" value="#555555">';
        html+= '<span class="input-group-btn">';
        html+= '<button class="btn_action btn_remove_color color_btn_remove" type="button">'+lang.defaultColorTitle+'</button>';
        html+= '<button class="btn_action btn_apply color_btn_apply" type="button">'+lang.apply+'</button>';
        html+='</span>';
    }else{
        var height_dialog = 290;
        var html = '<div class="list_colors" style="margin-bottom:10px;max-height:80px;overflow:auto;">';
        html+='<p style="font-size: 18px;line-height: 28px;text-align: center;">'+lang.customColorTitle+'</p>';
        jQuery.each(JSON.parse(droplistcolors),function(i,color){
            html+= '<div data-color="'+ color +'" class="custom_color_lists" style="float: left;width: 30px;height: 20px;border: #fff 1px solid;background:'+ color +'"></div>'
        });
        html+= '</div>';
        html+= '<input type="text" id="hue-font_gminicolors" class="form-control font_gminicolors" data-control="hue" value="#555555">';
        html+= '<span class="input-group-btn">';
        html+= '<button class="btn_action btn_remove_color color_btn_remove" type="button">'+lang.defaultColorTitle+'</button>';
        html+= '<button class="btn_action btn_apply color_btn_apply" type="button">'+lang.apply+'</button>';
        html+='</span>';
    }

    pickerContents = {
        id: 'yuiColorPicker',
        type: 'html',
        html: html,
        onLoad: function () {
            jQuery('.font_gminicolors').each(function () {
                jQuery(this).gminicolors({
                    control: jQuery(this).attr('data-control') || 'hue',
                    defaultValue: jQuery(this).attr('data-defaultValue') || '',
                    format: jQuery(this).attr('data-format') || 'hex',
                    keywords: jQuery(this).attr('data-keywords') || '',
                    inline: jQuery(this).attr('data-inline') === 'true',
                    letterCase: jQuery(this).attr('data-letterCase') || 'lowercase',
                    opacity: jQuery(this).attr('data-opacity'),
                    position: jQuery(this).attr('data-position') || 'bottom left',
                    change: function (value, opacity) {
                        if (!value)
                            return;
                        jQuery('.custom_color_lists').css('border','#fff 1px solid');
                        jQuery('.custom_color_lists[data-color="'+ value +'"]').css('border','#000 1px solid');
                    },
                    theme: 'bootstrap'
                });
            });


            jQuery('.color_btn_apply').on('click',function(){
                setNewUiColor(jQuery('.font_gminicolors.gminicolors-input').val());
                CKEDITOR.dialog.getCurrent().hide()
            });

            jQuery('.color_btn_remove').on('click',function(){
                editor.removeStyle(new CKEDITOR.style(config[ 'colorButton_foreStyle' ], {color: 'inherit'}));
                CKEDITOR.dialog.getCurrent().hide()
            });

            jQuery('.custom_color_lists').on('click',function(){
                jQuery('.custom_color_lists').css('border','#fff 1px solid');
                jQuery(this).css('border','#000 1px solid');
                var color = jQuery(this).data('color');
                jQuery('input.font_gminicolors.gminicolors-input').val(color).keyup().change();
            });

            jQuery('.font_gminicolors').closest('.gminicolors').before(jQuery('.list_colors'));
        }
    };

    return {
        title: lang.textColorTitle,
        minWidth: 310,
        minHeight: height_dialog,
        onLoad: function () {
            dialog = this;
            this.setupContent();
            // #3808
            if (CKEDITOR.env.ie7Compat)
                dialog.parts.contents.setStyle('overflow', 'hidden');
        },
        contents: [{
            id: 'tab1',
            label: '',
            title: '',
            expand: false,
            padding: 0,
            elements: [
                pickerContents,
                {
                    id: 'tab1',
                    type: 'vbox',
                    children: []
                }
            ]
        }],
        buttons : false
//                buttons: [CKEDITOR.dialog.okButton]

    };
});
