CKEDITOR.plugins.add( 'columns', {
    icons: 'columns',
    requires: ['panelbutton', 'iframedialog' ],
    lang: 'af,ar,bg,bn,bs,ca,cs,cy,da,de,el,en,en-au,en-ca,en-gb,eo,es,et,eu,fa,fi,fo,fr,fr-ca,gl,gu,he,hi,hr,hu,id,is,it,ja,ka,km,ko,ku,lt,lv,mk,mn,ms,nb,nl,no,pl,pt,pt-br,ro,ru,si,sk,sl,sq,sr,sr-latn,sv,th,tr,tt,ug,uk,vi,zh,zh-cn', // %REMOVE_LINE_CORE%
    init: function( editor ) {
        var config = editor.config,
            lang = editor.lang.columns;
        if ( !CKEDITOR.env.hc ) {
            addButton( 'Columns', lang.title, 20 );
        }


        var pluginDirectory = this.path;
        if (!IsStyleSheetAlreadyLoaded(pluginDirectory + 'styles/columns.css')) {
            CKEDITOR.document.appendStyleSheet(pluginDirectory + 'styles/columns.css');
        }

        // Get Browser Viewport Width
        var width = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
        width = width *80/100;
        // Get Browser Viewport Height
        var height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
        height = height -100 ;

        CKEDITOR.dialog.addIframe(
            'columnsIframeDialog' + editor.name,
            lang.title,
            CKEDITOR.config.jBaseHref +'index.php?option=com_dropeditor&tmpl=component&view=advancedcolumns&'+ ckToken +'=1&e_name='+ editor.name + '&caninsert=1&template=system&path='+ ckPath,
            width, height,
            function()
            {
                // Iframe loaded callback.
            },
            {
                onLoad : function()
                {
                    dialog = CKEDITOR.dialog.getCurrent();
                    document.getElementById(dialog.getButton("ok").domId).style.display = 'none';
                    document.getElementById(dialog.getButton("cancel").domId).style.display = 'none';
                }
            }
        );


        CKEDITOR.dialog.addIframe(
            'updateColumnDialog' + editor.name,
            lang.updateColumn,
            CKEDITOR.config.jBaseHref +'index.php?option=com_dropeditor&tmpl=component&view=advancedcolumns&'+ ckToken +'=1&e_name='+ editor.name + '&update=1&template=system&path='+ ckPath,
            width, height,
            function()
            {
                // Iframe loaded callback.
            },
            {
                onLoad : function()
                {
                    dialog = CKEDITOR.dialog.getCurrent();
                    document.getElementById(dialog.getButton("ok").domId).style.display = 'none';
                    document.getElementById(dialog.getButton("cancel").domId).style.display = 'none';
                }
            }
        );

        var update = new CKEDITOR.dialogCommand('updateColumnDialog' + editor.name);
        editor.addCommand('updateColumnCommand', update);
        //Register map group;
        editor.addMenuGroup("drop", 100);
        editor.addMenuItems({
            updateColumn: {
                label: lang.updateColumn,
                group: 'drop',
                command: 'updateColumnCommand'
            }
        });

        editor.contextMenu.addListener(function(element, selection) {
            if ( !element ) return null;

            while (element) {
                var name = element.getName();
                if (name == 'div' && element.hasClass("csRow"))
                    return {updateColumn: CKEDITOR.TRISTATE_OFF};

                element = element.getParent();
            }
            return null;
        });

        function addButton( name, title, order ) {

            columnsBoxId = CKEDITOR.tools.getNextId() + '_columnsBox';

            editor.ui.add( name, CKEDITOR.UI_PANELBUTTON, {
                label: title,
                title: title,
                modes: { wysiwyg: 1 },
                editorFocus: 0,
                toolbar: 'drop,' + order,

                panel: {
                    css: CKEDITOR.skin.getPath( 'editor' ),
                    attributes: { role: 'listbox', 'aria-label': 'Columns' }
                },
                onBlock: function( panel, block ) {
                    block.autoSize = true;
                    block.element.addClass( 'cke_columnsblock' );
                    block.element.setHtml( renderColumns( panel, pluginDirectory, columnsBoxId ) );
                    // The block should not have scrollbars (#5933, #6056)
                    block.element.getDocument().getBody().setStyle( 'overflow', 'hidden' );

                    CKEDITOR.ui.fire( 'ready', this );

                    var keys = block.keys;
                    var rtl = editor.lang.dir == 'rtl';
                    keys[ rtl ? 37 : 39 ] = 'next'; // ARROW-RIGHT
                    keys[ 40 ] = 'next'; // ARROW-DOWN
                    keys[ 9 ] = 'next'; // TAB
                    keys[ rtl ? 39 : 37 ] = 'prev'; // ARROW-LEFT
                    keys[ 38 ] = 'prev'; // ARROW-UP
                    keys[ CKEDITOR.SHIFT + 9 ] = 'prev'; // SHIFT + TAB
                    keys[ 32 ] = 'click'; // SPACE
                },

                refresh: function() {
                    //if ( !editor.activeFilter.check( style ) )
                    //this.setState( CKEDITOR.TRISTATE_DISABLED );
                },

                // The automatic colorbox should represent the real color (#6010)
                onOpen: function() {

                    var selection = editor.getSelection(),
                        block = selection && selection.getStartElement(),
                        path = editor.elementPath( block )
                    ;

                    if ( !path )
                        return;

                    // Find the closest block element.
                    block = path.block || path.blockLimit || editor.document.getBody();


                    //this._.panel._.iframe.getFrameDocument().getById( colorBoxId ).setStyle( 'background-color', color );

                    return '#000';
                }
            } );

        }

        function renderColumns( panel, pluginDirectory, columnsBoxId ) {
            var output = [],
                columns = config.columns_styles.split( ',' ) ,
                labels = config.columns_labels.split( ',' ) ;
            var total = 5;

            output.push('<style>');
            output.push('.cke_columnsbox { padding: 5px; } ');
            output.push('.cke_columnsbox:hover { background-color: #2196f3; } ');
            output.push('#CustomBtn { background-color: #2196f3; color:#fff; text-decoration: none;  font-size: 13px; font-family:Verdana,Arial,Helvetica ; padding:5px 5px;  cursor: pointer; box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.16), 0 2px 10px 0 rgba(0, 0, 0, 0.12); -moz-box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.16), 0 2px 10px 0 rgba(0, 0, 0, 0.12); -webkit-box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.16), 0 2px 10px 0 rgba(0, 0, 0, 0.12);} ');
            output.push('#CustomBtn:hover { box-shadow: 0 5px 11px 0 rgba(0, 0, 0, 0.18), 0 4px 15px 0 rgba(0, 0, 0, 0.15); -moz-box-shadow: 0 5px 11px 0 rgba(0, 0, 0, 0.18), 0 4px 15px 0 rgba(0, 0, 0, 0.15); -webkit-box-shadow: 0 5px 11px 0 rgba(0, 0, 0, 0.18), 0 4px 15px 0 rgba(0, 0, 0, 0.15);}');
            output.push('.column-50-50 {text-decoration: none; background: url('+ pluginDirectory+'/icons/50_50.gif) 50% 50% no-repeat ;}' );
            output.push('.column-33-66 {text-decoration: none; background: url('+ pluginDirectory+'/icons/33_66.gif) 50% 50% no-repeat;}' );
            output.push('.column-66-33 {text-decoration: none;background: url('+ pluginDirectory+'/icons/66_33.gif) 50% 50% no-repeat;}' );
            output.push('.column-33-33-33 {text-decoration: none; background: url('+ pluginDirectory+'/icons/33_33_33.gif) 50% 50% no-repeat;}' );
            output.push('.column-25-25-25-25 {text-decoration: none; background: url('+ pluginDirectory+'/icons/25_25_25_25.gif) 50% 50% no-repeat ;}' );
            output.push('</style>');

            output.push('<table role="presentation" cellspacing=0 cellpadding=0 width="100%"><tr>' );


            var clickFn = CKEDITOR.tools.addFunction( function( columnType ) {
                if ( columnType == 'custom' ) {

                    editor.openDialog( 'columnsIframeDialog' + editor.name, function() {
                        //do nothing
                    } );

                    return;
                }

                editor.focus();

                panel.hide();

                editor.fire( 'saveSnapshot' );

                if ( columnType ) {
                    columnWidths = columnType.split( '-' );
                    var  posX0 = 0;
                    var sampleContent = 'Lorem ipsum dolor sit amet';
                    var columnsHtml = '';
                    columnsHtml += '<div class="csRow">';
                    for ( var i = 0; i < columnWidths.length; i++ ) {
                        if(i > 0) {
                            posX0 +=  parseFloat(columnWidths[i-1])+ 0.5;
                        }
                        posX1 = posX0 + parseFloat(columnWidths[i]) - 0.5;

                        columnsHtml += '<div class="csColumn" data-posX0="'+ posX0+'" data-posX1="'+ posX1+'" data-padding="5" style="margin: 0px; padding: 0px; float: left; width:'+ columnWidths[i]+'%;" >'
                        columnsHtml += '<div style="padding:5px;"><div class="csColumn_text" >' + sampleContent +'</div></div></div>';
                    }

                    columnsHtml += '<div style="clear: both; float: none; display: block; visibility: hidden; width: 0px; font-size: 0px; line-height: 0;"></div>';
                    columnsHtml += '</div>';

                    var col = new CKEDITOR.dom.element.createFromHtml( columnsHtml);
                    editor.insertElement( col );
                    //editor.execCommand( 'shiftEnter' );

                }

            } );

            for ( var i = 0; i < columns.length; i++ ) {
                output.push( '<td height="30px">' +
                    '<a class="cke_columnsbox column-'+columns[i]+'"  _cke_focus=1 hidefocus=true' +
                    ' title="', labels[i], '"' +
                    ' onclick="CKEDITOR.tools.callFunction(', clickFn, ',\'', columns[i], '\'); return false;"' +
                    ' href="javascript:void(\'', labels[i], '\')"' +
                    ' role="option" aria-posinset="', ( i + 2 ), '" aria-setsize="', total, '"><span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>' +

                    '</a>' +
                    '</td>' );

            }

            output.push( '</tr><tr>' );
            output.push( '<td colspan="5" height="30px" style="text-align:center;padding-bottom:5px;" >' +
                ' <a class="cke_columnsbox" _cke_focus=1 hidefocus=true' +
                ' id="CustomBtn"' +
                ' title="'+ lang.custom + '"' +
                ' onclick="CKEDITOR.tools.callFunction(', clickFn, ',\'custom\'); return false;" ' +
                ' href="javascript:void(\'Custom\')"' +
                ' > '+ lang.custom + '</a></td>' );
            output.push( '</tr></table>' );
            return output.join( '' );
        }


    }
});

CKEDITOR.config.columns_styles = '50-50,33-33-33,25-25-25-25,33-66,66-33';
CKEDITOR.config.columns_labels = '1/2 + 1/2,1/3 + 1/3 + 1/3,1/4 + 1/4 + 1/4 + 1/4,1/3 + 2/3,2/3 + 1/3';	