(function() {

    CKEDITOR.plugins.add('dropbtns', {
        icons: 'buttons',
        requires: ['iframedialog'],
        lang: 'af,ar,bg,bn,bs,ca,cs,cy,da,de,el,en,en-au,en-ca,en-gb,eo,es,et,eu,fa,fi,fo,fr,fr-ca,gl,gu,he,hi,hr,hu,id,is,it,ja,ka,km,ko,ku,lt,lv,mk,mn,ms,nb,nl,no,pl,pt,pt-br,ro,ru,si,sk,sl,sq,sr,sr-latn,sv,th,tr,tt,ug,uk,vi,zh,zh-cn', // %REMOVE_LINE_CORE%
        init: function(editor) {

            // Get Browser Viewport Width
            var width = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
            width =  Math.min(800, width * 80 / 100);
            // Get Browser Viewport Height
            var height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
            var height = Math.min(520, height- 100);

            CKEDITOR.dialog.addIframe(
                'dropbtnsIframeDialog' + editor.name,
                editor.lang.dropbtns.title,
                CKEDITOR.config.jBaseHref + 'index.php?option=com_dropeditor&view=buttons&tmpl=component&' + ckToken + '=1&e_name=' + editor.name + '&caninsert=1&template=system&path=' + ckPath,
                width, height,
                function()
                {
                    // Iframe loaded callback.
                },
                {
                    onLoad: function()
                    {
                        dialog = CKEDITOR.dialog.getCurrent();
                        document.getElementById(dialog.getButton("ok").domId).style.display = 'none';
                        document.getElementById(dialog.getButton("cancel").domId).style.display = 'none';
                    }
                }
            );
            var cmd = new CKEDITOR.dialogCommand('dropbtnsIframeDialog'+ editor.name);
            editor.addCommand('addButtonCommand', cmd);


            editor.addCommand('launchCommand', {
                exec: function(editor) {
                    var selection = editor.getSelection();
                    var element = selection.getStartElement();

                    var btn = null;
                    while (element) {
                        var name = element.getName();
                        if (name == 'a' && element.hasClass("dropbtn"))
                        {
                            btn = element;
                            break;
                        }

                        element = element.getParent();
                    }

                    if (btn) {
                        editor.execCommand("updateButtonCommand");
                    } else {
                        editor.execCommand("addButtonCommand");
                    }

                }
            });

            CKEDITOR.dialog.addIframe(
                'buttonUpdateIframeDialog'+ editor.name,
                editor.lang.dropbtns.updateButton,
                CKEDITOR.config.jBaseHref +'index.php?option=com_dropeditor&view=buttons&tmpl=component&' + ckToken + '=1&e_name=' + editor.name + '&update=1&template=system&path=' + ckPath,
                width, height,
                function()
                {
                    // Iframe loaded callback.
                },
                {
                    onLoad: function()
                    {
                        dialog = CKEDITOR.dialog.getCurrent();
                        document.getElementById(dialog.getButton("ok").domId).style.display = 'none';
                        document.getElementById(dialog.getButton("cancel").domId).style.display = 'none';
                    }
                }
            );

            var updateButton = new CKEDITOR.dialogCommand('buttonUpdateIframeDialog'+ editor.name);
            editor.addCommand('updateButtonCommand', updateButton);
            //Register map group;
            editor.addMenuGroup("drop", 100);
            editor.addMenuItems({
                updateButton: {
                    label: editor.lang.dropbtns.updateButton,
                    group: 'drop',
                    command: 'updateButtonCommand'
                }
            });

            editor.contextMenu.addListener(function(element, selection) {
                if ( !element ) return null;

                while (element) {
                    var name = element.getName();
                    if (name == 'a' && element.hasClass("dropbtn"))
                        return {updateButton: CKEDITOR.TRISTATE_OFF};

                    element = element.getParent();
                }
                return null;
            });

            editor.ui.addButton('Buttons', {
                label: editor.lang.dropbtns.title,
                command: 'launchCommand',
                toolbar: 'insert'
            });
        }
    });
})();

