(function() {

    CKEDITOR.plugins.add('droplist', {
        requires: ['iframedialog'],
        lang: 'af,ar,bg,bn,bs,ca,cs,cy,da,de,el,en,en-au,en-ca,en-gb,eo,es,et,eu,fa,fi,fo,fr,fr-ca,gl,gu,he,hi,hr,hu,id,is,it,ja,ka,km,ko,ku,lt,lv,mk,mn,ms,nb,nl,no,pl,pt,pt-br,ro,ru,si,sk,sl,sq,sr,sr-latn,sv,th,tr,tt,ug,uk,vi,zh,zh-cn', // %REMOVE_LINE_CORE%
        init: function(editor) {

            // Get Browser Viewport Width
            var width = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
            width =  Math.min(800, width * 80 / 100);
            // Get Browser Viewport Height
            var height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
            var height = Math.min(500, height- 100);

            CKEDITOR.dialog.addIframe(
                'droplistIframeDialog' + editor.name,
                editor.lang.droplist.bulletedTitle,
                CKEDITOR.config.jBaseHref + 'index.php?option=com_dropeditor&view=bulleted&tmpl=component&' + ckToken + '=1&e_name=' + editor.name + '&caninsert=1&template=system&path=' + ckPath,
                width, height,
                function()
                {
                    // Iframe loaded callback.
                },
                {
                    onLoad: function()
                    {
                        dialog = CKEDITOR.dialog.getCurrent();
                        document.getElementById(dialog.getButton("ok").domId).style.display = 'none';
                        document.getElementById(dialog.getButton("cancel").domId).style.display = 'none';
                    }
                }
            );
            var cmd = new CKEDITOR.dialogCommand('droplistIframeDialog' + editor.name);
            editor.addCommand('addListCommand', cmd);


            editor.addCommand('launchListCommand', {
                exec: function(editor) {
                    var selection = editor.getSelection();
                    var element = selection.getStartElement();

                    var lst = null;
                    while (element) {
                        var name = element.getName();
                        if (name == 'ul' )
                        {
                            lst = element;
                            break;
                        }

                        element = element.getParent();
                    }

                    if (lst) {
                        editor.execCommand("updateListCommand");
                    } else {
                        editor.execCommand( 'bulletedlist' );
                        editor.execCommand("addListCommand");
                    }

                }
            });

            CKEDITOR.dialog.addIframe(
                'droplistUpdateIframeDialog' + editor.name,
                editor.lang.droplist.bulletedTitle,
                CKEDITOR.config.jBaseHref +'index.php?option=com_dropeditor&view=bulleted&tmpl=component&' + ckToken + '=1&e_name=' + editor.name + '&update=1&template=system&path=' + ckPath,
                width, height,
                function()
                {
                    // Iframe loaded callback.
                },
                {
                    onLoad: function()
                    {
                        dialog = CKEDITOR.dialog.getCurrent();
                        document.getElementById(dialog.getButton("ok").domId).style.display = 'none';
                        document.getElementById(dialog.getButton("cancel").domId).style.display = 'none';
                    }
                }
            );

            var updateList = new CKEDITOR.dialogCommand('droplistUpdateIframeDialog' + editor.name);
            editor.addCommand('updateListCommand', updateList);
            //Register map group;
            editor.addMenuGroup("drop", 100);
            editor.addMenuItems({
                updateList: {
                    label: 'Update List',
                    group: 'drop',
                    command: 'updateListCommand'
                }
            });

            editor.contextMenu.addListener(function(element, selection) {
                if ( !element ) return null;

                while (element) {
                    var name = element.getName();
                    if (name == 'ul' ) //&& element.hasClass("droplist")
                        return {updateList: CKEDITOR.TRISTATE_OFF};

                    element = element.getParent();
                }
                return null;
            });

            editor.ui.addButton('BulletedDropList', {
                label: editor.lang.droplist.bulletedTitle,
                command: 'launchListCommand',
                toolbar: 'insert'
            });
        }
    });
})();