(function () {
    CKEDITOR.plugins.add('dropmedia', {
        icons: 'dropmedia',
        requires: ['iframedialog'],
        lang: 'af,ar,bg,bn,bs,ca,cs,cy,da,de,el,en,en-au,en-ca,en-gb,eo,es,et,eu,fa,fi,fo,fr,fr-ca,gl,gu,he,hi,hr,hu,id,is,it,ja,ka,km,ko,ku,lt,lv,mk,mn,ms,nb,nl,no,pl,pt,pt-br,ro,ru,si,sk,sl,sq,sr,sr-latn,sv,th,tr,tt,ug,uk,vi,zh,zh-cn', // %REMOVE_LINE_CORE%
        init: function (editor) {
            var lang = editor.lang.dropmedia;
            // Get Browser Viewport Width
            var width = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
            width =  Math.min(800, width * 80 / 100);
            // Get Browser Viewport Height
            var height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
            height = Math.min(520, height- 100);

            CKEDITOR.dialog.addIframe(
                'dropmediaIframeDialog',
                lang.dialogTitle,
                CKEDITOR.config.jBaseHref + 'index.php?option=com_dropeditor&view=media&tmpl=component&' + ckToken + '=1&e_name=' + editor.name + '&caninsert=1&template=system&path=' + ckPath,
                width, height,
                function()
                {
                    // Iframe loaded callback.
                },
                {
                    onLoad: function()
                    {
                        dialog = CKEDITOR.dialog.getCurrent();
                        document.getElementById(dialog.getButton("ok").domId).style.display = 'none';
                        document.getElementById(dialog.getButton("cancel").domId).style.display = 'none';
                    }
                }
            );
            var dropmedia = new CKEDITOR.dialogCommand('dropmediaIframeDialog');
            editor.addCommand('addMediaCommand', dropmedia);

            if ( editor.ui.addButton ) {
                editor.ui.addButton('DropMedia', {
                    label: lang.buttonLabel,
                    command: 'addMediaCommand',
                    toolbar: 'insert'
                });
            }

            editor.on('contentDom', function () {
                thisDoc = this.document;
                $ = jQuery;

                thisDoc.on('click', function () {
                    $('.dropmedia-qe-block').remove();
                    editorTop = $('.cke_contents').offset().top;
                    editorHeight = $('.cke_contents').height();
                    elm = editor.getSelection().getStartElement();
                    videoHost = elm.getAttribute('data-host');

                    if (elm.$.tagName === 'IMG' && elm.getAttribute('data-dropmedia') === 'true') {
                        scrollTop = elm.$.offsetParent.scrollTop || elm.$.offsetParent.parentElement.scrollTop;
                        offX = elm.$.offsetLeft + elm.$.offsetWidth/4;
                        offY = elm.$.offsetTop + elm.$.offsetHeight - scrollTop + editorTop + 10;
                        previewURL = elm.getAttribute('data-video-url') || elm.getAttribute('data-local-file');

                        divHTML = '<div class="dropmedia-qe-block" style="position: absolute;top: '+offY+'px; left: '+offX+'px;">'
                            +'<div class="dropmedia-qe-url"><a href="'+previewURL+'" target="_blank">'+previewURL+'</a></div>'
                            +'<div class="dropmedia-qe-buttons">'
                            +'<button role="presentation" type="button" class="dropmedia-qe-full-edit" title="Edit in DropMedia"><i class="material-icons">play_circle_outline</i></button>';

                        if (videoHost === 'youtube' || videoHost === 'vimeo') {
                            divHTML += '<button role="presentation" type="button" class="dropmedia-qe-quick-edit" title="Quick edit"><i class="material-icons">mode_edit</i></button>';
                        }
                        divHTML +='</div></div>';

                        $('body').append(divHTML);

                        thisDoc.on('scroll', function () {
                            scrollTop = elm.$.offsetParent.scrollTop || elm.$.offsetParent.parentElement.scrollTop;
                            offY = elm.$.offsetTop + elm.$.offsetHeight - scrollTop + editorTop + 10;
                            $('.dropmedia-qe-block').css('top', offY + 'px');

                            if (elm.$.offsetTop + elm.$.offsetHeight < scrollTop ||
                                elm.$.offsetTop + elm.$.offsetHeight - scrollTop > editorHeight) {
                                $('.dropmedia-qe-block').hide();
                            } else {
                                $('.dropmedia-qe-block').show();
                            }
                        });

                        function initDropMediaButtons() {
                            $('.dropmedia-qe-quick-edit').unbind('click').click(function () {
                                editMode(previewURL);

                                newURL = previewURL;
                                $('.dropmedia-qe-url input').on('change input propertychange', function () {
                                    newURL = $(this).val().trim();
                                });
                                newURL = newURL.trim();

                                $('.dropmedia-qe-apply').unbind('click').click(function () {
                                    $('.dropmedia-qe-url input').attr('disabled', true);
                                    applyNewURL(newURL);
                                });

                                $('.dropmedia-qe-url input').on('keypress', function (e) {
                                    if (e.which === 13) { //Apply new href if user hit enter
                                        e.preventDefault();
                                        applyNewURL(newURL);
                                    }
                                }).on('keyup', function (e) {
                                    if (e.which === 27) { //Cancel editing if user hit ESC
                                        e.preventDefault();
                                        previewMode(previewURL);
                                    }
                                })
                            });

                            $('.dropmedia-qe-full-edit').unbind('click').click(function () {
                                editor.execCommand('addMediaCommand');
                                $('.dropmedia-qe-block').remove();
                                return false;
                            })
                        }

                        initDropMediaButtons();

                        function applyNewURL(mediaURL) {
                            if (mediaURL === '') {
                                alert('URL cannot be empty!');
                                return false;
                            } else {
                                video_host = ''; video_id = '';
                                if (mediaURL.search(/(youtube\.com|youtu\.be)/) > -1) {
                                    video_host = 'youtube';
                                } else if (mediaURL.search(/vimeo\.com/) > -1) {
                                    video_host = 'vimeo';
                                } else {
                                    alert('Invalid or not supported URL! Please enter another!');
                                    return false;
                                }

                                switch (video_host) {
                                    case 'youtube':
                                        if (mediaURL.indexOf('youtu.be') !== -1) {
                                            video_id = mediaURL.split('/');
                                            video_id = video_id[video_id.length - 1];

                                            break;
                                        }
                                        video_id = mediaURL.split('v=');
                                        video_id = video_id[1];
                                        var ampPos = video_id.indexOf('&');
                                        if(ampPos !== -1) {
                                            video_id = video_id.substring(0, ampPos);
                                        }

                                        break;
                                    case 'vimeo':
                                        video_id = mediaURL.split('/');
                                        video_id = video_id[video_id.length - 1];

                                        var ampPos = video_id.indexOf('&');
                                        if(ampPos !== -1) {
                                            video_id = video_id.substring(0, ampPos);
                                        }

                                        break;
                                    default:
                                        break;
                                }

                                $.ajax({
                                    url: 'index.php?option=com_dropeditor&task=media.getVideoInfo',
                                    method: 'POST',
                                    dataType: 'json',
                                    data: {
                                        video_id: video_id,
                                        video_type: video_host
                                    },
                                    success: function (res, stt) {
                                        if (res.status === true) {
                                            elm.setAttribute('data-host', res.datas.type);
                                            elm.setAttribute('data-direct-link', res.datas.directLink);
                                            elm.setAttribute('data-video-url', mediaURL);
                                            elm.setAttribute('data-video-id', res.datas.id);
                                            elm.setAttribute('data-video-title', res.datas.title);
                                            elm.setAttribute('data-cke-saved-src', res.datas.thumbnail);
                                            elm.setAttribute('src', res.datas.thumbnail);

                                            editor.fire('saveSnapshot');
                                            $('.dropmedia-qe-block').remove();
                                            editor.focus();
                                        } else {
                                            alert('Error while loading video data! Try another URL!');
                                            $('.dropmedia-qe-url input').removeAttr('disabled').select();
                                            return false;
                                        }
                                    }
                                })
                            }
                        }

                        function editMode(mediaURL) {
                            editInput = '<input type="text" placeholder="Enter video URL" value="'+mediaURL+'" />';
                            editBtns = '<button role="presentation" type="button" class="dropmedia-qe-apply"><i class="material-icons">subdirectory_arrow_left</i></button>';

                            $('.dropmedia-qe-url').html(editInput);
                            $('.dropmedia-qe-buttons').html(editBtns);
                            $('.dropmedia-qe-url input').select();
                        }

                        function previewMode(mediaURL) {
                            previewA = '<a href="'+mediaURL+'" target="_blank">'+mediaURL+'</a>';
                            previewBtns = '<button role="presentation" type="button" class="dropmedia-qe-full-edit" title="Edit in DropMedia"><i class="material-icons">play_circle_outline</i></button>'
                                + '<button role="presentation" type="button" class="dropmedia-qe-quick-edit" title="Quick edit"><i class="material-icons">mode_edit</i></button>';

                            $('.dropmedia-qe-url').html(previewA);
                            $('.dropmedia-qe-buttons').html(previewBtns);

                            initDropMediaButtons();
                        }
                    }
                })
            })
        }
    })
})();