(function() {
    CKEDITOR.plugins.add( 'htmltemplate', {
        icons: 'templates',
        requires: [ 'iframedialog' ],
        lang: 'af,ar,bg,bn,bs,ca,cs,cy,da,de,el,en,en-au,en-ca,en-gb,eo,es,et,eu,fa,fi,fo,fr,fr-ca,gl,gu,he,hi,hr,hu,id,is,it,ja,ka,km,ko,ku,lt,lv,mk,mn,ms,nb,nl,no,pl,pt,pt-br,ro,ru,si,sk,sl,sq,sr,sr-latn,sv,th,tr,tt,ug,uk,vi,zh,zh-cn', // %REMOVE_LINE_CORE%
        init: function( editor ) {

            // Get Browser Viewport Width
            var width = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
            width = width *60/100;
            // Get Browser Viewport Height
            var height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
            height = height *60/100;

            CKEDITOR.dialog.addIframe(
                'templateIframeDialog',
                editor.lang.htmltemplate.title,
                CKEDITOR.config.jBaseHref +'index.php?option=com_dropeditor&tmpl=component&view=htmlTemplates&'+ ckToken +'=1&e_name='+ editor.name + '&caninsert=1&template=system&path='+ ckPath,
                width, height,
                function()
                {
                    var editor = CKEDITOR.currentInstance;
                    range = editor.getSelection().getRanges()[ 0 ],
                        el = editor.document.createElement( 'div' );
                    el.append( range.cloneContents() );
                    htmlContent  = el.getHtml();
                    if(htmlContent=="") {
                        htmlContent = editor.getData();
                    }

                    var iframe = document.getElementById( this._.frameId );
                    iframeWindow = iframe.contentWindow;
                    iframeWindow.document.getElementById('templateContent').innerHTML = htmlContent;

                    // Iframe loaded callback.

                },
                {
                    onLoad : function()
                    {
                        dialog = CKEDITOR.dialog.getCurrent();
                        document.getElementById(dialog.getButton("ok").domId).style.display = 'none';
                        document.getElementById(dialog.getButton("cancel").domId).style.display = 'none';
                    }
                }
            );
            editor.addCommand( 'templateIframeCommand', new CKEDITOR.dialogCommand( 'templateIframeDialog' ) );


            editor.ui.addButton( 'Templates', {
                label: editor.lang.htmltemplate.title,
                command: 'templateIframeCommand',
                toolbar: 'insert'
            });
        }
    });
})();