/*
Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
For licensing, see LICENSE.html or http://ckeditor.com/license
*/

/**
 * @imagemobile plugin.
 */
(function()
{

    // Register a plugin named "jlink".
    CKEDITOR.plugins.add( 'jlink',
        {
            lang: 'af,ar,bg,bn,bs,ca,cs,cy,da,de,el,en,en-au,en-ca,en-gb,eo,es,et,eu,fa,fi,fo,fr,fr-ca,gl,gu,he,hi,hr,hu,id,is,it,ja,ka,km,ko,ku,lt,lv,mk,mn,ms,nb,nl,no,pl,pt,pt-br,ro,ru,si,sk,sl,sq,sr,sr-latn,sv,th,tr,tt,ug,uk,vi,zh,zh-cn', // %REMOVE_LINE_CORE%
            init : function( editor )
            {
                var lang = editor.lang.jlink;
                // Get Browser Viewport Width
                var width = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
                width = width *60/100;
                if (width > 800) width = 800;

                var height = 450 ;
                CKEDITOR.dialog.addIframe(
                    'linkIframeDialog' + editor.name,
                    lang.title,
                    CKEDITOR.config.jBaseHref +'index.php?option=com_dropeditor&tmpl=component&view=link&'+ ckToken +'=1&e_name='+ editor.name + '&caninsert=1&template=system&path='+ ckPath,
                    width, height,
                    function()
                    {
                        // Iframe loaded callback.
                    },
                    {
                        onLoad : function()
                        {
                            dialog = CKEDITOR.dialog.getCurrent();
                            document.getElementById(dialog.getButton("ok").domId).style.display = 'none';
                            document.getElementById(dialog.getButton("cancel").domId).style.display = 'none';
                        }
                    }
                );

                editor.addCommand( 'jlinkCommand', new CKEDITOR.dialogCommand( 'linkIframeDialog'+ editor.name ) );
                editor.ui.addButton( 'JLink',
                    {
                        label : lang.title,
                        command : 'jlinkCommand'
                    });

                editor.on('menuShow', function (env) {
                    var iFrame = (env.data[0] || env.data).element.getElementsByTag('iframe').getItem(0).getFrameDocument();
                    linkButton = iFrame.find('.cke_menubutton__link ');
                    if (linkButton.$.length > 0 ) {
                        linkButton = linkButton.$[0];
                        linkButton.onclick = function () {
                            editor.execCommand('jlinkCommand');
                        }
                    }
                });

                editor.on('contentDom', function () {
                    thisDoc = this.document;
                    $ = jQuery;

                    thisDoc.on('click', function (ev) {
                        $('.jlink_preview_block').remove();
                        editorTop = $('.cke_contents').offset().top;
                        editorHeight = $('.cke_contents').height();
                        elm = editor.getSelection().getStartElement();
                        // console.log(elm);
                        if (elm.$.tagName = "A" && elm.getAttribute('href')) {
                            thisHref = elm.getAttribute('href');
                            scrollTop = elm.$.offsetParent.scrollTop || elm.$.offsetParent.parentElement.scrollTop;
                            offX = elm.$.offsetLeft;
                            offY = elm.$.offsetTop + elm.$.offsetHeight - scrollTop + editorTop + 10;

                            divHTML = '<div class="jlink_preview_block" style="position: absolute;top: '+offY+'px; left: '+offX+'px;">'
                                +'<div class="jlink_preview"><a href="'+thisHref+'" target="_blank">'+thisHref+'</a></div>'
                                +'<div class="jlink_preview_button">'
                                +'<button role="presentation" type="button" class="jlink_link_btn" title="'+lang.manager+'"><i class="material-icons">link</i></button>'
                                +'<button role="presentation" type="button" class="jlink_edit_btn" title="'+lang.edit+'"><i class="material-icons">mode_edit</i></button>'
                                +'<button role="presentation" type="button" class="jlink_unlink_btn" title="'+lang.unlink+'"><i class="material-icons">leak_remove</i></button>'
                                +'</div>'
                                +'</div>';
                            $('body').append(divHTML);

                            thisDoc.on('scroll', function () {
                                scrollTop = elm.$.offsetParent.scrollTop || elm.$.offsetParent.parentElement.scrollTop;
                                offY = elm.$.offsetTop + elm.$.offsetHeight - scrollTop + editorTop + 10;
                                $('.jlink_preview_block').css('top', offY + 'px');

                                if (elm.$.offsetTop + elm.$.offsetHeight < scrollTop ||
                                    elm.$.offsetTop - scrollTop > editorHeight) {
                                    $('.jlink_preview_block').hide();
                                } else {
                                    $('.jlink_preview_block').show();
                                }
                            });

                            function initButtons() {
                                $('.jlink_edit_btn').unbind('click').click(function () {
                                    editMode(thisHref);

                                    newHref = thisHref;
                                    $('.jlink_preview input').on('change input propertychange', function () {
                                        newHref = $(this).val().trim();
                                    });
                                    newHref = newHref.trim();

                                    $('.jlink_apply_btn').unbind('click').click(function () {
                                        applyNewHref(newHref);
                                    });

                                    $('.jlink_preview input').on('keypress keyup', function (e) {
                                        if (e.which === 13) { //Apply new href if user hit enter
                                            e.preventDefault();
                                            applyNewHref(newHref);
                                        }
                                        if (e.which === 27) { //Cancel editing if user hit ESC
                                            e.preventDefault();
                                            applyNewHref(thisHref);
                                        }
                                    })
                                });

                                $('.jlink_link_btn').unbind('click').click(function () {
                                    editor.execCommand('jlinkCommand');
                                    $('.jlink_preview_block').remove();
                                    return false;
                                });

                                $('.jlink_unlink_btn').unbind('click').click(function () {
                                    editor.execCommand('unlink');
                                    $('.jlink_preview_block').remove();
                                    return false;
                                });
                            }
                            initButtons();

                            function applyNewHref(href) {
                                if (href !== "") {
                                    if (href.indexOf('http://') !== -1
                                        || href.indexOf('https://') !== -1
                                        || href.indexOf('mailto') !== -1
                                        || href.indexOf('index.php') === 0
                                        || href.indexOf('?') === 0
                                        || href.indexOf('#') === 0)
                                    {
                                        // do nothing
                                    } else {
                                        href = 'http://' + href
                                    }

                                    elm.setAttribute('href', href);
                                    elm.data('cke-saved-href', href);
                                    thisHref = href;
                                    previewMode(href);
                                } else {
                                    editor.execCommand('unlink');
                                    $('.jlink_preview_block').remove();
                                    return false;
                                }
                            }

                            function editMode(href) {
                                editHTML = '<input type="text" placeholder="http://" name="newHref" value="'+href+'" />';
                                editBtnHTML = '<button role="presentation" type="button" class="jlink_apply_btn" title="Apply"><i class="material-icons">subdirectory_arrow_left</i></button>';

                                $('.jlink_preview').html(editHTML);
                                $('.jlink_preview_button').html(editBtnHTML);
                                $('.jlink_preview input').select();                 //Select all text when click
                            }

                            function previewMode(href) {
                                previewA = '<a href="'+href+'" target="_blank">'+href+'</a>';
                                previewBtn = '<button role="presentation" type="button" class="jlink_link_btn" title="'+lang.manager+'"><i class="material-icons">link</i></button>'
                                    +'<button role="presentation" type="button" class="jlink_edit_btn" title="'+lang.edit+'"><i class="material-icons">mode_edit</i></button>'
                                    +'<button role="presentation" type="button" class="jlink_unlink_btn" title="'+lang.unlink+'"><i class="material-icons">leak_remove</i></button>';

                                $('.jlink_preview').html(previewA);
                                $('.jlink_preview_button').html(previewBtn);

                                // Highlight the link if it has white spaces
                                if (href.indexOf(' ') !== -1) {
                                    $('.jlink_preview a').css('color', 'red')
                                }

                                initButtons();
                            }
                        }
                    })
                });
            }
        });
})();
