﻿/**
 * @license Copyright (c) 2003-2017, CKSource - Frederico Knabben. All rights reserved.
 * For licensing, see LICENSE.md or http://ckeditor.com/license
 */

/**
 * @fileOverview Preview plugin.
 */

( function() {
    var currentURL = window.location.href;
    var urlArrays = currentURL.split('&');
    var currentView = '';
    var articleTitle = '';
    var articleID = null;
    for (var i =0; i < urlArrays.length; i++) {
        urlArray = urlArrays[i].split('=');
        if (urlArray[0] == 'id' || urlArray[0] ==  'a_id' || urlArray[0] ==  'cid') {
            articleID = urlArray[1];
            if (urlArray[0] ==  'a_id') {
                currentView = 'frontview';
            }
        }
        if (urlArray[0].indexOf('option') > -1) {
            currentView = urlArray[1];
        }
        if (urlArray[0].indexOf('view') > -1) {
            currentScreen = urlArray[1];
        }
    }

    var previewCmd = { modes: { wysiwyg: 1, source: 1 },
		canUndo: false,
        readOnly: true,
		exec: function( editor ) {
            var config = editor.config;
            baseHref = config.baseHref;
            if (currentView == 'com_k2') {
                articleTitle = document.getElementsByClassName('k2TitleBox')[0].value;
                actionHref = baseHref + 'index.php?option=com_k2&view=item&id='+articleID;
            }
            if (currentView == 'com_content') {
                articleTitle = document.getElementById('jform_title').value;
                actionHref = baseHref + 'index.php?option=com_content&view=article&id='+articleID;
            }

            var dropPreviewForm = document.getElementById('serverPreviewForm') ;
            if (!dropPreviewForm) {
                // If it doesn't exist, we create it here
                dropPreviewForm = document.createElement('FORM') ;
                dropPreviewForm.method = 'POST' ;
                dropPreviewForm.name = 'dropPreviewForm' ;
                dropPreviewForm.id=dropPreviewForm.name ;
                dropPreviewForm.style.display = 'none' ;

                dropPreviewForm.action = actionHref;

                dropPreviewForm.target='_blank';
                document.body.appendChild( dropPreviewForm );
            }

            //clear previous data
            dropPreviewForm.innerHTML = '' ;
            //set the new content
            addField('dropeditor_preview');
            addField('dropeditor_preview_data');
            addField('dropeditor_preview_title');

            function addField(field_name) {
                var input = document.createElement('TEXTAREA') ;
                input.type = 'hidden';
                input.name = field_name;
                switch (field_name) {
                    case 'dropeditor_preview' : input.value = 1;
                        break;
                    case 'dropeditor_preview_data': input.value = editor.getData();
                        break;
                    case 'dropeditor_preview_title': input.value = articleTitle;
                        break;
                    default: input.value = 1;
                        break;
                }
                //append the new input to the form
                dropPreviewForm.appendChild( input );
            }

            //send the data to the server
            dropPreviewForm.submit();
		}
	};

	var pluginName = 'preview';

	// Register a plugin named "preview".
	CKEDITOR.plugins.add( pluginName, {
		lang: 'af,ar,az,bg,bn,bs,ca,cs,cy,da,de,de-ch,el,en,en-au,en-ca,en-gb,eo,es,et,eu,fa,fi,fo,fr,fr-ca,gl,gu,he,hi,hr,hu,id,is,it,ja,ka,km,ko,ku,lt,lv,mk,mn,ms,nb,nl,no,oc,pl,pt,pt-br,ro,ru,si,sk,sl,sq,sr,sr-latn,sv,th,tr,tt,ug,uk,vi,zh,zh-cn', // %REMOVE_LINE_CORE%
		icons: 'preview,preview-rtl', // %REMOVE_LINE_CORE%
		hidpi: true, // %REMOVE_LINE_CORE%
		init: function( editor ) {

			// Preview is not used for the inline creator.
			if ( editor.elementMode == CKEDITOR.ELEMENT_MODE_INLINE )
				return;

			pluginPath = this.path;

			editor.addCommand( pluginName, previewCmd );
			editor.ui.addButton && editor.ui.addButton( 'Preview', {
				label: editor.lang.preview.preview,
				command: pluginName,
				toolbar: 'document,40'
			} );

			// We only enable this function on Article page
			editor.on('instanceReady', function (evt) {
                if (!articleID || (currentView != 'com_content' && currentView != 'frontview' && (currentView != 'com_k2' || currentScreen != 'item'))) {
                    command = editor.getCommand(pluginName);
                    command.setState(CKEDITOR.TRISTATE_DISABLED);
                }
            })
		}
	} );
} )();

/**
 * Event fired when executing `preview` command, which allows additional data manipulation.
 * With this event, the raw HTML content of the preview window to be displayed can be altered
 * or modified.
 *
 * @event contentPreview
 * @member CKEDITOR
 * @param {CKEDITOR.editor} editor This editor instance.
 * @param data
 * @param {String} data.dataValue The data that will go to the preview.
 */
