<?php
/** 
 * DropEditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package DropEditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


//-- No direct access
defined('_JEXEC') || die('=;)');


jimport('joomla.plugin.plugin');


/**
 * Content Plugin.
 *
 * @package    DropEditor
 * @subpackage Plugin
 */
class plgEditorDropeditor extends JPlugin
{
     /**
     * Constructor
     *
     * @access      public
     * @param       object  $subject The object to observe
     * @param       array   $config  An array that holds the plugin configuration
     * @since       3.3
     */
    public function __construct(& $subject, $config) {
        parent::__construct($subject, $config);
    }

   /**
     * Method to handle the onInit event.
     *  - Initializes the DropEditor
     *
     * @access  public
     * @param   $toString Return javascript and css as a string
     * @return  string JavaScript Initialization string
     * @since   3.3
     */
    public function onInit() {
        if (!is_dir(JPATH_SITE . '/components/com_dropeditor') || !is_dir(JPATH_ADMINISTRATOR . '/components/com_dropeditor')) {
            JError::raiseWarning('SOME_ERROR_CODE', 'JL_COMPONENT_MISSING');
        }


        $lang = JFactory::getLanguage();
        $lang->load('com_dropeditor',JPATH_ADMINISTRATOR.'/components/com_dropeditor',null,true);
        $lang->load('com_dropeditor.override',JPATH_ADMINISTRATOR.'/components/com_dropeditor',null,true);
        $lang->load('com_dropeditor.sys',JPATH_ADMINISTRATOR.'/components/com_dropeditor',null,true);

        // load constants and loader
        require_once(JPATH_ADMINISTRATOR . '/components/com_dropeditor/models/editor.php');     
        $model = new DropeditorModelEditor();

        return $model->buildEditor();
    }
    
    /**
	 * dropeditor - display the editor
	 *
	 * @param string The name of the editor area
	 * @param string The content of the field
	 * @param string The name of the form field
	 * @param string The width of the editor area
	 * @param string The height of the editor area
	 * @param int The number of columns for the editor area
	 * @param int The number of rows for the editor area
	 * @param mixed Can be boolean or array.
	 */
	function onDisplay( $name, $content, $width, $height, $col, $row, $buttons = true , $id = null, $asset = null, $author = null)
	{

		// Load modal popup behavior
		JHTML::_('behavior.modal', 'a.modal-button');
		JLoader::register('JavascriptHelper', JPATH_ADMINISTRATOR.'/components/com_dropeditor/helpers/javascriptHelper.php'); 
                JLoader::register('ckeditorHelper', JPATH_ADMINISTRATOR.'/components/com_dropeditor/helpers/ckeditorHelper.php');      	
                
		// initialise $error varable
		$errors = '';
		$loaded = false;

		if (empty($id))
		{
			$id = $name;
		}
				
		if(!$width)
			$width ="100%";
		if(!$height)
			$height ="450px";
		
		$skin = $this->params->get('skin');	
		
		if($skin == 'kama' && $width =='100%')
 			$width = '99%';
			
		$arributes = array("rows"=>$row, 'cols'=>$col, "style"=>"width:$width;height:$height");	

               //  var_dump($loaded);
                
                if( !$loaded )
		{
		  /* Generate the Output */
			$this->params->set('editorname',$id);
			
			if(!$this->params->get('hheight',''))
			{
				$this->params->set('hheight',$height);
			}
			if(!$this->params->get('wwidth',''))
			{
				$this->params->set('wwidth',$width);
			}
			JavascriptHelper::addHeadJavascript($this->params,$errors,$return_script);
				
			
			$loaded = ckeditorHelper::fixId($id);
			   
			if(!$return_script)
				return;

			//Here we will use JFCKJavascript output to screen //html element as well
			//jckimport('ckeditor.htmlwriter.helper');	
			return  ckeditorHelper::EditorTextArea($id,$name,$content,$buttons,$this,$arributes,$asset, $author);

		}//end if	
               // var_dump($loaded);
                $editor = '<label for="' . $id . '" style="display:none;" aria-visible="false">' . $id . '_textarea</label><textarea id="' . $id . '" name="' . $name . '" cols="' . $col . '" rows="' . $row . '" style="width:' . $width . ';height:' . $height . ';" class="dropEditor source" wrap="off">' . $content . '</textarea>';
                
                $editor .= '<script>window.addDomReadyEvent.add( function(){ 
			 
			CKEDITOR.on("instanceReady",function(evt)
			{
							
					
				if(evt.editor.name == "'.$loaded.'")
				{
								 
					var editor = CKEDITOR.replace( "'.ckeditorHelper::fixId($id).'", CKEDITOR.instances["'.$loaded.'"].config ); 
										
					
					var xtdbuttons = CKEDITOR.document.getById("editor-xtd-buttons");
					if(xtdbuttons)
					{                                                               
						buttonsHtml = xtdbuttons.getOuterHtml().replace(/'.$loaded.'/g,"'.ckeditorHelper::fixId($id).'");
						var buttonsElement = CKEDITOR.dom.element.createFromHtml(buttonsHtml); 
						editor.container.getParent().append(buttonsElement);
											
						var elements = buttonsElement.getElementsByTag("a");
													
						for(i= 0; i < elements.count();i++)
						{
							//override mootools model click event
							if(elements.getItem(i).hasClass("modal-button"))
							{
								(function()
								{
									var el = $(elements.getItem(i).$);
									el.addEvent("click", function(e) 
									{
										new Event(e).stop();
										SqueezeBox.fromElement(el,	{
																		parse: "rel"
																	});
									});
								})();
							}		
						}				
					}
				}	
				 
			})         
		});</script>';
                   
        	
                  
                return $editor;
                	
	}
        
        
    private function _displayButtons($name, $buttons, $asset, $author) {
        // Load modal popup behavior
       // JHTML::_('behavior.modal', 'a.modal-button');

        $args['name'] = $name;
        $args['event'] = 'onGetInsertMethod';

        $return = '';
        $results[] = $this->update($args);

        $version = new JVersion;
        $JOOMLA3 = (float) $version->RELEASE >= 3;

        foreach ($results as $result) {
            if (is_string($result) && trim($result)) {
                $return .= $result;
            }
        }

        if (is_array($buttons) || (is_bool($buttons) && $buttons)) {
            $results = $this->_subject->getButtons($name, $buttons, $asset, $author);

            /*
             * This will allow plugins to attach buttons or change the behavior on the fly using AJAX
             */
            $return .= "\n<div id=\"editor-xtd-buttons\"";

            if ($JOOMLA3) {
                $return .= " class=\"btn-toolbar pull-left\">\n\n<div class=\"btn-toolbar\"";
            }

            $return .= ">\n";

            foreach ($results as $button) {
                /*
                 * Results should be an object
                 */
                if ($button->get('name')) {
                    $modal = ($button->get('modal')) ? ' class="modal-button btn"' : '';
                    $href = ($button->get('link')) ? ' class="btn" href="' . JURI::base() . $button->get('link') . '"' : '';
                    $onclick = ($button->get('onclick')) ? ' onclick="' . $button->get('onclick') . '"' : ' onclick="IeCursorFix(); return false;"';
                    $title = ($button->get('title')) ? $button->get('title') : $button->get('text');

                    if ((float) $version->RELEASE < 3) {
                        $return .= '<div class="button2-left"><div class="' . $button->get('name') . '">';
                    }

                    $return .= '<a' . $modal . ' title="' . $title . '"' . $href . $onclick . ' rel="' . $button->get('options') . '">';
                    
                    // add icon class
                    if ($JOOMLA3) {
                        $return .= '<i class="icon-' . $button->get('name') . '"></i> ';
                    }
                    
                    $return .= $button->get('text') . '</a>';

                    if (!$JOOMLA3) {
                        $return .= '</div></div>';
                    }
                }
            }
            if ($JOOMLA3) {
                $return .= "</div>\n";
            }
            $return .= "</div>\n";
        }

        return $return;
    }

    	/**
	 * Get the editor content.
	 *
	 * @param   string  $id  The id of the editor field.
	 *
	 * @return  string
	 */
	public function onGetContent($id)
	{
		return "CKEDITOR.instances.$id.getData();\n";
	}

	public function onSetContent($editor, $html)
	{
		return 'CKEDITOR.instances.'.$editor.'.setData(' . $html . ');';
	}

}
