<?php
/** 
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// no direct access
defined('_JEXEC') or die;
class ckeditorHelper {
    protected static $profile;
    
    static function cleanString($str) {
        // remove any whitespace, and ensure all characters are alphanumeric
        $str = preg_replace(array('/\s+/', '/\[/', '/[^A-Za-z0-9_\-]/'), array('-', '_', ''), $str);
        // trim
        $str = trim($str);
        return $str;
    }

    static function fixId($id) {
        return ckeditorHelper::cleanString($id);
    }

    static function EditorTextArea($id, $name, $content, $buttons, $context, $arributes = array(), $asset = null, $author = null) {

        $html = ckeditorHelper::textarea($id, $name, $content, $arributes);

        $id = ckeditorHelper::fixId($id);
        $stylesSet = 'dropeditor:'. JUri::root().'media/dropeditor/dropeditor_styles.js';
        $editorProfile = self::getProfile();  
        $customConfig = "";       
        if($editorProfile && file_exists(JPATH_ROOT.'/media/dropeditor/config_p'.$editorProfile->id.'.js')) {
            $hash = md5( $editorProfile->params);
            $customConfig = JUri::root().'media/dropeditor/config_p'.$editorProfile->id.'.js?h='.$hash;
        }

        $document = JFactory::getDocument();
          //check if droptable, dropfile, droppic is installed then load buttons
        //$dropTableExist = self::checkComponentExist("com_droptables");       
        //$dropFilesExist = self::checkComponentExist("com_dropfiles");
        //$dropPicsExist = self::checkComponentExist("com_droppics");

        $document->addStyleSheet(JURI::root(true) . '/plugins/editors/dropeditor/ckeditor.css');
        $document->addStyleSheet('https://fonts.googleapis.com/css?family=Roboto');
        $document->addStyleSheet(JURI::root(true).'/components/com_dropeditor/assets/css/material-icons.css');

        // Get editor configuration
        $componentParams = JComponentHelper::getParams('com_dropeditor');
        $enable_tooltip = $componentParams->get('editor_tooltips', '1');
        $backColor = $componentParams->get('editor_back_color', '#f5f5f5');
        $iconColor = $componentParams->get('editor_icon_color', '#555d66');
        $iconSize = $componentParams->get('editor_icon_size', '20');
        $fontSize = $componentParams->get('editor_font_size', '12');
        $iconHover = $componentParams->get('editor_icon_hover_color', '#444444');
        $backHover = $componentParams->get('editor_back_hover_color', '#ffffff');
        $lineHeight = $iconSize + 6;
        $fontSize = $fontSize.'px';
        $iconSize = $iconSize.'px';
        $lineHeight = $lineHeight.'px';

        // Add tooltip
        if ($enable_tooltip) {
            $document->addScript(JURI::root(true).'/components/com_dropeditor/assets/js/tooltip.js');
        }
        // Add styles
        $document->addStyleDeclaration("
                        .cke_top {background: $backColor !important} 
                        .cke_button_icon {font-size: $iconSize !important;
                                          line-height: $iconSize !important;
                                          color: $iconColor !important}
                        .cke_button_label {color: $iconColor !important;
                                           line-height: $iconSize !important;
                                           font-size: $fontSize !important}
                        .cke_combo_text {color: $iconColor !important;
                                         line-height: $lineHeight !important;
                                         font-size: $fontSize !important}
                        .cke_combo_arrow {border-top-color: $iconColor !important}
                        .cke_button_arrow {border-top-color: $iconColor !important}
                        .cke_button_on {background: $backHover !important}
                        .cke_button_on * {color: $iconHover !important}
                        .cke_combo_on a {background: $backHover !important}
                        .cke_combo_on * {color: $iconHover !important}
                        .cke_combo_on .cke_combo_arrow,
                        .cke_button_on .cke_button_arrow {border-top-color: $iconHover !important}
                        .cke_button:hover,
                        .cke_combo_button:hover {background: $backHover !important}
                        .cke_button:hover *,
                        .cke_combo_button:hover * {color: $iconHover !important}
                        .cke_button:hover .cke_button_arrow {border-top-color: $iconHover !important}
                        .cke_combo_button:hover .cke_combo_arrow {border-top-color: $iconHover !important}
                        .cke_bottom {background: $backColor !important}
                        .cke_path_item, .cke_path_empty {color: $iconColor !important}");
        if ($iconSize == '32px') {
            $document->addStyleDeclaration("
                        a.cke_combo_button {line-height: $lineHeight !important}");
        }

        // Get info to set SCAYT state
        $input = JFactory::getApplication()->input;
        $comp = $input->get('option');
        $view = $input->get('view');
        $a_id = $input->getInt('id') ? $input->getInt('id') : $input->getInt('cid');
        $cookie_name = 'dropeditor_'.$comp.'_'.$view.'_'.$a_id.'_scayt';
        $scayt_cookie = 'false';
        if (isset($_COOKIE[$cookie_name])) {
            $scayt_cookie = $_COOKIE[$cookie_name];
        }

        $document->addScriptDeclaration(
                chr(13). ' window.addDomReadyEvent.add(function()
				{	
					CKEDITOR.config.expandedToolbar = true;
                    CKEDITOR.config.stylesSet = "'.$stylesSet.'";
                    CKEDITOR.replace( "'. $id.'", {customConfig: "'.$customConfig.'" } );
                    if (!'.$scayt_cookie.') {
                        CKEDITOR.config.disableNativeSpellChecker = false;
					    CKEDITOR.config.scayt_autoStartup = false;
                    } else {
                        CKEDITOR.config.disableNativeSpellChecker = true;
					    CKEDITOR.config.scayt_autoStartup = true;
                    }
				});'  );

        // Add style for menu panel (right-click on editor)
        $document->addScriptDeclaration("
            jQuery(document).ready(function ($) {
                if (typeof (CKEDITOR) !== 'undefined') {
                    CKEDITOR.on('instanceReady', function (e) {
                        var ed_id = Object.keys(CKEDITOR.instances)[0];
			            var editor = CKEDITOR.instances[ed_id];
			
			            // Register editor instance to Joomla core
			            Joomla.editors.instances[ed_id] = {
			                getValue: function () {
			                    return editor.getData();
			                },
			                setValue: function (text) {
			                    return editor.setData(text);
			                },
			                replaceSelection: function (text) {
			                    return editor.insertHtml(text);
			                },
			                id: ed_id,
			                instance: editor
			            }
            
                        $('.cke_button_icon ').text('');
                        
                        var editor = e.editor;
                        var setMenuStyle = function (env) {
                            var iFrame = (env.data[0] || env.data).element.getElementsByTag('iframe').getItem(0).getFrameDocument();
                            var custom_styles = iFrame.$.head.childNodes;
                            var custom_styles_head = null;
                            for (var i = 0; i < custom_styles.length; i++) {
                                if (custom_styles[i].id == 'custom_styles_head') {
                                    custom_styles_head = custom_styles[i];
                                }
                            }
                            
                            var newStyle = '.cke_menubutton_icon {background-color: $backColor}' +
                                '.cke_button_icon {color: $iconColor}' +
                                '.cke_menubutton:hover .cke_menubutton_icon {background-color: $backHover}' +
                                '.cke_menubutton:hover .cke_button_icon {color: $iconHover}';
                            if (!custom_styles_head) {
                                var newStyleTag = document.createElement('style');
                                newStyleTag.id = 'custom_styles_head';
                                newStyleTag.innerHTML = newStyle;
                                iFrame.$.head.appendChild(newStyleTag);
                            } else {
                                custom_styles_head.innerHTML = newStyle;
                            }
                        };
                        
                        var setPanelHeight = function (env) {
                            var comboPanel = (env.data[0] || env.data).element.$.className;
                            iFrame = (env.data[0] || env.data).element.getElementsByTag('iframe').getItem(0).getFrameDocument();
                            if (comboPanel.indexOf('cke_combopanel') > -1) {
                                panelHeight = iFrame.$.documentElement.offsetHeight;
                                if (panelHeight > 500) panelHeight = 500;
                                if (panelHeight < 50) panelHeight = 50;
                                thisElmID = (env.data[0] || env.data).element.$.id;
                                jQuery('#'+thisElmID).height(panelHeight);
                            }
                        };
                        
                        var scaytCookie = $scayt_cookie;
                        var setScaytState = function (env) {
                            iFrame = (env.data[0] || env.data).element.getElementsByTag('iframe').getItem(0).getFrameDocument();
                            scaytButton = iFrame.find('.cke_menubutton__scaytToggle');
                            if (scaytButton.$.length > 0) {
                                scaytButton.$[0].addEventListener('click', function () {
                                    if (!scaytCookie) {
                                        scaytCookie = !scaytCookie;
                                        createCookie('$cookie_name', 1, 365);
                                        jQuery('.cke_wysiwyg_frame').contents().find('.cke_editable').attr('spellcheck', false);
                                    } else {
                                        scaytCookie = !scaytCookie;
                                        createCookie('$cookie_name', 1, -10);
                                        jQuery('.cke_wysiwyg_frame').contents().find('.cke_editable').attr('spellcheck', true);
                                    }
                                })
                            }
                        }
                        
                        function createCookie(name,value,days) {
                            var expires = '';
                            var date = new Date();
                            date.setTime(date.getTime() + (days*24*60*60*1000));
                            expires = '; expires=' + date.toUTCString();
                            
                            document.cookie = name + '=' + value + expires + '; path=/';
                        };
            
                        editor.on('menuShow', setMenuStyle);
                        editor.on('panelShow', setPanelHeight);
                        editor.on('panelShow', setScaytState);
                        
                        editor.on('maximize', function () {
                            if (jQuery('#toolbar-apply').length > 0) {
                                css = jQuery('#toolbar-apply').css('position');
					            if (css !== 'fixed') {
					                jQuery('#toolbar-apply').css({
					                    'position': 'fixed',
					                    'top' : '10px',
					                    'right': '10px',
					                    'z-index': '9999'
					                });
					            } else {
					                jQuery('#toolbar-apply').css({
					                    'position': 'static',
					                    'top' : '',
					                    'right': '',
					                    'z-index': ''
					                });
					            }
					            editor.focus();
					            return false;
				            }
                        });
                    })
                }
            })");

        //set event handlers
        $args['name'] = $id;
        $args['event'] = 'onGetInsertMethod';

        $results[] = $context->update($args);

        foreach ($results as $result) {
            if (is_string($result) && trim($result)) {
                $html .= $result;
            }
        }

        //Get buttons
        if (!empty($buttons) || is_array($buttons) && !array_key_exists(0, $buttons)) {

            // Load modal popup behavior
            JHTML::_('behavior.modal', 'a.modal-button');

            $editor = JFactory::getEditor('dropeditor');

            $plugins = $editor->getButtons($id, $buttons, $asset, $author); 
            $buttons = '';
            $container = '';
            if (version_compare(JVERSION, '3.0', 'ge')) {
                $disableButtons = array("droppics","droptables","dropfiles");
                
                foreach ($plugins as $plugin) {
                    if(!in_array($plugin->name, $disableButtons )  ) {
                        
                        //if($dropPicsExist && $plugin->name == 'picture' && $plugin->text == JText::_('PLG_IMAGE_BUTTON_IMAGE') ) {
                           // continue;                        
                        //}
                        $className = ($plugin->get('modal')) ? "modal-button btn" : 'btn';
                        $url = ($plugin->get('link')) ? JURI::base() . $plugin->get('link') : '';
                        $click = ($plugin->get('onclick')) ? $plugin->get('onclick') : 'IeCursorFix(); return false;';
                        $options = $plugin->get('options');
                        $content = $plugin->get('text');
                        $buttonName = $plugin->get('name');
                        $content = '<i class="icon-' . $buttonName . '"></i>' . $content;
                        $linkAttributes = array("rel" => $options, 'onclick' => $click);
                        $buttons .= ckeditorHelper::link($url, $content, '', $className, $linkAttributes);
                    }
                }
                $innerContainer = ckeditorHelper::DivContainer($buttons, '', 'btn-toolbar');
                $container = ckeditorHelper::DivContainer($innerContainer, 'editor-xtd-buttons', 'btn-toolbar pull-left');
            } else {
                foreach ($plugins as $plugin) {
                    $className = ($plugin->get('modal')) ? "modal-button" : '';
                    $url = ($plugin->get('link')) ? JURI::base() . $plugin->get('link') : '';
                    $click = ($plugin->get('onclick')) ? $plugin->get('onclick') : '';
                    $options = $plugin->get('options');
                    $content = $plugin->get('text');
                    $buttonName = $plugin->get('name');
                    $buttons .= ckeditorHelper::buttonModalLink($url, $content, $options, $buttonName, $className, $click, array("class" => "button2-left"));
                }
                $container = ckeditorHelper::DivContainer($buttons, 'editor-xtd-buttons');
            }
            $html .= $container;
        }

        return $html;
    }
    
    static function _HtmlElement($tagName,$id,$name = '',$content = '',$attributes = array())
	{
		$attributes["id"] = ckeditorHelper::fixId($id);
		if($name)
			$attributes["name"] = $name;
			$attrStr = "";
		if(!empty($attributes))
			$attrStr = JArrayHelper::toString( $attributes);
		$html = chr(13) . "<$tagName $attrStr>$content</$tagName>";
		return $html;
	}
	
	static function textarea($id,$name,$content = '',$attributes = array())
	{
      
		if(!isset($attributes["cols"]) || !$attributes["cols"])
			$attributes["cols"] = "75";
		
		if(!isset($attributes["rows"]) || !$attributes["rows"])
			$attributes["rows"] = "30";		
			
		if(!isset($attributes['style']))
			$attributes["style"] = "width:100%; height:450px;";	
			
		$html = ckeditorHelper::_HtmlElement('textarea',$id,$name,$content,$attributes);
		
		return $html;
		 
	}


	static function DivContainer($content = '',$id = '',$className = '',$attributes = array())
	{
	   
	   if($id ) 
			$attributes["id"] = $id ;
	   if($className) 
			$attributes["class"] = $className;
	   
	   
	   return ckeditorHelper::_HtmlElement('div',$id,'',$content,$attributes);
	   
	}


	static function link($url,$content,$id = '', $className = '', $attributes = array())
	{
		$attributes["href"] = $url;
		if($className) 
			$attributes["class"] = $className;
		
		 return ckeditorHelper::_HtmlElement('a',$id,'',$content,$attributes);
	}
	
	static function buttonModalLink($url,$content,$options,$name,$className='',$click='',$attributes = array())
	{
		$linkAttributes["rel"] = $options;
		if($click)
			$linkAttributes["onclick"] = $click;
						
		$link = ckeditorHelper::link($url,$content,'',$className,$linkAttributes);
		$container = ckeditorHelper::DivContainer($link,'',$name);
		return ckeditorHelper::DivContainer($container,'','',$attributes);
	}

    static function checkComponentExist($option) {
        $dbo = JFactory::getDbo();
        $query = 'SELECT extension_id FROM #__extensions WHERE element=' . $dbo->quote($option) . ' AND type="component" AND enabled=1';
        if (!$dbo->setQuery($query)) {
            return false;
        }
        if (!$dbo->query()) {
            return false;
        }
        $component = $dbo->loadResult();
        if (!$component) {
            return false;
        }

        return true;
    }
    
    static function getProfile() {
        if (!empty(self::$profile)) {
             return self::$profile;
        }

        $db = JFactory::getDBO();
        $user = JFactory::getUser();
        $option = JRequest::getCmd('option', '');

        $query = $db->getQuery(true);

        // Select the required fields from the table.
        $query->select(
             'a.* '
        );
        $query->from('#__dropeditor_profiles AS a');
        $query->where('a.state = 1' );
        $query->order('a.ordering');
         $db->setQuery($query);
        $profiles = $db->loadObjectList();
        if ($option == 'com_dropeditor') {

        }

        $keys = $user->getAuthorisedGroups();
        foreach ($profiles as $item) {
            // at least one user group or user must be set
            if ( empty($item->usergroups)) {
                continue;
            }

            // check user groups - a value should always be set
            $groups = array_intersect($keys, explode(',', $item->usergroups));

            // user not in the current group...
            if (empty($groups)) {
                    continue;
            }

            // check component
            if ($item->components && in_array($option, explode(',', $item->components)) === false) {
                continue;
            }

            // assign item to profile
            self::$profile = $item;

            // return
            return $item;
        }

        return null;
    }
        
    static function getExtraPlugins($params) {
        $rows = array();

        $registry = new JRegistry;
        $registry->loadString($params);
        $params = $registry->toArray();
        if ($params && isset($params['buttons'])) {
            $buttons = $params['buttons'];
            if ($buttons) {
                $rows = json_decode($buttons, true);
            }
        }
        $allButtons = implode(',', $rows);
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select('a.name');
        $query->from('#__dropeditor_plugins AS a');
        $query->where('a.id IN (' . $allButtons . ')');
        $query->where('a.published=1');
        $query->where('a.iscore=0');
        $query->where('a.type="plugin"');
        $query->order('a.row, a.id');
        $db->setQuery($query);
        $rows = $db->loadColumn();

        $query = $db->getQuery(true);
        $query->select('b.name');
        $query->from('#__dropeditor_plugins AS a');
        $query->leftJoin('#__dropeditor_plugins AS b ON b.id= a.parentid');
        $query->where('a.id IN (' . $allButtons . ')');
        $query->where('b.published=1');
        $query->where('b.iscore=0');
        $query->where('b.type="plugin"');
        $db->setQuery($query);
        $rows2 = $db->loadColumn();

        return implode(",", array_unique( array_merge($rows, $rows2)) );
    }

    static function getPluginButtons() {
    	$rows = array();
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('a.*');
        $query->from('#__dropeditor_plugins AS a');
        $query->where('a.published=1');
        $query->order('a.row, a.id');

        $db->setQuery($query);
        $rows = $db->loadObjectList('id');

        return $rows;
    }
    
    static function writeProfileConfig($data) {
        $pid = $data['id'];
        $rows = array();
        if(isset($data['buttons']) && !empty($data['buttons'])){
            $rows = json_decode($data['buttons'], true);
        }

        $spacer = '-1';
        $config = "CKEDITOR.editorConfig = function( config ){" . "\n";
        $config .= "config.toolbar_".$pid ." = [". "\n";
        $config .= "['Droppics'],['Dropfiles' ] ,['Droptables'],". "\n"; 
        $allButtons = self::getPluginButtons();

        for($i=0;$i< count($rows); $i++) {
            $config .= "'/',". "\n"; //new toolbar row
            if(!empty($rows[$i])) {
                $groups = explode($spacer,$rows[$i]);
                $groupItems = "";
                for($j=0; $j< count($groups); $j++) {
                    $group = $groups[$j];
                    $groupItems .= "{name: '".$i.$j."', items: [" ;
                    $buttons = explode(",",$group);
                    $buttonNames = array();
                    for($k=0; $k < count($buttons); $k++) {
                        if($buttons[$k] != "" ) {
                            if($allButtons[$buttons[$k]]->type=='plugin') {
                                $buttonNames[] = "'". ucfirst($allButtons[$buttons[$k]]->title) ."'";
                            }else {
                                $buttonNames[] = "'". ucfirst($allButtons[$buttons[$k]]->name) ."'";
                            }
                        }
                    }
                    
                    $groupItems .= implode(",",$buttonNames);
                    $groupItems .= "]}," . "\n";
                }
                $config .= $groupItems . "\n";
            }
        }
        
        $config .= "];". "\n";
        $config .= "config.removeButtons = 'About,Anchor';". "\n";
        $config .= "config.format_tags = 'p;h1;h2;h3;pre';". "\n";
        $config .= "config.removeDialogTabs = 'image:advanced;link:advanced'". "\n";;
        $config .= "config.allowedContent = true;". "\n";
		$config .= "config.entities = false;". "\n";		
		$config .= "config.skin = 'material';". "\n";
		$config .= "config.pasteFromWordRemoveStyles = false;". "\n";
		$config .= "config.pasteFromWordRemoveFontStyles = false;". "\n";
        $config .= "};" . "\n";
        $config .= 'CKEDITOR.dtd.$removeEmpty["i"] = false;' . "\n";
		$config .= 'CKEDITOR.dtd.$removeEmpty["span"] = false;';

        $file = JPATH_SITE . '/media/dropeditor/config_p'. $pid. '.js';
        if (!JFile::write($file, $config))
        {
             JFactory::getApplication()->enqueueMessage(JText::_('COM_DROPEDITOR_ERROR_WRITE_CONFIG_FAILED'), 'error');
             return;
        }
    }

}
