<?php
/** 
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

class JavascriptHelper {
    
    static function addHeadJavascript(&$params,&$errors,&$excludeEventHandlers)
	{
		global $option;	

		//lets get JS object
		$document = JFactory::getDocument();
		//now Add intialisation scripts
		
		$app = JFactory::getApplication();
		$path_root = '../';
		
		if($app->isSite())
			$path_root = '';

		jimport('joomla.environment.browser');
		$instance	= JBrowser::getInstance();
		$language	= JFactory::getLanguage();

		if ($language->isRTL()) {
			$direction = 'rtl';
		} else {
			$direction = 'ltr';
		}
		
		/* Load the CK's Parameters */
	
		$skin				= 	$params->def( 'skin', 'office2007' );
		$hheight			= 	$params->def( 'hheight', 500 );
		$wwidth				= 	$params->def( 'wwidth', '100%' );
		$lang_mode			= 	$params->def( 'lang_mode', 1 );
		$lang				= 	$params->def( 'lang_code', 'en' );
		$entermode 			= 	$params->def( 'entermode', 1 );
		$shiftentermode 	= 	$params->def( 'shiftentermode', 2 );
		$uicolor 			= 	$params->def( 'uicolor', '#D6E6F4' );
		$imagepath			=   $params->def( 'magePath','images/stories');
		$returnScript 		= 	$params->get( 'returnScript', true );
		$editorname 		= 	$params->get( 'editorname');
		$bgcolor			= 	$params->get( 'bgcolor','#ffffff');
		$ftcolor			= 	$params->get( 'ftcolor','');
		$textalign			= 	$params->get( 'textalign',0);
		$entities			= 	$params->get( 'entities',0);
		$formatsource		= 	$params->get( 'formatsource',1);
		$minify		        = 	$params->get( 'minify',1);

		$excludeEventHandlers	= $returnScript;

		$hheight = (int)$hheight - 50; //toolbar height

		// If language mode set 
		
	    // set default Joomla language setting
		switch ($lang_mode) {
			case 0:
				$AutoDetectLanguage = 	$lang; // User selection
				break;
			case 1:
				$AutoDetectLanguage = 	""; // Joomla Default
				$lang = substr( $language->getTag(), 0, strpos( $language->getTag(), '-' ) ); //access joomlas global configuation and get the language setting from there
				break;
			case 2:
			    $AutoDetectLanguage = 	""; // Browser default
				$lang = "";
	            break;
		}

		$params->set('JoomlaLang',$lang);
		
		if($textalign)
			$textalign = "text-align:$textalign;";
		else
			$textalign = "";

        $editorProfile = ckeditorHelper::getProfile();
        $profile_params = json_decode($editorProfile->params);

        if (isset($profile_params->editor_fheight)){
            $editorFullHeight = $profile_params->editor_fheight;
        }
        else {
            $editorFullHeight = 0;
        }

        if(!empty($editorProfile)){
            $toolbar = $editorProfile->id; // "Basic" ; //
            $extraPlugins = ckeditorHelper::getExtraPlugins($editorProfile->params);  
            $extraPlugins .= ",panelbutton,iframedialog,codemirror,customlist,font,link,droptables,dropfiles,droppics";        
        }else{
            $extraPlugins = "panelbutton,iframedialog,codemirror,customlist,font,link";        
        }

        $removedPlugins = "magicline";
        $dropTableExist = ckeditorHelper::checkComponentExist("com_droptables");
        $dropFilesExist = ckeditorHelper::checkComponentExist("com_dropfiles");
        $dropPicsExist = ckeditorHelper::checkComponentExist("com_droppics");

        $registry = new JRegistry;
        $registry->loadString(@$editorProfile->params);
        $profile_params = $registry->toArray();
        $removeButtons = array();
        if(!$dropPicsExist || (isset($profile_params['droppics_button']) && !$profile_params['droppics_button'])  ) {
           $removeButtons[] = "Droppics";
        }
        if(!$dropFilesExist || (isset($profile_params['dropfiles_button']) && !$profile_params['dropfiles_button']) ) {
           $removeButtons[] = "Dropfiles";
        }
        if(!$dropTableExist || (isset($profile_params['droptables_button']) && !$profile_params['droptables_button']) ) {
           $removeButtons[] = "Droptables";
        }

        $registry = new JRegistry;
        $file = JPATH_SITE . '/media/dropeditor/config.json';
        $registry->loadFile($file);
        $stylesSet = 'dropeditor:'. JUri::root().'plugins/editors/dropeditor/ckeditor/styles_dropeditor.js';
        $dropStyles = JUri::root().'plugins/editors/dropeditor/dropeditor.css';
        $customStyles = JUri::root().'media/dropeditor/customstyles.css';
        $titleStyle = JUri::root().'media/dropeditor/titlestyles.css';
        $componentParams = JComponentHelper::getParams('com_dropeditor');
        $defaultColor = $componentParams->get('default_color','#333333');   
        
        $o_params = json_decode(@$editorProfile->params);

        $toolbar_rows = json_decode($o_params->buttons, true);
        $toolbar_rows_count = count($toolbar_rows) ;
        if( count($removeButtons) <3) { $toolbar_rows_count++; }

        $custom_font_colors = 0;
        if(isset($o_params->custom_font_colors)) $custom_font_colors = $o_params->custom_font_colors;
        $listcolors = array();
        if(!empty($o_params->listcolors)) $listcolors = $o_params->listcolors;
        if(!empty($o_params->ggfonts)){
            $font_js = json_encode((array)$o_params->ggfonts);
        }else{
            $font_js = '[]';
        }
        
		$document->addScriptDeclaration(
		"
			
            ". self::addDomReadyEventHandler() .
            " 
                 window.addDomReadyEvent.add(function() 
			{
			
				CKEDITOR.on('instanceCreated',function(evt)
				{
					 var editor = evt.editor;
					 var extenConfig = ".$registry->toString(). ";  
                         custom_font_colors = ".$custom_font_colors.";
                         droplistcolors = '".json_encode($listcolors)."';
                     if(".$editorFullHeight."){
                         extenConfig.height = window.screen.availHeight - 220 - ". ($toolbar_rows_count*30). ";
                     }
                     else{
                        extenConfig.height =" . $hheight . ";
                     }
                     
                     extenConfig.extraPlugins = '".$extraPlugins."' ;    
                     extenConfig.removePlugins = '".$removedPlugins."' ;
                     extenConfig.removeButtons = '". implode(",", @$removeButtons) ."' ;                                               
                     extenConfig.styleSet = '". $stylesSet. "' ;
                     extenConfig.contentsCss =  ['".$dropStyles."','".$customStyles."','".$titleStyle."'] ;
                     extenConfig.toolbar = '". @$toolbar . "';
                     extenConfig.language = '". $lang . "';
                     editor.on( 'customConfigLoaded', function()
					 {
						 CKEDITOR.tools.extend( editor.config,extenConfig, true );
                         CKEDITOR.addCss( '[class^=\"drop-\"] > li:before, [class*=\" drop-\"] > li:before { color: ". $defaultColor. "; }');
                         CKEDITOR.addCss( 'ol.ol-circles > li:before { background-color: ". $defaultColor.";}' ) ;
                         CKEDITOR.addCss( 'ol.ol-boxes > li:before { background-color: ". $defaultColor.";}' ) ;
                         dropggfonts = $font_js;

                         CKEDITOR.config.gfont_names = '';

                         for(var i = 0; i<dropggfonts.length; i++){
                             CKEDITOR.config.gfont_names = CKEDITOR.config.gfont_names+';'+dropggfonts[i];
                             dropggfonts[i] = 'http://fonts.googleapis.com/css?family='+dropggfonts[i].replace(' ','+');
                         }

                        editor.config.contentsCss = editor.config.contentsCss.concat(dropggfonts);
					 });
				});
			});
        ");
		
        //set session
        $clientid = $app->getClientId(); 
        $_GET['client'] = $clientid;

		return true;
	}

	static function addDomReadyEventHandler()
	{
        return "
		if (typeof DropEvent == 'undefined') 
		{
			
			var DropEvent = {};
			
			DropEvent.domReady = {
			  add: function(fn) {
				
				
				if (DropEvent.domReady.loaded) return fn();
				
		
				var observers = DropEvent.domReady.observers;
				if (!observers) observers = DropEvent.domReady.observers = [];
				observers[observers.length] = fn;
		
				if (typeof DropEvent.domReady.callback != 'undefined') return;
		
				DropEvent.domReady.callback = function() {
				  if (DropEvent.domReady.loaded) return;
				  
				  DropEvent.domReady.loaded = true;
				  if (DropEvent.domReady.timer) {
					clearInterval(DropEvent.domReady.timer);
					DropEvent.domReady.timer = null;
				  }
				 
				  var observers = DropEvent.domReady.observers;
				  for (var i = 0, length = observers.length; i < length; i++) {
					var fn = observers[i];
					observers[i] = null;
					fn(); // make 'this' as window
				  }
				  DropEvent.domReady.callback = DropEvent.domReady.observers = null;
				};
		
			
				var ie = !!(window.attachEvent && !window.opera);
				var webkit = navigator.userAgent.indexOf('AppleWebKit/') > -1;
				
				if (document.readyState && webkit) {
				  
				  // Apple WebKit (Safari, OmniWeb, ...)
				  DropEvent.domReady.timer = setInterval(function() {
					var state = document.readyState;
					if (state == 'loaded' || state == 'complete') {
					  DropEvent.domReady.callback();
					}
				  }, 50);
				  
				} else if (document.readyState && ie) {
				  
		
                // Windows IE 
				  if (window.attachEvent) {
					window.attachEvent('onload', DropEvent.domReady.callback)
				  }
				  else
				  {
				  var src = (window.location.protocol == 'https:') ? '://0' : 'javascript:void(0)';
				  document.write(
					'<script type=\"text/javascript\" defer=\"defer\" src=\"' + src + '\" ' + 
					'onreadystatechange=\"if (this.readyState == \'complete\') DropEvent.domReady.callback();\"' + 
					'><\/script>');
				  }
				  
				} else {
				  
				  if (window.addEventListener) {
					// for Mozilla browsers, Opera 9
					document.addEventListener(\"DOMContentLoaded\", DropEvent.domReady.callback, false);
					// Fail safe 
					window.addEventListener(\"load\", DropEvent.domReady.callback, false);
				  } else if (window.attachEvent) {
					window.attachEvent('onload', DropEvent.domReady.callback);
				  } else {
					// Legacy browsers (e.g. Mac IE 5)
					var fn = window.onload;
					window.onload = function() {
					  DropEvent.domReady.callback();
					  if (fn) fn();
					}
				  }
				  
				}
				
			  }
			}
		
			window.addDomReadyEvent = {};
			if(typeof window.addDomReadyEvent.add == 'undefined')
				window.addDomReadyEvent.add = DropEvent.domReady.add;
		}; ";
	}

	static function setContent($editor,$html)
	{
	 	return "CKEDITOR.tools.setData('$editor',$html);";
	}
	 
	static function getContent($editor)
	{
		return "CKEDITOR.tools.getData('$editor');";
	}
} 
