<?php

/**
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */
defined('_JEXEC') or die;

jimport('joomla.application.component.modeladmin');

//jimport('joomla.access.access');

class DropeditorModelEditor extends JModelAdmin {

    /**
     * Profile object
     *
     * @var    object
     */
    private $profile = null;

    /**
     * Array of linked scripts
     *
     * @var    array
     */
    protected $scripts = array();

    /**
     * Array of linked style sheets
     *
     * @var    array
     */
    protected $stylesheets = array();

    /**
     * Array of included style declarations
     *
     * @var    array
     */
    protected $styles = array();

    /**
     * Array of scripts placed in the header
     *
     * @var    array
     */
    protected $javascript = array();

    /**
     * Constructor.
     *
     * @param   array  $config  An optional associative array of configuration settings.
     *
     * @see     JModelLegacy
     * @since   12.2
     */
    public function __construct($config = array()) {
        
    }

    function buildEditor() {
        $this->addScript(JURI::root(true) . '/plugins/editors/dropeditor/ckeditor/ckeditor.js');
        
	    $this->addScriptDeclaration(
			"function jInsertEditorText( text,editor) {
                           
			    if(oEditor) 
                            {
                                if (CKEDITOR.env.ie && CKEDITOR.env.version > 10 && oEditor.ie11_bookmarks)
                                    oEditor.setBookmarks(oEditor.ie11_bookmarks);
                                                    oEditor.insertHtml( text ); 
                            }
			else
                        {
				var oEditor = CKEDITOR.instances[editor];
                        if (CKEDITOR.env.ie && CKEDITOR.env.version > 10 && oEditor.ie11_bookmarks)
                        oEditor.setBookmarks(oEditor.ie11_bookmarks);
                        oEditor.insertHtml( text );
                     }
                     
                     var ckDialog = window.CKEDITOR.dialog.getCurrent();                   
                     if(ckDialog) {                    
                         ckDialog.hide();
                      }
		}");
                
        $this->addScriptDeclaration( chr(13). '  CKEDITOR.config.baseHref = "'.JURI::root(). '";' .  chr(13) );    
		$this->addScriptDeclaration( chr(13). '  CKEDITOR.config.jBaseHref = "'.JURI::base(). '";' .  chr(13) );		
        $this->addScriptDeclaration( chr(13). '  function IeCursorFix() { return true; } '.  chr(13) );
		$this->addScriptDeclaration( chr(13). '  var ckToken = "' . JSession::getFormToken(). '"; ' .  chr(13) );
        $this->addScriptDeclaration( chr(13). '  var ckPath = "' .  $path = urlencode(JURI::root(true)) . '"; ' .  chr(13) );

        return $this->getOutput();
    }

    function checkComponentExist($option) {
        $dbo = JFactory::getDbo();
        $query = 'SELECT extension_id FROM #__extensions WHERE element=' . $dbo->quote($option) . ' AND type="component"';
        if (!$dbo->setQuery($query)) {
            return false;
        }
        if (!$dbo->execute()) {
            return false;
        }
        $component = $dbo->loadResult();
        if (!$component) {
            return false;
        }

        return true;
    }

    private function getOutput() {
        $document = JFactory::getDocument();

        $end = $document->_getLineEnd();
        $tab = $document->_getTab();

        $output = '';

        foreach ($this->stylesheets as $stylesheet) {

            $output .= $tab . '<link rel="stylesheet" href="' . $stylesheet . '" type="text/css" />' . $end;
        }

        foreach ($this->scripts as $script) {

            $output .= $tab . '<script data-cfasync="false" type="text/javascript" src="' . $script . '"></script>' . $end;
        }

        foreach ($this->javascript as $script) {
            $output .= $tab . '<script data-cfasync="false" type="text/javascript">' . $script . '</script>' . $end;
        }

        foreach ($this->styles as $style) {
            $output .= $tab . '<style type="text/css">' . $style . '</style>' . $end;
        }

        return $output;
    }


    private function addScript($url) {
        $this->scripts[] = $url;
    }

    private function addStyleSheet($url) {
        $this->stylesheets[] = $url;
    }

    private function addScriptDeclaration($text) {
        $this->javascript[] = $text;
    }

    private function addStyleDeclaration($text) {
        $this->styles[] = $text;
    }

    public function getForm($data = array(), $loadData = true) {
        
    }

}
