<?php

/**
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */
// No direct access.
defined('_JEXEC') or die;

jimport('joomla.application.component.modeladmin');

/**
 * Seoglossary model.
 */
class DropeditorModelGgfonts extends JModelAdmin {

    /**
     * @var		string	The prefix to use with controller messages.
     * @since	1.6
     */
    protected $text_prefix = 'COM_DROPEDITOR';

    public function getForm($data = array(), $loadData = true) {
        
    }
    
    public function get_profiles_params($profiles_id) {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('params');
        $query->from('#__dropeditor_profiles');
        $query->where($db->quoteName('id').'='.$db->quote($profiles_id));
        $db->setQuery($query);
        $res = $db->loadObject();
        if(!empty($res)){
            $params = json_decode($res->params);
        }else{
            $params = '';
        }
        return $params;
    }
    
    public function updateggfonts($profiles_id,$font_family,$type) {
        if(!empty($profiles_id)){
            $db = JFactory::getDbo();
            $params = $this->get_profiles_params($profiles_id);
            if(isset($type) && $type == 'add'){
                if(!empty($params->ggfonts) && is_array((array)$params->ggfonts)){
                    $ggfonts = (array)$params->ggfonts;
                    if(in_array($font_family, $ggfonts) == false){
                        $ggfonts[] = $font_family;
                    }
                }else{
                    $ggfonts = array($font_family);
                }
            }else{
                $ggfonts = (array)$params->ggfonts;
                $key = array_search($font_family,$ggfonts);
                if(in_array($font_family, $ggfonts)) unset($ggfonts[$key]);
            }
            
            $params->ggfonts = array_values($ggfonts);

            $query = $db->getQuery(true);
            $fields = array(
                $db->quoteName('params') . ' = ' . $db->quote(json_encode($params))
            );

            $query->update($db->quoteName('#__dropeditor_profiles'))->set($fields)->where($db->quoteName('id').'='.$db->quote($profiles_id));
            $db->setQuery($query);
            $result = $db->execute();
            return true;
        }else{
            return false;
        }
    }
    
    public function updatecolor($profiles_id,$color,$type) {
        if(!empty($profiles_id)){
            $db = JFactory::getDbo();
            $params = $this->get_profiles_params($profiles_id);
            if(isset($type) && $type == 'add'){
                if(!empty($params->listcolors) && is_array((array)$params->listcolors)){
                    $listcolors = (array)$params->listcolors;
                    if(in_array($color, $listcolors) == false){
                        $listcolors[] = $color;
                    }
                }else{
                    $listcolors = array($color);
                }
            }else{
                $listcolors = (array)$params->listcolors;
                $color_remove = explode(',', $color);
                if(!empty($color)){
                    $listcolors = array_diff($listcolors,$color_remove);
                }
            }
            
            $params->listcolors = array_values($listcolors);

            $query = $db->getQuery(true);
            $fields = array(
                $db->quoteName('params') . ' = ' . $db->quote(json_encode($params))
            );

            $query->update($db->quoteName('#__dropeditor_profiles'))->set($fields)->where($db->quoteName('id').'='.$db->quote($profiles_id));
            $db->setQuery($query);
            $result = $db->execute();
            return $params->listcolors;
        }else{
            return false;
        }
    }
    
    public function viewpage($current_page, $link , $count_page,$keyword) {
        if(!empty($keyword)){
            $keyw = '&keyword='.$keyword;
        }else{
            $keyw = '';
        }
        
        if ($current_page > $count_page)
            $current_page = $count_page;
        if ($current_page < 1)
            $current_page = 1;
        $begin = $current_page - 4;
        $end = $current_page + 4;
        if ($begin < 1) {
            $begin = 1;
            $end = $begin + 8;
        }
        if ($end > $count_page) {
            $end = $count_page;
            $begin = $end - 8;
        }
        if ($begin < 1)
            $begin = 1;
        
        $html = '<div class="pagination pagination-toolbar">';
        $html .= '<ul class="pagination-list">';
        $previous = $current_page - 1;
        if ($current_page > 1){
            $html.= '<li><a class="hasTooltip" href="'.$link.'1'.$keyw.'" data-original-title="Start"><span class="icon-first"></span></a></li>';
            $html.= '<li><a class="hasTooltip" href="' . $link . $previous . $keyw . '" data-original-title="Previous"><span class="icon-previous"></span></a></li>';
        }else{
            $html.= '<li class="disabled"><a><span class="icon-first"></span></a></li>';
            $html.= '<li class="disabled"><a><span class="icon-previous"></span></a></li>';
        }
        
        for ($i = $begin; $i <= $end; $i++) {
            if ($current_page == $i){
                $html.= '<li class="active hidden-phone"><a href="' . $link . $i . $keyw . '">' . $i . '</a></li>';
            }else{
                $html.= '<li class="hidden-phone"><a href="' . $link . $i . $keyw . '">' . $i . '</a></li>';
            }
        }
        $next = $current_page + 1;
        if ($current_page < $count_page){
            $html.= '<li><a class="hasTooltip" href="' . $link . $next . $keyw . '" data-original-title="Next"><span class="icon-next"></span></a></li>';
            $html.= '<li><a class="hasTooltip" href="' . $link . $count_page . $keyw . '" data-original-title="End"><span class="icon-last"></span></a></li>';
        }else{
            $html.= '<li class="disabled"><a class="hasTooltip" data-original-title="Next"><span class="icon-next"></span></a></li>';
            $html.= '<li class="disabled"><a class="hasTooltip" data-original-title="End"><span class="icon-last"></span></a></li>';
        }
        $html.='</ul>';
        $html.='</div>';
        return $html;
    }
}
