<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_dropeditor
 *
 * @copyright   Copyright (C) 2005 - 2014 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class DropeditorModelMedia extends JModelAdmin
{
	/**
	 * Method to get form
	 */
	public function getForm( $data = array(), $loadData = true ) {
		$form = $this->loadForm('com_dropeditor.media', 'style', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)) {
			return false;
		}

		// Add media field
		$xml = new SimpleXMLElement('<fieldset><field name="dropmediaThumbnail" type="media" description="'. JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_THUMBNAIL_DESC') .'" label="'. JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_THUMBNAIL_LABEL') .'" /></fieldset>');
		$form->setField($xml);
		return $form;
	}

	/**
	 *  Method to get list media file and folder
	 */
	public function getList($type = '', $current = '', $parent = '') {
		$paramsmedia = JComponentHelper::getParams('com_media');
		if(!defined('COM_MEDIA_BASE')){
			define('COM_MEDIA_BASE',	JPATH_ROOT.'/'.$paramsmedia->get('file_path', 'images'));
		}
		$currentPath = ((strlen($parent) > 0) ? $parent : '') . ((strlen($current) > 0) ? '/' . $current : '');
		$basePath  = COM_MEDIA_BASE . '/' . $currentPath;
		$fileList = ''; $folderList = ''; $list = array();
		$validVideoExt = array('3gp', '3g2', 'mp4', 'flv', 'avi', 'm4v', 'mov', 'mpg', 'swf', 'wmv', 'mkv', 'webm', 'ogg');
		$validAudioExt = array('mp3', 'wma', 'wav', 'mpa', 'm4a', 'mid', 'midi');

		if (file_exists($basePath)) {
			// Get the list of files and folders from the given folder
			$fileList   = JFolder::files($basePath);
			$folderList = JFolder::folders($basePath);
		} else {
			return false;
		}

		if ($folderList) {
			foreach ($folderList as $folder) {
				$folderData = array();
				$folderData['text'] = $folder;
				$folderData['parentPath'] = $currentPath;
				$folderData['type'] = 'folder';
				$folderData['children'] = true;

				array_push($list, $folderData);
			}
		}

		if ($fileList) {
			foreach ($fileList as $file) {
				$ext = JFile::getExt($file);
				if ($type == 'video') {
					if ( preg_grep( '/' . $ext . '/i', $validVideoExt ) ) {
						$fileData['text'] = $file;
						$fileData['parentPath'] = $currentPath;
						$fileData['type'] = 'video';

						array_push($list, $fileData);
					}
				} elseif ($type == 'sound') {
					if ( preg_grep( '/' . $ext . '/i', $validAudioExt ) ) {
						$fileData['text'] = $file;
						$fileData['parentPath'] = $currentPath;
						$fileData['type'] = 'sound';

						array_push($list, $fileData);
					}
				}
			}
		}

		return $list;
	}
}