<?php
/** 
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


defined('_JEXEC') or die;


class DropeditorViewBulleted extends JViewLegacy
{
	
	protected $state;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
        $this->canDo = DropeditorHelper::getActions();
        $this->params = $params = JComponentHelper::getParams('com_dropeditor');

        JFactory::getApplication()->setUserState('list.limit', 100000);
        $document = JFactory::getDocument();
        $document->addStyleSheet(JURI::root().'plugins/editors/dropeditor/dropeditor.css');
        $document->addStyleSheet(JURI::root().'components/com_dropeditor/assets/css/bullets-editor.css');
        $document->addScript(JURI::root().'components/com_dropeditor/assets/js/jquery.ddslick.min.js');
        $document->addScript(JURI::root().'components/com_dropeditor/assets/js/dropeditor-bulleted.js');

        $modelButton = $this->getModel('bulleted');
        $this->bulleteds = $modelButton->getItems();

        $this->setLayout(JRequest::getCmd('layout','default'));
		parent::display($tpl);
                
        $app = JFactory::getApplication();
        if($app->isAdmin()){
            $this->addToolbar();
        }
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{

		$canDo	= DropeditorHelper::getActions();

		JToolBarHelper::title(JText::_('COM_DROPEDITOR_MAIN_PAGE'), 'dropeditor.png');

		$toolbar = JToolBar::getInstance();		
		
		if ($canDo->get('core.admin')) {
			$toolbar->appendButton( 'popup', 'support', JText::_('COM_DROPTABLE_VIEW_SUPPORT'), 'index.php?option=com_dropeditor&view=support&tmpl=component', 700, 600,0,0 );
			JToolBarHelper::preferences('com_dropeditor');
		}

		JToolBarHelper::divider();
	}
}
