<?php
/** 
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


defined('_JEXEC') or die;


class DropeditorViewButtons extends JViewLegacy
{
	
	protected $state;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
        $this->canDo = DropeditorHelper::getActions();
        $this->params = $params = JComponentHelper::getParams('com_dropeditor');

        JFactory::getApplication()->setUserState('list.limit', 100000);
        $document = JFactory::getDocument();
        $document->addStyleSheet(JURI::root().'plugins/editors/dropeditor/dropeditor.css');
        $document->addStyleSheet(JURI::root().'components/com_dropeditor/assets/css/button-editor.css');
        $document->addScript(JURI::root().'components/com_dropeditor/assets/js/button-editor.js');

        $modelButton = $this->getModel('button');
        $this->buttons = $modelButton->getItems();

        $menu = JMenu::getInstance('site');
        $menuElems = JHtml::_('menu.menuitems', array('published' => 1));
        $generatedMenuElems = array();
        foreach ($menuElems as $menuElem) {
            $elemObj = new stdClass();
            $elemObj->text = $menuElem->text;
            if (isset($menuElem->disable)) {
                $elemObj->disable = $menuElem->disable;
            }
            $parts = explode('.', $menuElem->value);
            if (count($parts) > 1) {
                $route = $menu->getItem($parts[count($parts) - 1]);
                if ($route) {
					if($route->type=='url') {
                        $elemObj->value = $route->link ;
                    }else {
                        $elemObj->value = $route->link . '&Itemid=' . $parts[count($parts) - 1];
                    }
                } else {
                    $elemObj->value = $menuElem->value;
                }
            } else {
                $elemObj->value = $menuElem->value;
            }
            $generatedMenuElems[] = $elemObj;
        }
        $this->menuItems = $generatedMenuElems;

        $this->setLayout(JRequest::getCmd('layout','default'));
		parent::display($tpl);
                
        $app = JFactory::getApplication();
        if($app->isAdmin()){
            $this->addToolbar();
        }
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{

		$canDo	= DropeditorHelper::getActions();

		JToolBarHelper::title(JText::_('COM_DROPEDITOR_MAIN_PAGE'), 'dropeditor.png');

		$toolbar = JToolBar::getInstance();		
		
		if ($canDo->get('core.admin')) {
			$toolbar->appendButton( 'popup', 'support', JText::_('COM_DROPTABLE_VIEW_SUPPORT'), 'index.php?option=com_dropeditor&view=support&tmpl=component', 700, 600,0,0 );
			JToolBarHelper::preferences('com_dropeditor');
		}

		JToolBarHelper::divider();
	}
}
