<?php
/**
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die;
?>

<div class="row-fluid">
    <div class="span3">
        <div class="form-inline" >
            <div class=" control-group">
                <div class="control-label" style="min-width: 75px;">
                    <label id="jform_element_state-lbl" for="jform_element_state_input">
				        <?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_STATE_LABEL'); ?>
                    </label>
                </div>
                <div class="controls">
                    <div id="jform_element_state" class="dropcheckbox-wrapper">
                        <input type="checkbox" class="observeChangesRadio" id="jform_element_state_input" name="jform[jform_element_state]" value="1">
                        <label for="jform_element_state_input" class="dropcheckbox-label"></label>
                    </div>
                </div>
            </div>

            <div class=" control-group">
                <div class="control-label" style="min-width: 75px;">
                    <label id="filter_element-lbl" for="filter_element">
                        <?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_TITLE_LEVEL'); ?>
                    </label>
                </div>
                <div class="controls">
                    <select name="filter_element" id="filter_element" class="input-medium" onchange="return elementChange(this)">			
                        <?php echo JHtml::_('select.options', $this->items, 'id', 'element', $this->state->get('filter.element')); ?>
                    </select>
                </div>
            </div>

            <div class=" control-group">
                <div class="control-label" style="min-width: 75px;">
                    <label id="jform_element_title-lbl" for="jform_element_title">
                        <?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_TITLE_LABEL'); ?>
                    </label>
                </div>
                <div class="controls">
                    <input class="observeChanges"  type="text" name="jform[element_title]" id="jform_element_title" value=""/>
                </div>
            </div>
        </div>       
    </div>

    <div class="span4">
        <h4><?php echo JText::_("COM_DROPEDITOR_VIEW_FORMAT_SETTINGS"); ?></h4>

        <div id="formatConfig">
            <div class="control-group">
                <div class="control-label">
                    <label id="jform_cell_font_family-lbl" for="jform_cell_font_family">
                        <?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_PARAM_FONT'); ?> :
                    </label>
                </div>
                <div class="controls">

                    <select class="chzn-select observeChanges" name="jform[jform_cell_font_family]" id="jform_cell_font_family">
                        <option value="">(Default)</option>
                        <option value="Arial">Arial</option>
                        <option value="Arial Black">Arial Black</option>
                        <option value="Comic Sans MS">Comic Sans MS</option>
                        <option value="Courier New">Courier New</option>
                        <option value="Georgia">Georgia</option>
                        <option value="Impact">Impact</option>
                        <option value="Times New Roman">Times New Roman</option>
                        <option value="Trebuchet MS">Trebuchet MS</option>
                        <option value="Verdana">Verdana</option>
                    </select>
                </div>
            </div>

            <div class="form-inline control-group">
                <div class="input-append">
                    <input class="observeChanges"  type="text" name="jform[jform_cell_font_size]" id="jform_cell_font_size" value=""/>
                    <button class="btn" type="button" id="cell_font_size_incr">+</button>
                    <button class="btn" type="button" id="cell_font_size_decr">-</button>
                </div>

                <input class="minicolors  observeChanges"  data-position="left" data-control="hue" type="text" name="jform[jform_cell_font_color]" id="jform_cell_font_color" value="" size="7" />
            </div>

            <div class="aglobuttons">
                <button class="btn observeChanges"  id="jform_cell_font_bold"  name="jform[jform_cell_font_bold]" type="button"><span class="sprite sprite_text_bold"></span></button>
                <button class="btn observeChanges"  id="jform_cell_font_underline"  name="jform[jform_cell_font_underline]" type="button"><span class="sprite sprite_text_underline"></span></button>
                <button class="btn observeChanges"  id="jform_cell_font_italic"  name="jform[jform_cell_font_italic]" type="button"><span class="sprite sprite_text_italic"></span></button>
                <br/>
                <button class="btn observeChanges cell_align" id="jform_cell_align_left" name="jform[jform_cell_align_left]" type="button"><span class="sprite sprite_text_align_left"></span></button>
                <button class="btn observeChanges cell_align" id="jform_cell_align_center" name="jform[jform_cell_align_center]" type="button"><span class="sprite sprite_text_align_center"></span></button>
                <button class="btn observeChanges cell_align" id="jform_cell_align_right" name="jform[jform_cell_align_right]" type="button"><span class="sprite sprite_text_align_right"></span></button>
                <button class="btn observeChanges cell_align" id="jform_cell_align_justify" name="jform[jform_cell_align_justify]" type="button"><span class="sprite sprite_text_align_justify"></span></button>
            </div>     

            <div class="form-inline">
                <div class=" control-group">
                    <div class="control-label">
                        <label id="jform_line_height-lbl" for="jform_line_height">
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_LINE_HEIGHT_LABEL'); ?>
                        </label>
                    </div>
                    <div class="controls">
                        <input class="observeChanges input-medium"  type="text" name="jform[line_height]" id="jform_line_height" value=""/>
                    </div>
                </div>
                <div class=" control-group">
                    <div class="control-label">
                        <label id="jform_margin-lbl" for="jform_margin">
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_MARGIN_LABEL'); ?>
                        </label>
                    </div>
                    <div class="controls">
                        <input class="observeChanges input-medium"  type="text" name="jform[margin]" id="jform_margin" value=""/>
                    </div>
                </div>
                <div class=" control-group">
                    <div class="control-label">
                        <label id="jform_padding-lbl" for="jform_padding">
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_PADDING_LABEL'); ?>
                        </label>
                    </div>
                    <div class="controls">
                        <input class="observeChanges input-medium"  type="text" name="jform[padding]" id="jform_padding" value=""/>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="span5">
        <h4><?php echo JText::_("COM_DROPEDITOR_VIEW_FORMAT_PREVIEW"); ?></h4>
        <div id="preview">
            <p class="previousBlock"><?php echo JText::_("COM_DROPEDITOR_VIEW_FORMAT_SAMPLE_TEXT_PREVIEW"); ?></p>
            <p class="followBlock"><?php echo JText::_("COM_DROPEDITOR_VIEW_FORMAT_SAMPLE_TEXT_FOLLOW"); ?></p>
        </div>
    </div>
</div>
<div class="row-fluid" id="formatConfig2">
    <div class="span3"></div>
    <div class="span3">
        <div class="control-group">
            <div class="control-label">
                <label id="jform_cell_border_type-lbl" for="jform_cell_border_type">
                    <?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_PARAM_BORDERS'); ?>
                </label>
            </div>
            <div class="clr"></div>
            <div class="controls">
                <div>
                    <select class="chzn-select" name="jform[jform_cell_border_type]" id="jform_cell_border_type">
                        <option value="none"><?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_PARAM_BORDERS_NO_BORDER'); ?></option>
                        <option value="solid"><?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_PARAM_BORDERS_SOLID'); ?></option>
                        <option value="dashed"><?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_PARAM_BORDERS_DASHED'); ?></option>
                        <option value="dotted"><?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_PARAM_BORDERS_DOTTED'); ?></option>                                
                    </select>

                    <div class="form-inline">
                        <div class="input-append">
                            <input type="text" name="jform[jform_cell_border_width]" id="jform_cell_border_width" value="1"/>
                            <button class="btn" type="button" id="cell_border_width_incr">+</button>
                            <button class="btn" type="button" id="cell_border_width_decr">-</button>
                        </div>
                        <input class="minicolors minicolors-input observeChanges"  data-position="left" data-control="hue" type="text" name="jform[jform_cell_border_color]" id="jform_cell_border_color" value="#CCCCCC" size="7" />
                    </div>
                </div>
                <div class="aglobuttons">
                    <button class="btn observeChanges" name="jform[jform_cell_border_top]" type="button"><span class="sprite sprite_border_top"></span></button>
                    <button class="btn observeChanges" name="jform[jform_cell_border_right]" type="button"><span class="sprite sprite_border_right"></span></button>
                    <button class="btn observeChanges" name="jform[jform_cell_border_bottom]" type="button"><span class="sprite sprite_border_bottom"></span></button>
                    <button class="btn observeChanges" name="jform[jform_cell_border_left]" type="button"><span class="sprite sprite_border_left"></span></button>
                    <br/>           
                    <button class="btn observeChanges" name="jform[jform_cell_border_outline]" type="button"><span class="sprite sprite_border_outline"></span></button>
                    <button class="btn observeChanges" name="jform[jform_cell_border_remove]" type="button"><span class="sprite sprite_border_remove"></span></button>
                </div>                        
            </div>
        </div>  
    </div>
    <div class="span6">
        <div class="control-group">
            <div class="control-label">
                <label id="jform_css-lbl" for="jform_css">
                    <?php echo JText::_('COM_DROPEDITOR_VIEW_FORMAT_PARAM_CUSTOM_CSS'); ?> :
                </label>
                <div class="controls customCss" style="height:150px">
                    <textarea rows="7" name="jform[jform_css]" id="jform_css"></textarea>
                </div>
            </div>
        </div>
    </div>
</div>    

<script type="text/javascript">
    var myTextArea, myCssEditor
    jQuery(document).ready(function($) {
        $('.minicolors-input').minicolors('settings', {
            change: function() {
                jQuery(this).trigger('change');
            }
        }).attr('maxlength', '7');
        
         //codemirror
        myTextArea = document.getElementById("jform_css");
        myCssEditor = CodeMirror.fromTextArea(myTextArea, {mode: "css"});
        
        
        $(myTextArea).on('change', function() {
            myCssEditor.setValue($(myTextArea).val());
        });
    
        myCssEditor.on("blur", function() {
            myCssEditor.save();
            $(myTextArea).trigger("propertychange");

        });
    });
</script>