<?php
/** 
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// No direct access
defined('_JEXEC') or die;

/**
 * View to edit
 */
class DropeditorViewFormat extends JViewLegacy
{
	protected $state;
	protected $item;
	protected $form;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		$model = $this->getModel();
		$this->state	    = $this->get('State');
		$this->items		= $model->getItems(false);
        $this->customStyles	= $this->get('CustomStyles');
		$this->canDo        = DropeditorHelper::getActions();

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		$this->addToolbar();
		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 */
	protected function addToolbar()
	{
		JRequest::setVar('hidemainmenu', false);

        $toolbar = JToolBar::getInstance();
        JToolBarHelper::apply('format.saveCustomStyle');
        $toolbar->appendButton('link', 'cancel', 'Cancel', 'index.php?option=com_dropeditor&view=profiles');
        JToolBarHelper::title(JText::_('COM_DROPEDITOR_GLOBAL_CONFIG'), 'format.png');
	}
}
