<?php

/**
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */
defined('_JEXEC') or die;

class DropeditorViewGgfonts extends JViewLegacy {

    protected $state;
//    public $ggurl = 'https://www.googleapis.com/webfonts/v1/webfonts?key=';
//    public $api_key = 'AIzaSyD6kL15KaUQpZLBN42WzXadai8hDgoINUg';
    public $ggfonts = array();
    public $per_page = 10;
    public $count_page;
    public $paged;
    public $html_pagination = '';
    public $profiles_id;
    public $profiles_params;
    public $keyword = '';
    public $countggfonts = array();

    /**
     * Display the view
     */
    public function display($tpl = null) {
        $this->canDo = DropeditorHelper::getActions();
        $this->params = $params = JComponentHelper::getParams('com_dropeditor');
        $modelggfonts = $this->getModel('ggfonts');  
        
        $this->keyword = JRequest::getVar('keyword');
        $this->profiles_id = JRequest::getVar('profiles');
        $url = JPATH_ADMINISTRATOR.'/components/com_dropeditor/views/ggfonts/tmpl/fonts.json';
        JLoader::register('DropeditorHelper', JPATH_ADMINISTRATOR.'/components/com_dropeditor/helpers/dropeditor.php');
        $json = DropeditorHelper::gf_download_font_list($url);
        $fonts_object = json_decode($json);
        
        $this->profiles_params = $modelggfonts->get_profiles_params($this->profiles_id);
        
        $this->count_page = ceil(count($fonts_object->items) / $this->per_page);
        $paged = JRequest::getVar('page');
        if (empty($paged)) {
            $this->paged = 1;
        } else {
            $this->paged = $paged;
        }

        $a = 0;
        if (is_object($fonts_object)) {
            foreach ($fonts_object->items as $i => $v) {
                if(!empty($this->keyword)){
                    if(strpos(strtolower($v->family),strtolower($this->keyword)) !== false){
                        $a++;
                        $this->countggfonts[] = $v;
                        if ($a < $this->paged * $this->per_page && $a >= ($this->paged - 1) * $this->per_page) {
                            $this->ggfonts[] = $v;
                        }
                    }
                }else{
                    if ($i < $this->paged * $this->per_page && $i >= ($this->paged - 1) * $this->per_page) {
                        $this->ggfonts[] = $v;
                    }
                }
            }
            
            if(!empty($this->keyword)){
                $this->count_page = ceil(count($this->countggfonts) / $this->per_page);
            }
        }
        
        if(!empty($this->ggfonts)){
            $this->html_pagination = $modelggfonts->viewpage($this->paged, 'index.php?option=com_dropeditor&view=ggfonts&tmpl=component&profiles='.$this->profiles_id.'&page=' , $this->count_page,$this->keyword);
        }
        $document = JFactory::getDocument();
        $list = '';
        if (!empty($this->ggfonts)) {
            foreach ($this->ggfonts as $f) {
                $list .= $f->family.'|';
                
            }
            if(!empty($list)){
                $document->addStyleSheet('http://fonts.googleapis.com/css?family=' . $list);
            }
        }
        $document->addStyleSheet(JURI::root() . 'components/com_dropeditor/assets/css/ggfonts.css?ver=1.1');
        $document->addScript(JURI::root().'components/com_dropeditor/assets/js/ggfonts.js?ver=1.1');

        $this->setLayout(JRequest::getCmd('layout', 'default'));
        parent::display($tpl);

        $app = JFactory::getApplication();
        if ($app->isAdmin()) {
            $this->addToolbar();
        }
    }

    
    /**
     * Add the page title and toolbar.
     *
     * @since	1.6
     */
    protected function addToolbar() {

        $canDo = DropeditorHelper::getActions();

        JToolBarHelper::title(JText::_('COM_DROPEDITOR_MAIN_PAGE'), 'dropeditor.png');

        $toolbar = JToolBar::getInstance();

        if ($canDo->get('core.admin')) {
            $toolbar->appendButton('popup', 'support', JText::_('COM_DROPTABLE_VIEW_SUPPORT'), 'index.php?option=com_dropeditor&view=support&tmpl=component', 700, 600, 0, 0);
            JToolBarHelper::preferences('com_dropeditor');
        }

        JToolBarHelper::divider();
    }

    

}