<?php
/**
 * Dropeditor
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') or die;

?>
<div class="container">
    <div id="import-block" class="action-block clearfix">
        <h3 class="action-title"><?php echo JText::_('COM_DROPEDITOR_VIEW_IMPORT_EXPORT_IMPORT_LABEL') ?></h3>
        <div class="action-content">
            <form action="index.php?option=com_dropeditor&task=importexport.import" method="POST" enctype="multipart/form-data">
                <div class="controls">
                    <label for="import-file"><?php echo JText::_('COM_DROPEDITOR_VIEW_IMPORT_EXPORT_IMPORT_SELECT_FILE') ?>:</label>
                    <input type="file" name="import_file" id="import-file" required />
                </div>
                <div class="controls">
                    <input type="checkbox" name="override-styles" id="override-styles" value="1" />
                    <label for="override-styles"><?php echo JText::_('COM_DROPEDITOR_VIEW_IMPORT_EXPORT_IMPORT_OVERRIDE') ?></label>
                </div>
                <button type="submit" class="form-btn"><?php echo JText::_('COM_DROPEDITOR_VIEW_IMPORT_EXPORT_IMPORT_RUN') ?></button>
            </form>
        </div>
    </div>

	<div id="export-block" class="action-block clearfix">
		<h3 class="action-title"><?php echo JText::_('COM_DROPEDITOR_VIEW_IMPORT_EXPORT_EXPORT_LABEL') ?></h3>
		<div class="action-content">
			<form action="index.php?option=com_dropeditor&task=importexport.export" method="POST">
                <div class="controls">
                    <input type="radio" name="form-actions" value="export-styles" id="export-styles" checked required />
                    <label for="export-styles"><?php echo JText::_('COM_DROPEDITOR_VIEW_IMPORT_EXPORT_EXPORT_STYLES_LABEL') ?></label>
                </div>
                <div class="controls">
					<input type="radio" name="form-actions" value="export-profiles" id="export-profiles" />
					<label for="export-profiles"><?php echo JText::_('COM_DROPEDITOR_VIEW_IMPORT_EXPORT_EXPORT_PROFILES_LABEL') ?></label>
				</div>
                <div id="profiles-list" style="margin: 10px 0 0 10px; display: none;">
                    <?php if (count($this->profiles)) : ?>
                        <div class="controls" style="margin-bottom: 10px; border-bottom: 1px solid #ddd">
                            <input type="checkbox" id="profiles-check-all" />
                            <label for="profiles-check-all"><?php echo JText::_('COM_DROPEDITOR_VIEW_IMPORT_EXPORT_SELECT_ALL') ?></label>
                        </div>
                        <?php foreach ($this->profiles as $profile) : ?>
                            <div class="controls">
                                <input type="checkbox" name="profile-id[]" value="<?php echo $profile->id ?>" id="profile-<?php echo $profile->id ?>">
                                <label for="profile-<?php echo $profile->id ?>"><?php echo $profile->title ?></label>
                            </div>
                        <?php endforeach; ?>
                    <?php endif; ?>
                </div>
                <button type="submit" class="form-btn"><?php echo JText::_('COM_DROPEDITOR_VIEW_IMPORT_EXPORT_EXPORT_RUN') ?></button>
			</form>
		</div>
	</div>
</div>

<script type="text/javascript">
jQuery(document).ready(function ($) {
    $('#profiles-check-all').unbind('click').click(function () {
        $('input[name="profile-id[]"]').prop('checked', this.checked);
    });

    $('input[name="profile-id[]"]').unbind('click').click(function () {
        if (!this.checked) {
            $('#profiles-check-all').prop('checked', false);
        }
    });

    $('#export-block .action-content input[type=radio]').on('click', function () {
        if (this.value === 'export-profiles') {
            $('#profiles-list').slideDown();
        } else {
            $('#profiles-list').slideUp();
        }
    });

    if ($('#export-profiles').is(':checked')) {
        $('#profiles-list').slideDown();
    }
})
</script>