<?php
/**
 * Dropeditor
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// no direct access
defined('_JEXEC') or die;

$paramsmedia = JComponentHelper::getParams('com_media');
$media_root = JUri::root().$paramsmedia->get('file_path', 'images');
$dropeditor_img_folder = JUri::root().'components/com_dropeditor/assets/images/';
$doc = JFactory::getDocument();
$doc->addScriptDeclaration('var jroot_media = "'. $media_root. '/"; var dropeditor_img_folder = "'.$dropeditor_img_folder.'";');
JText::script('COM_DROPEDITOR_VIEW_DROPMEDIA_FAIL');
?>
<div class="container">
	<ul class="tabs cyan z-depth-1">
		<li class="tab"><a href="#youtube-tab" class="link-tab white-text waves-effect waves-light"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_YOUTUBE', true) ?></a></li>
		<li class="tab"><a href="#vimeo-tab" class="link-tab white-text waves-effect waves-light"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_VIMEO', true) ?></a></li>
		<li class="tab"><a href="#video-tab" class="link-tab white-text waves-effect waves-light"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_VIDEO', true) ?></a></li>
		<li class="tab"><a href="#sound-tab" class="link-tab white-text waves-effect waves-light"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_SOUND', true) ?></a></li>
	</ul>

	<!--Youtube tab-->
	<div id="youtube-tab" class="tab-block form-horizontal">
		<div class="control-group">
			<div class="control-label">
				<label for="youtube-video-url"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_VIDEO_URL') ?></label>
			</div>
			<div class="controls">
				<input type="text" class="video-url" id="youtube-video-url" name="youtube-video-url" placeholder="<?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_ENTER_URL') ?>" />
			</div>
		</div>

		<div class="control-group">
			<div class="control-label">
				<label for="youtube-load-type"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE') ?></label>
			</div>
			<div class="controls">
				<select name="youtube-load-type" class="load-type" id="youtube-load-type">
					<option value="content"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE_CONTENT') ?></option>
					<option value="popup"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE_POPUP') ?></option>
				</select>
			</div>
		</div>

        <div class="video-thumb" id="youtube-video-thumb">
            <?php echo $this->form->renderField('dropmediaThumbnail') ?>
        </div>

		<div class="control-group">
			<div class="control-label">
				<label for="youtube-video-max-width"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_MAX_WIDTH') ?></label>
			</div>
			<div class="controls">
				<input type="number" min="200" class="video-max-width" name="youtube-video-max-width" id="youtube-video-max-width" placeholder="Auto" />
				<span class="small-hint">(<?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_MAX_WIDTH_HINT') ?>)</span>
			</div>
		</div>

        <div class="submit-block clearfix">
            <button type="button" class="submit-btn cyan white-text waves-effect waves-light" id="insert-youtube">
				<?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_INSERT') ?>
            </button>
        </div>

		<div class="preview-block" id="youtube-preview-block">
			<div class="video-title" id="youtube-video-title"></div>
			<div class="video" id="youtube-video"></div>
		</div>
	</div><!--end Youtube tab-->

	<!--Vimeo tab-->
	<div id="vimeo-tab" class="tab-block form-horizontal">
		<div class="control-group">
			<div class="control-label">
				<label for="vimeo-video-url"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_VIDEO_URL') ?></label>
			</div>
			<div class="controls">
				<input type="text" class="video-url" id="vimeo-video-url" name="vimeo-video-url" placeholder="<?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_ENTER_URL') ?>" />
			</div>
		</div>

		<div class="control-group">
			<div class="control-label">
				<label for="vimeo-load-type"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE') ?></label>
			</div>
			<div class="controls">
				<select name="vimeo-load-type" class="load-type" id="vimeo-load-type">
					<option value="content"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE_CONTENT') ?></option>
					<option value="popup"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE_POPUP') ?></option>
				</select>
			</div>
		</div>

        <div class="video-thumb" id="vimeo-video-thumb">
			<?php echo $this->form->renderField('dropmediaThumbnail') ?>
        </div>

		<div class="control-group">
			<div class="control-label">
				<label for="vimeo-video-max-width"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_MAX_WIDTH') ?></label>
			</div>
			<div class="controls">
				<input type="number" min="200" name="vimeo-video-max-width" class="video-max-width" id="vimeo-video-max-width" placeholder="Auto" />
				<span class="small-hint">(<?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_MAX_WIDTH_HINT') ?>)</span>
			</div>
		</div>

        <div class="submit-block clearfix">
            <button type="button" class="submit-btn cyan white-text waves-effect waves-light" id="insert-vimeo">
				<?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_INSERT') ?>
            </button>
        </div>

		<div class="preview-block" id="vimeo-preview-block">
			<div class="video-title" id="vimeo-video-title"></div>
			<div class="video" id="vimeo-video"></div>
		</div>
	</div><!--end Vimeo tab-->

	<!--Video tab-->
	<div id="video-tab" class="tab-block form-horizontal">
        <div class="control-group">
            <div class="control-label">
                <label for="video-local-file"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_SELECTED_VIDEO') ?></label>
            </div>
            <div class="controls">
                <input type="text" disabled class="localFile" id="video-local-file" name="video-local-file" />
                <input type="hidden" class="local-src" id="video-local-src" name="video-local-src" />
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="video-load-type"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE') ?></label>
            </div>
            <div class="controls">
                <select name="video-load-type" class="load-type" id="video-load-type">
                    <option value="content"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE_CONTENT') ?></option>
                    <option value="popup"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE_POPUP') ?></option>
                </select>
            </div>
        </div>

        <div class="video-thumb" id="video-video-thumb">
			<?php echo $this->form->renderField('dropmediaThumbnail') ?>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="video-video-max-width"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_MAX_WIDTH') ?></label>
            </div>
            <div class="controls">
                <input type="number" min="200" name="video-video-max-width" class="video-max-width" id="video-video-max-width" placeholder="Auto" />
                <span class="small-hint">(<?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_MAX_WIDTH_HINT') ?>)</span>
            </div>
        </div>

        <div class="treeBlock" id="video-tree"></div>

        <div class="submit-block clearfix">
            <button type="button" class="submit-btn local-file cyan white-text waves-effect waves-light" id="insert-video">
				<?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_INSERT') ?>
            </button>
        </div>

        <div class="preview-block" id="video-preview-block">
            <div class="video-title" id="video-video-title"></div>
            <div class="video" id="video-video"></div>
        </div>
	</div><!--end Video tab-->

	<!--Sound tab-->
	<div id="sound-tab" class="tab-block form-horizontal">
        <div class="control-group">
            <div class="control-label">
                <label for="sound-local-file"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_SELECTED_SOUND') ?></label>
            </div>
            <div class="controls">
                <input type="text" disabled class="localFile" id="sound-local-file" name="sound-local-file" />
                <input type="hidden" class="local-src" id="sound-local-src" name="sound-local-src" />
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="sound-load-type"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE') ?></label>
            </div>
            <div class="controls">
                <select name="sound-load-type" class="load-type" id="sound-load-type">
                    <option value="content"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE_CONTENT') ?></option>
                    <option value="popup"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_LOAD_TYPE_POPUP') ?></option>
                </select>
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="sound-video-max-width"><?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_MAX_WIDTH') ?></label>
            </div>
            <div class="controls">
                <input type="number" min="200" name="sound-video-max-width" class="video-max-width" id="sound-video-max-width" placeholder="Auto" />
                <span class="small-hint">(<?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_MAX_WIDTH_HINT') ?>)</span>
            </div>
        </div>

        <div class="treeBlock" id="sound-tree"></div>

        <div class="submit-block clearfix">
            <button type="button" class="submit-btn local-file cyan white-text waves-effect waves-light" id="insert-sound">
				<?php echo JText::_('COM_DROPEDITOR_VIEW_DROPMEDIA_INSERT') ?>
            </button>
        </div>

        <div class="preview-block" id="sound-preview-block">
            <div class="video-title" id="sound-video-title"></div>
            <div class="video" id="sound-video"></div>
        </div>
	</div><!--end Sound tab-->
</div>