<?php
/**
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */
// No direct access.
defined('_JEXEC') or die;

JHtml::_('behavior.keepalive');
JHtml::_('behavior.framework');

JHtml::_('behavior.formvalidation');
JHtml::_('formbehavior.chosen', '.chzn-select');
JHtml::_('formbehavior.chosen', 'select');

jimport('joomla.html.html.bootstrap');
jimport('joomla.application.component.helper');


$app = JFactory::getApplication();
$user = JFactory::getUser();
$userId = $user->get('id');
$listOrder = $this->escape($this->state->get('list.ordering'));
$listDirn = $this->escape($this->state->get('list.direction'));
$archived = $this->state->get('filter.published') == 2 ? true : false;
$trashed = $this->state->get('filter.published') == -2 ? true : false;
$canOrder = $user->authorise('core.edit.state', 'com_dropeditor.profile');
$saveOrder = $listOrder == 'a.ordering';

$usergroups = explode(',', $this->item->usergroups);
?>

<script type="text/javascript">
    Joomla.submitbutton = function(task)
    {
        if (task == 'profile.cancel' || document.formvalidator.isValid(document.id('profile-form')))
        {                       
            
            Joomla.submitform(task, document.getElementById('profile-form'));
        }
    }
</script>
<style>
    .form-horizontal .control-label {
        min-width: 160px;
    }
    #groupList {
        width: 300px;
        overflow:auto;
    }
    #groupList .controls {
        margin-left: 20px;
    }
    [type="checkbox"] {
        visibility: hidden;
    }
</style>
<form action="<?php echo JRoute::_('index.php?option=com_dropeditor&view=profile&layout=edit&id=' . (int) $this->item->id); ?>" method="post" name="adminForm" id="profile-form" class="form-validate">
    <div class="form-horizontal">
        <ul class="tabs cyan z-depth-1" style="margin-bottom: 20px">
            <li class="tab"><a href="#details" class="link-tab white-text waves-effect waves-light"><?php echo JText::_('COM_DROPEDITOR_EDIT_PROFILE', true) ?></a></li>
            <li class="tab"><a href="#layout" class="link-tab white-text waves-effect waves-light"><?php echo JText::_('COM_DROPEDITOR_PROFILE_EDITOR_LAYOUT', true) ?></a></li>
        </ul>

        <div class="row-fluid" id="details">
            <div class="span5">
                <div class="row-fluid form-horizontal-desktop">

                    <?php echo $this->form->renderField('title'); ?>
                    <?php echo $this->form->renderField('description'); ?>
                    <?php echo $this->form->renderField('state'); ?>                                                                                                                                                                            

                    <div class="control-group ">
                        <div class="control-label">
                            <?php echo $this->form->getLabel('components'); ?>

                        </div>
                        <div class="controls">
                            <?php echo $this->lists['components']; ?>    
                        </div>
                    </div>
                </div>
            </div>
            <div class="span6">
                <div class="control-group ">
                    <div class="control-label">
                        <?php echo $this->form->getLabel('usergroups'); ?>                                                       
                    </div>
                    <div id="groupList" >
                        <?php echo JHtml::_('access.usergroups', 'jform[usergroups]', $usergroups); ?>
                    </div>
                </div>
            </div>
        </div>
        <div class="row-fluid" id="layout">
            <div class="span12">
                <?php echo $this->loadTemplate('layout'); ?>
            </div>
        </div>
    </div>
    <input type="hidden" name="task" value="" />
    <input type="hidden" name="jform[components][]" value="" />
    <input type="hidden" name="jform[buttons]" id="jform_buttons" value="" />
    
    <?php echo JHtml::_('form.token'); ?>
</form>