<?php
/**
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */
// No direct access.
defined('_JEXEC') or die;
JHTML::_('behavior.modal', 'a.modal');
//JHtml::_('behavior.colorpicker');
$position="ckeLeft";
$theme="";
$usdedPlugins= array();
JHtml::_('jquery.ui', array('core','sortable'));

$baseImageUrl= JURI::root() . 'components/com_dropeditor/assets/images/';
$spacerUrl= JURI::root() . 'components/com_dropeditor/assets/images/spacer.gif';
$doc = JFactory::getDocument();
$doc->addStyleSheet(JURI::root() . 'components/com_dropeditor/assets/css/editorlayout.css');
$doc->addStyleSheet(JURI::base() . 'components/com_dropeditor/assets/css/admin.css');
$doc->addStyleSheet(JURI::root() . 'components/com_dropeditor/assets/minicolors/jquery.minicolors.css');
$doc->addScript(JURI::root() . 'components/com_dropeditor/assets/minicolors/jquery.minicolors.js');
?>

<ul class="adminformlist" id="profileLayoutTable">
    <!-- Active Editor Layout -->
    <li>
        <label class="drop-tooltip" title="<?php echo JText::_('COM_DROPEDITOR_PROFILE_LAYOUT_EDITOR') . '::' . JText::_('COM_DROPEDITOR_PROFILE_LAYOUT_EDITOR_DESC'); ?>"><?php echo JText::_('COM_DROPEDITOR_PROFILE_LAYOUT_EDITOR'); ?></label>
        <span class="profileLayoutContainer profileLayoutContainerCurrent <?php echo $theme; ?>">
            <!-- Toolbar -->
            <span id="toolbar_container" class="profileLayoutContainerToolbar">
                <ul class="sortableList <?php echo $position; ?>">

                    <?php if (count($this->rows) == 0) : ?>
                    <li class="sortableListItem"><span class="sortableRow ckeToolbar"></span></li>
                    <?php
                     endif; ?>
                    <?php for($i=0;$i < count($this->rows);$i++) : ?>
                        <li class="sortableListItem">
                            <span class="sortableRow ckeToolbar">
                                <?php
                                $usdedPlugins[] = $this->rows[$i]; //->pluginIds
                                foreach (explode(',', $this->rows[$i]) as $pluginID) : ?>
                                    <?php if($pluginID && isset($this->pluginBtns[$pluginID]) ) {
                                        $btn = $this->pluginBtns[$pluginID];
                                    if ($btn->type == 'spacer') : ?>
                                        <span class="sortableRowItem spacer" data-btn-id="-1" data-name="spacer"><span class="ckeSeparator"></span></span>
                                    <?php elseif( $btn->icon == "") : ?>
                                        <span data-name="<?php echo $btn->name; ?>" data-btn-id="<?php echo $btn->id; ?>" class="sortableRowItem <?php echo $btn->type; ?> drop-tooltip drop-tooltip-cancel-ondrag" title="<?php echo JText::_($btn->title);?>">
                                            <?php echo JText::_($btn->title);?>
                                        </span>
                                    <?php elseif(strpos($btn->icon, 'ic_') === false) : ?>
                                        <span data-name="<?php echo $btn->name; ?>" data-btn-id="<?php echo $btn->id; ?>" class="sortableRowItem <?php echo $btn->type; ?> drop-tooltip drop-tooltip-cancel-ondrag" title="<?php echo JText::_($btn->title);?>">
                                            <img src="<?php echo $baseImageUrl.'plugins/'. $btn->icon; ?>" alt="<?php echo JText::_($btn->title);?>" title="<?php echo JText::_($btn->title);?>" class="cke_plugin" >
                                        </span>
                                    <?php else: ?>
                                        <span data-name="<?php echo $btn->name; ?>" data-btn-id="<?php echo $btn->id; ?>" class="sortableRowItem <?php echo $btn->type; ?> drop-tooltip drop-tooltip-cancel-ondrag" title="<?php echo JText::_($btn->title);?>">
                                            <?php $icon = $btn->icon; $icon = str_replace('ic_', '', $icon) ?>
                                            <i class="material-icons cke_icon" title="<?php echo JText::_($btn->title) ?>"><?php echo $icon ?></i>
                                        </span>
                                    <?php endif; ?>
                                <?php }
                                endforeach;
                                ?>
                            </span>
                            <span class="sortableRowHandle"><span class="ui-icon ui-icon-arrowthick-2-n-s"></span></span>
                            <span class="sortableOption"></span>
                        </li>
                    <?php endfor; ?>
                </ul></span>
            <!--  Editor -->
            <span id="editor_container" class="profileLayoutContainerEditor ckeIframeContainer">
                <p><?php echo JText::_('COM_DROPEDITOR_PROFILE_DUMMY_TEXT');?></p>
            </span>
            <!--  Statusbar -->
            <span id="statusbar_container" class="profileLayoutContainerStatusBar">
                <span class="ckeStatusbar"><span><span class="ckePathLabel">Path: </span></span>
                    <a href="#" class="ckeResize"></a>
                </span>
            </span>
        </span>
    </li>

    <!-- Available Buttons -->
    <li style='margin-top: 20px'>
        <label class="drop-tooltip" title="<?php echo JText::_('COM_DROPEDITOR_PROFILE_LAYOUT_AVAILABLE') . '::' . JText::_('COM_DROPEDITOR_PROFILE_LAYOUT_AVAILABLE_DESC'); ?>"><?php echo JText::_('COM_DROPEDITOR_PROFILE_LAYOUT_AVAILABLE'); ?></label>
        <span class="profileLayoutContainer <?php echo $theme; ?> available">
            <span class="profileLayoutContainerToolbar">
            <ul class="sortableList">
                <?php for ($i = 0; $i < 5; $i++) :?>
                    <li class="sortableListItem">
                        <span class="sortableRow ckeToolbar">
                            <?php if ($i == 4) :
                                for ($x = 1; $x <= 10; $x++) :
                            ?>
                                <span class="sortableRowItem spacer" data-btn-id="-1" data-name="spacer"><span class="ckeSeparator"></span></span>
                            <?php
                                endfor;
                            endif;

                            foreach ($this->pluginBtns as $btn) :
                                if (!in_array($btn->id, explode(',', implode(',', $usdedPlugins)))) :
                                    if ((int)$btn->row == $i) :
                                        if( $btn->icon == "" && $btn->title != "") :
                                            echo '<span class="sortableRowItem ' . $btn->type . ' drop-tooltip drop-tooltip-cancel-ondrag" data-btn-id="'. $btn->id . '" data-name="' . $btn->name . '" title="' . JText::_($btn->title)  . '">'; ?>
                                                <?php echo JText::_($btn->title);?>
                                            <?php echo '</span>';
                                        elseif(strpos($btn->icon, 'ic_') === false &&  $btn->icon != "") :
                                            echo '<span class="sortableRowItem ' . $btn->type . ' drop-tooltip drop-tooltip-cancel-ondrag" data-btn-id="'. $btn->id . '" data-name="' . $btn->name . '" title="' . JText::_($btn->title)  . '">'; ?>
                                                <img src="<?php echo $baseImageUrl; ?>plugins/<?php echo $btn->icon;?>" alt="<?php echo JText::_($btn->title);?>" title="<?php echo JText::_($btn->title);?>" class="cke_plugin" >
                                            </span>
                                        <?php
                                        elseif(strpos($btn->icon, 'ic_') !== false ):
                                            echo '<span class="sortableRowItem ' . $btn->type . ' drop-tooltip drop-tooltip-cancel-ondrag" data-btn-id="'. $btn->id . '" data-name="' . $btn->name . '" title="' . JText::_($btn->title)  . '">'; ?>
                                            <?php $icon = $btn->icon; $icon = str_replace('ic_', '', $icon) ?>
                                             <i class="material-icons cke_icon" title="<?php echo JText::_($btn->title) ?>"><?php echo $icon ?></i>
                                            <?php echo '</span>';
                                        endif;
                                    endif;
                                endif;
                            endforeach;
                            ?>
                        </span>
                        <span class="sortableRowHandle"><span class="ui-icon ui-icon-arrowthick-2-n-s"></span></span>
                        <span class="sortableOption"></span>
                    </li>
                <?php endfor; ?>
            </ul>
            </span>
        </span>
    </li>
    <li>  <br/> </li>
<?php 
$dropPicsExist = ckeditorHelper::checkComponentExist("com_droppics");
$dropFilesExist = ckeditorHelper::checkComponentExist("com_dropfiles");
$dropTableExist = ckeditorHelper::checkComponentExist("com_droptables");
$droppics_button = $dropfiles_button = $droptables_button = $google_font = 1;
$custom_font_colors = $editor_fheight = 0;
if($this->item->id > 0) {
    $profile_params = $this->item->params;
    if($profile_params && isset($profile_params['droppics_button'])) {
        $droppics_button = $profile_params['droppics_button'];
    }
    if($profile_params && isset($profile_params['dropfiles_button'])) {
        $dropfiles_button = $profile_params['dropfiles_button'];
    }
    if($profile_params && isset($profile_params['droptables_button'])) {
        $droptables_button = $profile_params['droptables_button'];
    }
    if($profile_params && isset($profile_params['google_font'])) {
        $google_font = $profile_params['google_font'];
    }
    if($profile_params && isset($profile_params['custom_font_colors'])) {
        $custom_font_colors = $profile_params['custom_font_colors'];
    }
    if($profile_params && isset($profile_params['editor_fheight'])) {
        $editor_fheight = $profile_params['editor_fheight'];
    }
}
?>
    <li>
        <label id="editor_fheight-lbl" for="jform_editor_fheight_input" class="control-label hasPopover" title="<?php echo JText::_('COM_DROPEDITOR_FORM_LBL_PROFILE_FHEIGHT') ?>" data-content="<?php echo JText::_('COM_DROPEDITOR_FORM_DESC_PROFILE_FHEIGHT'); ?>">
            <?php echo JText::_('COM_DROPEDITOR_FORM_LBL_PROFILE_FHEIGHT'); ?> :
        </label>
        <div class="controls">
            <div id="jform_editor_fheight" class="dropcheckbox-wrapper">
                <input type="hidden" class="btn-val" name="jform[editor_fheight]" id="editor_fheight" value="0" />
                <input type="checkbox" class="observeLayoutChanges" id="jform_editor_fheight_input" name="jform[editor_fheight]" value="1" <?php if ($editor_fheight == 1) {echo 'checked';} ?>>
                <label for="jform_editor_fheight_input" class="dropcheckbox-label"></label>
            </div>
        </div>
    </li>
        
        <li>
            <label id="google_font-lbl" for="jform_custom_font_colors_input" >
                        <?php echo JText::_('COM_DROPEDITOR_PROFILE_PARAM_CUSTOM_FONT_COLORS'); ?> :
            </label>
            <div class="controls">
                <div id="jform_custom_font_colors" class="dropcheckbox-wrapper">
                    <input type="hidden" class="btn-val" name="jform[custom_font_colors]" id="custom_font_colors" value="0" />
                    <input type="checkbox" class="observeLayoutChanges" id="jform_custom_font_colors_input" name="jform[custom_font_colors]" value="1" <?php if ($custom_font_colors == 1) {echo 'checked';} ?>>
                    <label for="jform_custom_font_colors_input" class="dropcheckbox-label"></label>
                </div>
            </div>
        </li>

<?php if(isset($custom_font_colors) && $custom_font_colors == 1): ?>
        <li>
            <label id="custom_font_colors-lbl" for="add_font_colors" >
                        
            </label>
            <div class="controls">
                <div class="radio btn-group btn-group-yesno add_font_colors">
                    <input type="text" id="hue-font_gminicolors" class="form-control font_gminicolors" data-control="hue" value="#555555">
                    <div class="action_color">
                        <button type="button" class="btn btn-small btn_add_remove add_color btn-success" data-profiles_id="<?php echo $this->item->id ?>">
                            <span class="icon-new"></span>
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_PROFILES_ADD'); ?>
                        </button><br>
                        <button type="button" class="btn btn-small btn_add_remove remove_color" data-profiles_id="<?php echo $this->item->id ?>">
                            <span class="icon-trash"></span>
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_PROFILES_REMOVE'); ?>
                        </button>
                    </div>
                    <div class="wrap_listcolors">
                        <h3><?php echo JText::_('COM_DROPEDITOR_PROFILE_PARAM_CUSTOM_COLORS'); ?></h3>
                        <div class="list_colors">
                        <?php
                        if(!empty($this->item->params['listcolors'])){
                            $lists_color = $this->item->params['listcolors'];
                            foreach ($lists_color as $color){
                                echo '<div data-color="'.$color.'" class="custom_color_lists" style="background:'.$color.'"></div>';
                            }
                        }
                        ?>
                        </div>
                    </div>
                </div>
            </div>
        </li>
        <?php endif; ?>
        <li>
            <label id="google_font-lbl" for="jform_google_font_input" >
                        <?php echo JText::_('COM_DROPEDITOR_PROFILE_PARAM_GOOGLE_FONT'); ?> :
            </label>
            <div class="controls">
                <div id="jform_google_font" class="dropcheckbox-wrapper">
                    <input type="hidden" class="btn-val" name="jform[google_font]" id="google_font" value="0" />
                    <input type="checkbox" class="observeLayoutChanges" id="jform_google_font_input" name="jform[google_font]" value="1" <?php if ($google_font == 1) {echo 'checked';} ?>>
                    <label for="jform_google_font_input" class="dropcheckbox-label"></label>
                </div>
            </div>
        </li>
        
        <?php if (isset($google_font) && $google_font == 1): ?>
        <li>
            <label id="select_google_font-lbl" for="select_google_font" >
                        <?php echo JText::_('COM_DROPEDITOR_PROFILE_SELECT_GOOGLE_FONT'); ?> :
            </label>
            <div class="controls">
                <?php 
                    $link = 'index.php?option=com_dropeditor&view=ggfonts&tmpl=component&profiles='.$this->item->id;
                ?>
                <a style="text-decoration:none;margin-left: 20px;" class="btn modal btn_show_font" href="<?php echo $link; ?>" rel="{handler: 'iframe', size: {x:1100, y:650}}"><?php echo JText::_('VIEW_GOOGLE_FONT'); ?></a>
            </div>
        </li>
        <?php endif; ?>
<?php if($dropPicsExist) : ?>
    <li>
        <label id="droppics_button-lbl" for="jform_droppics_button_input" >
            <?php echo JText::_('COM_DROPEDITOR_PROFILE_PARAM_DROPPICS_BUTTON'); ?> :
        </label>
        <div class="controls">
            <div id="jform_droppics_button" class="dropcheckbox-wrapper">
                <input type="hidden" class="btn-val" name="jform[droppics_button]" id="droppics_button" value="0" />
                <input type="checkbox" class="observeLayoutChanges" id="jform_droppics_button_input" name="jform[droppics_button]" value="1" <?php if ($droppics_button == 1) {echo 'checked';} ?>>
                <label for="jform_droppics_button_input" class="dropcheckbox-label"></label>
            </div>
        </div>
    </li>
<?php endif; ?>

<?php if($dropFilesExist) : ?>
    <li>
        <label id="dropfiles_button-lbl" for="jform_dropfiles_button_input" >
            <?php echo JText::_('COM_DROPEDITOR_PROFILE_PARAM_DROPFILES_BUTTON'); ?> :
        </label>
        <div class="controls">
            <div id="jform_dropfiles_button" class="dropcheckbox-wrapper">
                <input type="hidden" class="btn-val" name="jform[dropfiles_button]" id="dropfiles_button" value="0" />
                <input type="checkbox" class="observeLayoutChanges" id="jform_dropfiles_button_input" name="jform[dropfiles_button]" value="1" <?php if ($dropfiles_button == 1) {echo 'checked';} ?>>
                <label for="jform_dropfiles_button_input" class="dropcheckbox-label"></label>
            </div>
        </div>
    </li>
<?php endif; ?>
<?php if($dropTableExist) : ?>    
        <li>
            <label id="droptables_button-lbl" for="jform_droptables_button_input" >
                <?php echo JText::_('COM_DROPEDITOR_PROFILE_PARAM_DROPTABLES_BUTTON'); ?> :
            </label>
            <div class="controls">
                <div id="jform_droptables_button" class="dropcheckbox-wrapper">
                    <input type="hidden" class="btn-val" name="jform[droptables_button]" id="droptables_button" value="0" />
                    <input type="checkbox" class="observeLayoutChanges" id="jform_droptables_button_input" name="jform[droptables_button]" value="1" <?php if ($droptables_button == 1) {echo 'checked';} ?>>
                    <label for="jform_droptables_button_input" class="dropcheckbox-label"></label>
                </div>
            </div>
        </li>
<?php endif; ?>
</ul>
<style>
    .minicolors-panel{
        display:inline-block !important;left:0px !important;
    }
    .add_font_colors{
        min-height:200px;
        max-width: 600px !important;
    }
    .minicolors{
        float:left;
    }
    .action_color{
        margin-left:100px;margin-top: 40px;float:left;
    }
    .remove_color{
        margin-top: 10px;
    }
    .wrap_listcolors{
        max-width:192px;float:left;margin-left: 50px;text-align:center;
    }
    .custom_color_lists{
        float:left;width:30px;height:20px;border: #fff 1px solid;
    }
    .dropcheckbox-wrapper {
        margin-left: 60px;
    }
</style>
<script>
jQuery( document ).ready(function($) {
    jQuery('.font_gminicolors').each(function () {
        jQuery(this).minicolors({
            control: jQuery(this).attr('data-control') || 'hue',
            defaultValue: jQuery(this).attr('data-defaultValue') || '',
            format: jQuery(this).attr('data-format') || 'hex',
            keywords: jQuery(this).attr('data-keywords') || '',
            inline: jQuery(this).attr('data-inline') === 'true',
            letterCase: jQuery(this).attr('data-letterCase') || 'lowercase',
            opacity: jQuery(this).attr('data-opacity'),
            position: jQuery(this).attr('data-position') || 'bottom left',
            change: function (value, opacity) {
                if (!value)
                    return;
                //setNewUiColor(value);
            },
            theme: 'bootstrap'
        });
    });
    
    var selected_color = function() {
        $('.custom_color_lists').on('click',function(){
            if($(this).hasClass('selected')){
                $(this).removeClass('selected').css('border','#fff 1px solid');
            }else{
                $(this).addClass('selected').css('border','#000 1px solid');
            }
        });
    };
    
    selected_color();
    $('.btn_add_remove').on('click',function(){
        var profiles_id = $(this).data('profiles_id');
        if($(this).hasClass('add_color')){
            var color = $('.add_font_colors .minicolors-input').val();
            var type = 'add'
        }else{
            var list_colors = []
            $('.custom_color_lists.selected').each(function(i,element){
                list_colors.push($(element).data('color'));
            });
            var color = list_colors.join(',');
            var type = 'remove';
        }
        
        $.ajax({
            url: "index.php?option=com_dropeditor&task=ggfonts.updatecolor",
            type: "POST",
            data : {
                profiles_id : profiles_id,
                color : color,
                type :type
            },
            dataType: "json",
            success: function(response) {
                $('.list_colors').html(null);
                if(response.status == true){
                    $.each(response.datas,function(i,v){
                        $('.list_colors').append('<div data-color="'+ v +'" class="custom_color_lists" style="background:'+ v +'"></div>');
                    });
                    selected_color();
                }
            }
        });
    });
    
    $( ".sortableRow" ).sortable({
        items: '.sortableRowItem',
        connectWith: ".sortableRow",
        update : function( event, ui){
             updateBtnsList();
        }
    }).disableSelection();
    
    $( ".sortableList" ).sortable({
        items: '.sortableListItem',
        connectWith: ".sortableList",
        update : function( event, ui){
            updateBtnsList();
        }
    }).disableSelection();
        
    var updateBtnsList = function() {
        var currentBtns='';
        $.each( $('#toolbar_container').find('.sortableListItem'),function(i,val){
            if(currentBtns!==''){
                currentBtns+=',';
            }
            var row = [];
            $.each( $(val).find(".sortableRowItem"),function(i,item){
                row.push( $(item).data('btn-id'));
            });
                 
            currentBtns+='"'+i+'":"'+ row.join() + '"';
        });
        currentBtns = '{'+currentBtns+'}';
         
        $("#jform_buttons").val(currentBtns) ;
    };
    updateBtnsList();
});
</script>