<?php
/** 
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


defined('_JEXEC') or die;

class DropeditorViewProfile extends JViewLegacy
{
	
	protected $state;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
        $this->canDo    = DropeditorHelper::getActions();
        $this->params   = $params = JComponentHelper::getParams('com_dropeditor');
        $this->form		= $this->get('Form');
        $this->item		= $this->get('Item');
		$this->state	= $this->get('State');
                
        $components = explode(",", $this->item->components);
        $allcomponents =  $this->get('Components') ;
		$lists['components'] = JHTML::_('select.genericlist',  $allcomponents, 'jform[components][]', ' size="10" multiple', 'value', 'text', $components);
		$this->lists = $lists;
                                            
        $model  = $this->getModel();
        if($this->item->id == 0) {  //$isNew
            $defaultParams = '{"buttons":"{\"0\":\"13,14,18,15,-1,44,45,47,46,-1,40,41\",\"1\":\"43,42,-1,85,86,20,63,21,-1,80,59,-1,16,17,23,-1,3\"}"}';
            $this->rows = $model->getButtons($defaultParams);
        }else {
            $this->rows = $model->getButtons($this->item->params);
        }

        $this->pluginBtns = $this->get('PluginButtons');
        $spacer = new stdClass();
        $spacer->type = 'spacer';
        $spacer->id = '-1';
        $spacer->icon = '';
        $spacer->row = 0;
        $spacer->title = '';
        $this->pluginBtns["-1"] = $spacer;

        // Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
                
        $this->setLayout(JRequest::getCmd('layout','default'));
                
		parent::display($tpl);
                
        $app = JFactory::getApplication();
        if($app->isAdmin()){
            $this->addToolbar();
        }
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
        $user		= JFactory::getUser();
		$userId		= $user->get('id');
		$isNew		= ($this->item->id == 0);
		$canDo	    = DropeditorHelper::getActions();

		JToolBarHelper::title(JText::_('COM_DROPEDITOR_MAIN_PAGE'), 'dropeditor.png');

		$toolbar = JToolBar::getInstance();		
		              
        if ($canDo->get('core.admin')) {
        	if ($isNew) {
                JToolbarHelper::apply('profile.apply');
                JToolbarHelper::save('profile.save');
                JToolbarHelper::save2new('profile.save2new');
                JToolbarHelper::cancel('profile.cancel');
            } else {
                JToolbarHelper::apply('profile.apply');
                JToolbarHelper::save('profile.save');
                JToolbarHelper::save2new('profile.save2new');
                JToolbarHelper::cancel('profile.cancel', 'JTOOLBAR_CLOSE');
            }
			$toolbar->appendButton( 'popup', 'support', JText::_('COM_DROPTABLE_VIEW_SUPPORT'), 'index.php?option=com_dropeditor&view=support&tmpl=component', 700, 600,0,0 );
			JToolBarHelper::preferences('com_dropeditor');
		}

		JToolBarHelper::divider();
	}
}
