<?php
/**
 * DropEditor
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package DropEditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// no direct access
defined('_JEXEC') or die;
jimport('joomla.filesystem.folder');

class com_dropeditorInstallerScript
{

	public function __construct() {
		// Get old version
		$this->oldRelease = $this->getVersion('com_dropeditor');
	}

    /**
     * method to install the component
     *
     * @return void
     */
    static function install($parent)
    {
        $lang = JFactory::getLanguage();
        $lang->load('com_dropeditor', JPATH_ROOT . '/components/com_dropeditor', null, true);
        $dbo = JFactory::getDbo();

        $queries = array(); //This array will contain all the queries which need to be excuted during install

        /* Completely arbritrary tables change to fit your needs */
        $queries[] = "CREATE TABLE IF NOT EXISTS `#__dropeditor` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `id_category` int(11) NOT NULL,
                        `title` varchar(100) NOT NULL,
                        `datas` mediumtext NOT NULL,
                        `style` mediumtext NOT NULL,
                        `css` text NOT NULL,
                        `hash` VARCHAR( 32 ) NOT NULL,
                        `params` text NOT NULL,
                        `created_time` datetime NOT NULL,
                        `modified_time` datetime NOT NULL,
                        `author` int(11) NOT NULL,
                        PRIMARY KEY (`id`)
                      ) ENGINE=MyISAM  DEFAULT CHARSET=utf8";

        $queries[] = "CREATE TABLE IF NOT EXISTS `#__dropeditor_customstyles` (
                         `id` int(11) NOT NULL AUTO_INCREMENT,
						  `title` varchar(100) NOT NULL,
						  `name` varchar(50) NOT NULL,
						  `css` text NOT NULL,
						  `state` tinyint(4) NOT NULL,
						  `ordering` int(11) NOT NULL,
						  PRIMARY KEY (`id`)
                      ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ";

        $queries[] = "CREATE TABLE IF NOT EXISTS `#__dropeditor_styles` (
                         `id` int(11) NOT NULL AUTO_INCREMENT,
						  `title` varchar(100) NOT NULL,
						  `element` varchar(50) NOT NULL,
						  `attributes` text NOT NULL,
						  `css` text NOT NULL,
						  `state` tinyint(4) NOT NULL,
						  `ordering` int(11) NOT NULL,
						  PRIMARY KEY (`id`)
                      ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ";

        $queries[] = "CREATE TABLE IF NOT EXISTS `#__dropeditor_templates` (
                         `id` int(11) NOT NULL AUTO_INCREMENT,
						  `title` varchar(100) NOT NULL,						  
						  `data` text NOT NULL,						  
						  `state` tinyint(4) NOT NULL,
						  `ordering` int(11) NOT NULL,
						  PRIMARY KEY (`id`)
                      ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ";

        $queries[] = "CREATE TABLE IF NOT EXISTS `#__dropeditor_plugins` (
					  `id` int(11) NOT NULL AUTO_INCREMENT,
					  `title` varchar(100) NOT NULL DEFAULT '',
					  `name` varchar(100) NOT NULL,
					  `type` varchar(100) NOT NULL DEFAULT 'command',
					  `row` tinyint(4) NOT NULL DEFAULT '0',
					  `icon` varchar(255) NOT NULL DEFAULT '',
					  `published` tinyint(3) NOT NULL DEFAULT '0',
					  `editable` tinyint(3) NOT NULL DEFAULT '0',
					  `checked_out` int(11) NOT NULL DEFAULT '0',
					  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
					  `iscore` tinyint(3) NOT NULL DEFAULT '0',
					  `acl` text,
					  `params` text NOT NULL,
					  `parentid` int(11) DEFAULT NULL,
					  PRIMARY KEY (`id`),
					  UNIQUE KEY `plugin` (`name`)
					) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ";

        $queries[] = "CREATE TABLE IF NOT EXISTS `#__dropeditor_profiles` (
					  `id` int(11) NOT NULL AUTO_INCREMENT,
					  `title` varchar(100) NOT NULL DEFAULT '',
					  `description` text NOT NULL,
					  `usergroups` varchar(100) NOT NULL,
					  `components` varchar(255) NOT NULL,
					  `state` tinyint(3) NOT NULL DEFAULT '1',
					  `modified_by` int(11) NOT NULL DEFAULT '0',
					  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
					  `ordering` int(11) NOT NULL,
					  `params` text NOT NULL,
					  PRIMARY KEY (`id`)
					) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ";

        $queries[] = "CREATE TABLE IF NOT EXISTS `#__dropeditor_buttons` (
						  `id` int(11) NOT NULL AUTO_INCREMENT,
						  `btnstyle` varchar(20) NOT NULL,
						  `title` varchar(50) NOT NULL,
						  `link` varchar(255) NOT NULL,
						  `params` text NOT NULL,
						  PRIMARY KEY (`id`)
						) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ";
        $queries[] = "CREATE TABLE IF NOT EXISTS `#__dropeditor_bulleteds` (
						  `id` int(11) NOT NULL AUTO_INCREMENT,
						  `icon` varchar(50) NOT NULL,
						  `title` varchar(50) NOT NULL,						
						  `params` text NOT NULL,
						  PRIMARY KEY (`id`)
						) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ";

        foreach ($queries as $query) {
            $dbo->setQuery($query);
            $dbo->execute();
        }
    }

    /**
     * method to uninstall the component
     *
     * @return void
     */
    function uninstall($parent)
    {
        //Prevent the component uninstall without user confirmation
        JLoader::register('JControllerLegacy', JPATH_LIBRARIES . 'legacy/controller/legacy.php');
        $session = JFactory::getSession();
        if ($session->get('dropeditorUninstall', false) == false) {
            //Show a message to the user, he needs to know that all content will be removed
            $session->set('dropeditorUninstall', true);
            JFactory::getApplication()->enqueueMessage('
                <script src="'.JURI::root().'components/com_dropeditor/assets/js/bootbox.min.js"></script>
                <script>
                  jQuery(document).ready(function() {
                     bootbox.alert("'.JText::_("COM_DROPEDITOR_INSTALLER_UNINSTALL_DB").'", "'.JText::_("COM_DROPEDITOR_INSTALLER_UNINSTALL_CONFIRM") .'");
                  })
                </script>'.JText::_('COM_DROPEDITOR_INSTALLER_UNINSTALL_MSG'));
            $controller = new JControllerLegacy();
            $controller->setRedirect('index.php?option=com_installer&view=manage&confirm=1');
            $controller->redirect();
        }

        $dbo = JFactory::getDbo();
        $queries = array();
        $queries[] = "DROP TABLE IF EXISTS `#__dropeditor`";
        $queries[] = "DROP TABLE IF EXISTS `#__dropeditor_customstyles`";
        $queries[] = "DROP TABLE IF EXISTS `#__dropeditor_styles`";
        $queries[] = "DROP TABLE IF EXISTS `#__dropeditor_templates`";
        $queries[] = "DROP TABLE IF EXISTS `#__dropeditor_plugins`";
        $queries[] = "DROP TABLE IF EXISTS `#__dropeditor_profiles`";
        $queries[] = "DROP TABLE IF EXISTS `#__dropeditor_buttons`";
        $queries[] = "DROP TABLE IF EXISTS `#__dropeditor_bulleteds`";

        foreach ($queries as $query) {
            $dbo->setQuery($query);
            $dbo->execute();
        }
    }

    /**
     * method to update the component
     * you can also run extra actions if needed
     * @return void
     */
    function update($parent)
    {
        // $parent is the class calling this method
        $dbo = JFactory::getDbo();
        $queries = array(); //This array will contain all the queries which need to be excuted during install

	    if (version_compare($this->oldRelease, '2.0.0', 'lt')) {
		    // Update new button styles
		    $queries[] = "INSERT INTO `#__dropeditor_buttons` (`btnstyle`, `title`, `link`, `params`) VALUES
            ('1', 'Button text', '', '{\"font-size\":\"13\",\"color\":\"#ffffff\",\"background\":\"#2196F3\",\"padding-left\":\"12\",\"padding-top\":\"6\",\"padding-right\":\"12\",\"padding-bottom\":\"6\",\"border-width\":\"1\",\"border-radius\":\"3\",\"border-color\":\"#2196F3\",\"text-hover\":\"#ffffff\",\"background-hover\":\"#2196F3\",\"border-style\":\"solid\",\"box-shadow-color-hover\":\"#bababa\",\"box-shadow-horz-hover\":\"3\",\"box-shadow-vert-hover\":\"3\",\"box-shadow-blur-hover\":\"3\",\"box-shadow-spread-hover\":\"0\",\"text\":\"Button text\"}'),
            ('1', 'Button text', '', '{\"font-size\":\"13\",\"color\":\"#ffffff\",\"background\":\"#009688\",\"padding-left\":\"12\",\"padding-top\":\"6\",\"padding-right\":\"12\",\"padding-bottom\":\"6\",\"border-width\":\"1\",\"border-radius\":\"3\",\"border-color\":\"#009688\",\"text-hover\":\"#ffffff\",\"background-hover\":\"#009688\",\"border-style\":\"solid\",\"box-shadow-color-hover\":\"#bababa\",\"box-shadow-horz-hover\":\"3\",\"box-shadow-vert-hover\":\"3\",\"box-shadow-blur-hover\":\"3\",\"box-shadow-spread-hover\":\"0\",\"text\":\"Button text\"}'),
            ('1', 'Button text', '', '{\"font-size\":\"13\",\"color\":\"#ffffff\",\"background\":\"#0097a7\",\"padding-left\":\"12\",\"padding-top\":\"6\",\"padding-right\":\"12\",\"padding-bottom\":\"6\",\"border-width\":\"1\",\"border-radius\":\"3\",\"border-color\":\"#0097a7\",\"text-hover\":\"#ffffff\",\"background-hover\":\"#0097a7\",\"border-style\":\"solid\",\"box-shadow-color-hover\":\"#bababa\",\"box-shadow-horz-hover\":\"3\",\"box-shadow-vert-hover\":\"3\",\"box-shadow-blur-hover\":\"3\",\"box-shadow-spread-hover\":\"0\",\"text\":\"Button text\"}');
            ";

		    $queries[] = "TRUNCATE TABLE `#__dropeditor_plugins`";

		    $queries[] = "INSERT INTO `#__dropeditor_plugins` (`id`, `title`, `name`, `type`, `row`, `icon`, `published`, `editable`, `checked_out`, `checked_out_time`, `iscore`, `acl`, `params`, `parentid`) VALUES
                    (1, 'Scayt'           , 'scayt'             , 'plugin'  , 1   , 'ic_spellcheck'             , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 82),
                    (2, ''                , 'sourcearea'        , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (3, 'Source'          , 'source'            , 'command' , 1   , 'ic_code'                   , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 2),
                    (4, 'Preview'         , 'preview'           , 'plugin'  , 1   , 'ic_pageview'               , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (5, 'Cut'             , 'cut'               , 'command' , 0   , 'ic_content_cut'            , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 60),
                    (6, 'Copy'            , 'copy'              , 'command' , 0   , 'ic_content_copy'           , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 60),
                    (7, 'Paste'           , 'paste'             , 'command' , 0   , 'ic_content_paste'          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 60),
                    (8, 'PasteText'       , 'pastetext'         , 'plugin'  , 0   , 'ic_text_fields'            , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (9, 'Find'            , 'find'              , 'plugin'  , 1   , 'ic_search'                 , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (10, 'Replace'        , 'replace'           , 'command' , 1   , 'ic_find_replace'           , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 9),
                    (11, 'SelectAll'      , 'selectall'         , 'plugin'  , 1   , 'ic_select_all'             , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', 0),
                    (13, 'Bold'           , 'bold'              , 'command' , 2   , 'ic_format_bold'            , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 58),
                    (14, 'Italic'         , 'italic'            , 'command' , 2   , 'ic_format_italic'          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 58),
                    (15, 'Strike'         , 'strike'            , 'command' , 2   , 'ic_strikethrough_s'        , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 58),
                    (16, 'Subscript'      , 'subscript'         , 'command' , 2   , 'ic_picture_in_picture_alt' , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 58),
                    (17, 'Superscript'    , 'superscript'       , 'command' , 2   , 'ic_picture_in_picture'     , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 58),
                    (18, 'Underline'      , 'underline'         , 'command' , 2   , 'ic_format_underlined'      , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 58),
                    (19, 'Smiley'         , 'smiley'            , 'plugin'  , 2   , 'ic_insert_emoticon'        , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (21, 'Image'          , 'image'             , 'plugin'  , 2   , 'ic_insert_photo'           , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (23, 'SpecialChar'    , 'specialChar'       , 'plugin'  , 2   , 'ic_folder_special'         , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (24, 'PageBreak'      , 'pagebreak'         , 'plugin'  , 2   , 'ic_linear_scale'           , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    -- (25, 'SpellChecker'   , 'checkspell'        , 'command' , 1   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', 82),
                    (26, ''               , 'tableresize'       , 'plugin'  , 2   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 82),
                    (27, ''               , 'tabletools'        , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 82),
                    (28, 'TextColor'      , 'TextColor'         , 'command' , 3   , 'ic_format_color_text'      , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', 62),
                    (29, 'BGColor'        , 'BGColor'           , 'command' , 3   , 'ic_format_color_fill'      , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', 62),
                    (40, 'NumberedList'   , 'numberedList'      , 'command' , 2   , 'ic_format_list_numbered'   , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 90),
                    (41, 'BulletedDropList', 'bulletedDropList' , 'command' , 2   , 'ic_format_list_bulleted'   , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 106),
                    (42, 'Indent'         , 'indent'            , 'plugin'  , 2   , 'ic_format_indent_increase' , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (43, 'Outdent'        , 'outdent'           , 'command' , 2   , 'ic_format_indent_decrease' , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 42),
                    (44, 'JustifyLeft'    , 'justifyLeft'       , 'command' , 2   , 'ic_format_align_left'      , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 55),
                    (45, 'JustifyCenter'  , 'justifyCenter'     , 'command' , 2   , 'ic_format_align_center'    , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 55),
                    (46, 'JustifyBlock'   , 'justifyBlock'      , 'command' , 2   , 'ic_format_align_justify'   , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 55),
                    (47, 'JustifyRight'   , 'justifyRight'      , 'command' , 2   , 'ic_format_align_right'     , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 55),
                    (48, 'Blockquote'     , 'blockquote'        , 'plugin'  , 2   , 'ic_format_quote'           , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (50, 'Maximize'       , 'maximize'          , 'plugin'  , 3   , 'ic_fullscreen'             , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (51, ''               , 'div'               , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (55, ''               , 'justify'           , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (56, ''               , 'a11yhelp'          , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (58, ''               , 'basicstyles'       , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (59, 'Table'          , 'table'             , 'plugin'  , 2   , 'ic_border_clear'           , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (60, ''               , 'clipboard'         , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (61, ''               , 'selection'         , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (62, ''               , 'colorbutton'       , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (63, 'Unlink'         , 'unlink'            , 'command' , 2   , 'ic_leak_remove'            , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 20),
                    (64, 'Anchor'         , 'anchor'            , 'command' , 2   , 'ic_low_priority'           , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 20),
                    (65, ''               , 'contextmenu'       , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (66, ''               , 'editingblock'      , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (67, ''               , 'elementspath'      , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (68, ''               , 'enterkey'          , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (69, ''               , 'entities'          , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (70, ''               , 'toolbar'           , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (71, ''            , 'jfilebrowser'      , 'filebrowser', 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (72, 'Styles'         , 'Styles'            , 'plugin'  , 3   , 'stylescombo.png'           , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (73, 'Font'           , 'font'              , 'plugin'  , 0   , 'font.png'                  , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (74, 'Format'         , 'format'            , 'plugin'  , 3   , 'format.png'                , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (75, ''               , 'forms'             , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    -- (76, 'About', 'jabout', 'plugin', 3, '-0', 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (80, 'HorizontalRule' , 'horizontalRule'    , 'plugin'  , 2   , 'ic_remove'                 , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (81, 'Print'          , 'print'             , 'plugin'  , 1   , 'ic_print'                  , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (82, ''               , 'wsc'               , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (83, ''               , 'showborders'       , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (84, ''               , 'tab'               , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (85, 'Undo'           , 'undo'              , 'plugin'  , 1   , 'ic_undo'                   , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (86, 'Redo'           , 'redo'              , 'command' , 1   , 'ic_redo'                   , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 86),
                    (87, ''               , 'resize'            , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    -- (88, 'Templates'      , 'templates'         , 'plugin'  , 1   , 'ic_format_paint'           , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (89, ''               , 'wysiwygarea'       , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (90, ''               , 'list'              , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (92, 'FontSize'       , 'fontSize'          , 'command' , 0   , 'fontsize.png'              , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', 73),
                    (93, 'PasteFromWord'  , 'pastefromword'     , 'plugin'  , 0   , 'ic_text_format'            , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (94, 'JLink'          , 'jlink'             , 'plugin'  , 2   , 'ic_insert_link'            , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (95, ''               , 'html5support'      , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (99, ''               , 'imagedragndrop'    , 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (100, ''            , 'ie9selectionoverride', 'plugin'  , 0   , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 1, NULL, '', NULL),
                    (101, 'Buttons'       , 'dropbtns'          , 'plugin'  , 3   , 'ic_wb_iridescent'          , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (102, 'Columns'       , 'columns'           , 'plugin'  , 3   , 'ic_view_array'             , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (103, 'Summary'       , 'summary'           , 'plugin'  , 3   , 'ic_subject'                , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (104, 'Templates'     , 'htmltemplate'      , 'plugin'  , 3   , 'ic_format_paint'           , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (105, 'Panelbutton'   , 'panelbutton'       , 'plugin'  , -1  , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (106, 'Droplist'      , 'droplist'          , 'plugin'  , -1  , ''                          , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (107, 'RemoveFormat'  , 'removeformat'      , 'plugin'  , 1   , 'ic_format_clear'           , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL),
                    (108, 'GgFonts'       , 'ggfonts'           , 'plugin'  , 3   , 'ic_font_download'          , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL);
            ";
	    }
	    if (version_compare($this->oldRelease, '2.3.0', 'lt')) {
	    	$queries[] = "INSERT INTO `#__dropeditor_plugins` (`id`, `title`, `name`, `type`, `row`, `icon`, `published`, `editable`, `checked_out`, `checked_out_time`, `iscore`, `acl`, `params`, `parentid`) VALUES
					(109, 'DropMedia'     , 'dropmedia'         , 'plugin'  , 3   , 'ic_play_circle_outline'    , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL)";
	    }

        if (version_compare($this->oldRelease, '2.5.0', 'lt')) {
            $queries[] = "INSERT INTO `#__dropeditor_plugins` (`id`, `title`, `name`, `type`, `row`, `icon`, `published`, `editable`, `checked_out`, `checked_out_time`, `iscore`, `acl`, `params`, `parentid`) VALUES
					(110, 'NBSP'     , 'nbspace'         , 'plugin'  , 3   , 'ic_space_bar'    , 1, 1, 0, '0000-00-00 00:00:00', 0, NULL, '', NULL)";
        }

        foreach ($queries as $query) {
            $dbo->setQuery($query);
            $dbo->execute();
        }
    }

    /**
     * method to run before an install/update/uninstall method
     *
     * @return mixed
     */
    function preflight($type, $parent)
    {
        // $parent is the class calling this method
        // $type is the type of change (install, update or discover_install)
        if ($type == 'uninstall') {
            //you can check here before uninstalling some things
        } elseif ($type == 'update') {
            //We don't want any update if the user tries to install an old version
            $this->oldRelease = $this->getVersion('com_dropeditor');
            if (version_compare($this->oldRelease, $parent->get('manifest')->version, 'gt')) {
                Jerror::raiseWarning(null, 'You already have a newer version of DropEditor');
                jimport('joomla.application.component.controler');
                $controller = new JControllerLegacy();
                $controller->setRedirect('index.php?option=com_installer&view=install');
                $controller->redirect();
                return false;
            }
        } else {
            $this->release = $parent->get('manifest')->version;
            $jversion = new JVersion();
            // abort if the current Joomla release is older
            if (version_compare($jversion->getShortVersion(), '3.3.0', 'lt')) {
                Jerror::raiseWarning(null, 'Cannot install Dropeditor component in a Joomla release prior to 3.3.0');
                $controller = new JControllerLegacy();
                $controller->setRedirect('index.php?option=com_installer&view=install');
                $controller->redirect();
                return false;
            }
        }

        if ($type == 'update') {
	        // Move old profiles config to media folder
	        $old_config_folder = JPATH_SITE . '/plugins/editors/dropeditor/';
	        $new_config_folder = JPATH_SITE . '/media/dropeditor/';

	        if (JFolder::exists($old_config_folder)) {
		        $list_old_configs = scandir( $old_config_folder );
		        foreach ( $list_old_configs as $config_file ) {
			        if ( strpos( $config_file, 'config_p' ) !== false ) {
				        JFile::copy( $old_config_folder . $config_file, $new_config_folder . $config_file );
				        // Update config file if they updated from version before 2.0.0
				        $content = file_get_contents( $new_config_folder . $config_file );
				        if ( strpos( $content, 'config.skin' ) === false ) {
					        $new_content = str_replace( '};', "config.skin = 'material'; //updated" . "\n" . "};", $content );
					        JFile::write( $new_config_folder . $config_file, $new_content );
				        }
			        }
		        }
	        }

	        // Update old profiles config files
            if (JFolder::exists($new_config_folder)) {
	            $list_new_configs = scandir($new_config_folder);
	            foreach ($list_new_configs as $new_config) {
	                if (strpos($new_config, 'config_p') !== false) {
	                    $content = file_get_contents($new_config_folder . $new_config);
	                    if (strpos($content, 'CKEDITOR.dtd.') === false) {
	                        $new_content = str_replace(
	                            '};',
                                '};'. "\n" .'CKEDITOR.dtd.$removeEmpty["i"] = false;'. "\n" .'CKEDITOR.dtd.$removeEmpty["span"] = false;',
                                $content
                            );
                            JFile::write( $new_config_folder . $new_config, $new_content );
                            $content = $new_content;
                        }
                        if (strpos($content, 'config.pasteFromWordRemoveStyles') === false) {
	                        $new_content = str_replace(
	                            '};',
                                'config.pasteFromWordRemoveStyles = false;'. "\n" .'config.pasteFromWordRemoveFontStyles = false;'. "\n" ."};",
                                $content
                            );
                            JFile::write( $new_config_folder . $new_config, $new_content );
                        }
                    }
                }
            }
        }

        $session = JFactory::getSession();
        $session->set('dropeditorUninstall', false);

	    return true;
    }

    /**
     * method to run after an install/update/uninstall method
     *
     * @return mixed
     */
    function postflight($type, $parent)
    {
        // $parent is the class calling this method
        // $type is the type of change (install, update or discover_install)
        if ($type == 'install') {
            //Once the component is installed we may want to do others things like adding categories for this component
            $dbo = JFactory::getDbo();
            $schema = JPATH_ADMINISTRATOR . '/components/com_dropeditor/sql/insert.sql';
            // Attempt to import the database schema.
            if (!$this->populateDatabase($dbo, $schema)) {
                return false;
            }
        }
        if ($type == 'install' || $type == 'update') {
        /*
         * Here we will install extra extensions like plugins,
         * all this extensions are in the folder /admin/extensions/extname
        */
            $lang = JFactory::getLanguage();
            $lang->load('com_dropeditor.sys', JPATH_ROOT . '/components/com_dropeditor', null, true);

            $manifest = $parent->get('manifest');
            JLoader::register('DropeditorInstallerHelper', JPATH_ADMINISTRATOR . '/components/com_dropeditor/helpers/installer.php');
            echo '<h2>' . JText::_('COM_DROPEDITOR_INSTALLER_TITLE') . '</h2>';
            echo JText::_('COM_DROPEDITOR_INSTALLER_MSG');

            $extensions = $manifest->extensions;

            foreach ($extensions->children() as $extension) {
                $folder = $extension->attributes()->folder;
                $enable = $extension->attributes()->enable;
                if ($folder == "com-droppics") {
                    //check if droppics is exist already
                    $dbo = JFactory::getDbo();
                    $query = 'SELECT extension_id FROM #__extensions WHERE element="com_droppics" AND type="component"';
                    $result = true;
                    if (!$dbo->setQuery($query)) {
                        $result = false;
                    }
                    if (!$dbo->execute()) {
                        $result = false;
                    }
                    $component = $dbo->loadResult();
                    if (!$component) {
                        $result = false;
                    }
                    if ($result) {
                        $oldRelease = $this->getVersion('com_droppics');
                        if(strpos($oldRelease,"_light") === false ) {
                            continue;
                        }
                    }
                } else if ($folder == "com-dropfiles") {
                    //check if droppics is exist already
                    $dbo = JFactory::getDbo();
                    $query = 'SELECT extension_id FROM #__extensions WHERE element="com_dropfiles" AND type="component"';
                    $result = true;
                    if (!$dbo->setQuery($query)) {
                        $result = false;
                    }
                    if (!$dbo->execute()) {
                        $result = false;
                    }
                    $component = $dbo->loadResult();
                    if (!$component) {
                        $result = false;
                    }
                    if ($result) {
                        $oldRelease = $this->getVersion('com_dropfiles');
                        if(strpos($oldRelease,"_light") === false ) {
                            continue;
                        }
                    }

                }

                if (DropeditorInstallerHelper::install(JPATH_ADMINISTRATOR . '/components/com_dropeditor/extensions/' . $folder, $enable)) {
                    //                        JFile::delete(JPATH_ADMINISTRATOR.'/components/com_sponsorshipreward/extensions/'.$folder);
                    echo '<img style="padding: 5px 10px;" src="' . JURI::root() . '/components/com_dropeditor/assets/images/tick.png" />' . $folder . ' : ' . JText::sprintf('COM_DROPEDITOR_INSTALLER_EXT_OK', '') . '<br/>';
                } else {
                    echo '<img style="padding: 5px 10px;" src="' . JURI::root() . '/components/com_dropeditor/assets/images/exclamation.png" />' . $folder . ' : ' . JText::sprintf('COM_DROPEDITOR_INSTALLER_EXT_NOK', '') . '<br/>';
                }
            }

            $db = JFactory::getDBO();
            $query = $db->getQuery(true);
            $query->select('*');
            $query->from('#__dropeditor_plugins');
            $query->where($db->quoteName('title') . ' = ' . $db->quote('GgFonts'));
            $db->setQuery($query);
            $result = $db->loadResult();
            if (empty($result)) {
                $query = $db->getQuery(true);
                $columns = array('id', 'title', 'name', 'type', 'row', 'icon', 'published', 'editable', 'checked_out', 'checked_out_time', 'iscore', 'params');
                $values = array(108, $db->quote('GgFonts'), $db->quote('ggfonts'), $db->quote('plugin'), 3, $db->quote('ggfonts.png'), 1, 1, 0, $db->quote('0000-00-00 00:00:00'), 0, $db->quote(''));
                $query
                    ->insert($db->quoteName('#__dropeditor_plugins'))
                    ->columns($db->quoteName($columns))
                    ->values(implode(',', $values));

                $db->setQuery($query);
                $db->execute();
            }

	        // Adding default editor config files if no config files exist
	        JLoader::register('ckeditorHelper', JPATH_ADMINISTRATOR.'/components/com_dropeditor/helpers/ckeditorHelper.php');
	        $profiles = ckeditorHelper::getProfile();
	        $params = json_decode($profiles->params);
	        $profiles->buttons = $params->buttons;
	        $config_file = JPATH_SITE . '/media/dropeditor/config_p'. $profiles->id . '.js';

	        if (!JFile::exists($config_file)) {
		        settype($profiles, "array");
		        ckeditorHelper::writeProfileConfig($profiles);
	        }
        }

        $dbo = JFactory::getDbo();
        $tables = $dbo->getTableList();
        $app = JFactory::getApplication();
        $prefix = $app->getCfg('dbprefix');
        if (in_array($prefix . 'joomunited_config', $tables)) {
            $query = $dbo->getQuery(true);
            $query->select('*');
            $query->from('#__joomunited_config');
            $dbo->setQuery($query);

            $results = $dbo->loadObject();
            if (!empty($results)) {
                $token = $results->value;
                if (!empty($token)) {
                    $token = str_replace('token=', '', $token);
                    $com_name = $parent->get('element');
                    $script = '<script type="text/javascript">';
                    $script .= 'jQuery(document).ready(function($){';
                    $script .= "jQuery.ajax({
                                                url     :   'index.php?option=$com_name&task=jutoken.ju_add_token',
                                                method    : 'GET',
                                                dataType : 'json',
                                                data    :   {
                                                    'token': '$token',
                                                }
                                            }).done(function(response){

                                            });";
                    $script .= '});';
                    $script .= '</script>';
                    echo $script;
                }
            }
        }

        // Clean cache
        $conf = JFactory::getConfig();
        $options = array(
            'defaultgroup' => '',
            'storage' => $conf->get('cache_handler', ''),
            'caching' => true,
            'cachebase' => $conf->get('cache_path', JPATH_ADMINISTRATOR. '/cache')
        );
        $cache = JCache::getInstance('', $options);
        $cache->clean();

	    return true;
    }


    /**
     * Method to import a database schema from a file.
     *
     * @param   JDatabaseDriver $db JDatabase object.
     * @param   string $schema Path to the schema file.
     *
     * @return  boolean  True on success.
     *
     * @since   3.1
     */
    public function populateDatabase($db, $schema)
    {
        // Get the application
        /* @var InstallationApplicationWeb $app */
        $app = JFactory::getApplication();

        $return = true;

        // Get the contents of the schema file.
        if (!($buffer = file_get_contents($schema))) {
            $app->enqueueMessage($db->getErrorMsg(), 'notice');
            return false;
        }

        // Get an array of queries from the schema and process them.
        $queries = $this->_splitQueries($buffer);

        foreach ($queries as $query) {
            // Trim any whitespace.
            $query = trim($query);

            // If the query isn't empty and is not a MySQL or PostgreSQL comment, execute it.
            if (!empty($query) && ($query{0} != '#') && ($query{0} != '-')) {
                // Execute the query.
                $db->setQuery($query);

                try {
                    $db->execute();
                } catch (RuntimeException $e) {
                    $app->enqueueMessage($e->getMessage(), 'notice');
                    $return = false;
                }
            }
        }

        return $return;
    }

    /**
     * Method to split up queries from a schema file into an array.
     *
     * @param   string $query SQL schema.
     *
     * @return  array  Queries to perform.
     *
     * @since   3.1
     */
    protected function _splitQueries($query)
    {
        $buffer = array();
        $queries = array();
        $in_string = false;

        // Trim any whitespace.
        $query = trim($query);

        // Remove comment lines.
        $query = preg_replace("/\n\#[^\n]*/", '', "\n" . $query);

        // Remove PostgreSQL comment lines.
        $query = preg_replace("/\n\--[^\n]*/", '', "\n" . $query);

        // Find function
        $funct = explode('CREATE OR REPLACE FUNCTION', $query);

        // Save sql before function and parse it
        $query = $funct[0];

        // Parse the schema file to break up queries.
        for ($i = 0; $i < strlen($query) - 1; $i++) {
            if ($query[$i] == ";" && !$in_string) {
                $queries[] = substr($query, 0, $i);
                $query = substr($query, $i + 1);
                $i = 0;
            }

            if ($in_string && ($query[$i] == $in_string) && $buffer[1] != "\\") {
                $in_string = false;
            } elseif (!$in_string && ($query[$i] == '"' || $query[$i] == "'") && (!isset ($buffer[0]) || $buffer[0] != "\\")) {
                $in_string = $query[$i];
            }
            if (isset ($buffer[1])) {
                $buffer[0] = $buffer[1];
            }
            $buffer[1] = $query[$i];
        }

        // If the is anything left over, add it to the queries.
        if (!empty($query)) {
            $queries[] = $query;
        }

        // Add function part as is
        for ($f = 1; $f < count($funct); $f++) {
            $queries[] = 'CREATE OR REPLACE FUNCTION ' . $funct[$f];
        }

        return $queries;
    }

    /**
     * Method to get the version of a component
     * @param string $option
     * @return null
     */
    private function getVersion($option)
    {
        $manifest = self::getManifest($option);
        if (@property_exists($manifest, 'version')) {
            return $manifest->version;
        }
        return null;
    }

    /**
     * Method to get an object containing the manifest values
     * @param string $option
     * @return object
     */
    private function getManifest($option)
    {
//                $component = JComponentHelper::getComponent($option);
        $dbo = JFactory::getDbo();
        $query = 'SELECT extension_id FROM #__extensions WHERE element=' . $dbo->quote($option) . ' AND type="component"';
        if (!$dbo->setQuery($query)) {
            return false;
        }
        if (!$dbo->execute()) {
            return false;
        }
        $component = $dbo->loadResult();
        if (!$component) {
            return false;
        }
        $table = JTable::getInstance('extension');
        // Load the previous Data
        if (!$table->load($component, false)) {
            return false;
        }
        return json_decode($table->manifest_cache);
    }

}