/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

jQuery(document).ready(function($) {
    if (typeof (DropButton) == 'undefined') {            
        DropButton = {};
    } 
    if (typeof (DropButton.styles) == 'undefined') {            
        DropButton.styles = {};
    } 
    DropButton.styles_markup = '';
    DropButton.styles_hover_markup = '';
    DropButton.pixel_properties = ['font-size', 'border-radius', 'border-width', 'padding', 'padding-top', 'padding-right', 'padding-bottom', 'padding-left'];
    DropButton.default_styles = {'font-size': 13,'color':'#ffffff','background':'#0E83CD', 'padding-left':'12','padding-top':'6','padding-right':'12',
                               'padding-bottom':'6','border-width':0, 'border-radius':0,'border-color':'#357ebd','text-hover':'#ffffff','background-hover':'#0e83cd'};
    
     $('#btn_save').unbind('click').click(function(e) {
         updateButton($("#previewBtn").data('id-button'));
     });
    $('#btn_add').unbind('click').click(function(e) {       
         insertButton();
     });
       
    $('.incr').unbind('click').click(function(e) {
        var id = $(this).attr('id').replace('_incr','');
        var current_value = $('#jform_'+id).val();
        if (current_value == "") {
            current_value = 0;
        }
        $('#jform_'+id).val((parseInt(current_value || 0)) + 1).trigger('change');
    });
       
    $('.decr').unbind('click').click(function() {
        var id = $(this).attr('id').replace('_decr','');
        var current_value = $('#jform_'+id).val();       
        if (current_value == "") {
            current_value = '0';
        }
        if (current_value === '0')
            return;
        $('#jform_'+id).val(Math.abs(parseInt(current_value) - 1)).trigger('change');
    });
      
      
    $('.minicolors').on('change', function(e) {
         var css_property = $(this).data('css-prop');
         var css_val = $(this).val();
         DropButton.styles[css_property] = css_val ;
         update_styles();
    });

    $('.observeBtnChanges').on('input propertychange change click', function(e) {
        var css_property = $(this).data('css-prop');               
        DropButton.styles[css_property] = $(this).val() ;       
        update_styles();             
    });
    
    var update_styles = function() {
        prepare_styles();
        DropButton.styles_markup = generate_style_markup(DropButton.styles);        
        DropButton.styles_markup = '#previewBtn {\n' + DropButton.styles_markup + '}'; // wrap the style markups in proper css calls
        
        DropButton.styles_hover_markup = generate_style_markup_hover(DropButton.styles);   
        if(DropButton.styles_hover_markup != '') {
            DropButton.styles_hover_markup = '\n\n#previewBtn:hover {\n' + DropButton.styles_hover_markup + '}';
        }
        render_styles();        
    };
    
    var prepare_styles = function() {        
        // remove the text data
        $('#previewBtn').html(DropButton.styles['text']);
          
        DropButton.styles = $.extend({},DropButton.default_styles, DropButton.styles);
        // combine padding if all are present
        var padding_top, padding_right, padding_bottom, padding_left;
        if((padding_top = DropButton.styles['padding-top']) &&
           (padding_right = DropButton.styles['padding-right']) &&
           (padding_bottom = DropButton.styles['padding-bottom']) &&
           (padding_left = DropButton.styles['padding-left'])){
            DropButton.styles['padding'] = padding_top + 'px ' + padding_right + 'px ' + padding_bottom + 'px ' + padding_left;
        }

        DropButton.styles['border-style'] = (DropButton.styles['border-width'] ) ? "solid" : "none";                            
    };
    prepare_styles();
    var generate_style_markup = function(styles) {
        var styles_markup = '';   
        
        // border radius
        var border_radius;
        if((border_radius = styles['border-radius'])){
          styles_markup += render_style_line('-webkit-border-radius', border_radius);
          styles_markup += render_style_line('-moz-border-radius', border_radius);
          styles_markup += render_style_line('border-radius', border_radius);
          //delete DropButton.styles['border-radius'];
        }
        
        $.each(styles, function(css_property, css_value){          
            if( (css_property=="background" || (css_property.indexOf('color') !== -1)) && css_value == "" ) {
                //styles_markup += render_style_line(css_property, css_value);     
                styles_markup += render_style_line(css_property, "transparent");  
            }
            // ignore the hover background
            else if(css_property != 'background-hover'){
                styles_markup += render_style_line(css_property, css_value);              
            } 
        });
        
        return styles_markup;
    };
    
    var generate_style_markup_hover  = function(styles) {
        var styles_hover_markup = '';  
        if(typeof styles['background-hover'] != undefined && styles['background-hover'] != '') {
             styles_hover_markup += render_style_line('background', styles['background-hover']);
        }  
        if(typeof styles['text-hover'] != undefined && styles['text-hover'] != '') {
             styles_hover_markup += render_style_line('color', styles['text-hover']);
        }
        if(typeof styles['box-shadow-color-hover'] !== undefined && styles['box-shadow-color-hover'] !== '') {
            styles_hover_markup += render_box_shadow_line(styles['box-shadow-horz-hover'], styles['box-shadow-vert-hover'], styles['box-shadow-blur-hover'], styles['box-shadow-spread-hover'], styles['box-shadow-color-hover']);
        }
        return styles_hover_markup;
    };
    
    /**
    * Update the output of the css styles
    */
    var render_styles = function(){
        var output = DropButton.styles_markup + DropButton.styles_hover_markup;
        var style_tag = '<style id="dynamic-styles" type="text/css">' + output + '</style>';
        $('#dynamic-styles').replaceWith(style_tag);
    };

    var render_styles_btns = function() {
        var output = '',
        styles_markup =  '',
        styles_hover_markup =  '';
        $.each(DropButtons, function(btnId, btn_styles){
            if(btn_styles != null & btn_styles != '') {                
                styles_markup = generate_style_markup(btn_styles);
                styles_markup = '#btn-'+ btnId + '{\n' + styles_markup + '}';

                styles_hover_markup = generate_style_markup_hover(btn_styles);  
                if(styles_hover_markup != '') {
                    styles_hover_markup = '#btn-'+ btnId +':hover {\n' + styles_hover_markup + '}';             
                }
                output +=  styles_markup +  '\n' + styles_hover_markup + '\n';
            }
        });
       
       var style_tag = '<style id="btn-styles" type="text/css">' + output + '</style>';
       $('#btn-styles').replaceWith(style_tag);    
    };

    /**
    * Renders an individual style line
    */
    var render_style_line = function(css_property, css_value){
        // check if "px" should appended to the style
        var px_value = $.inArray(css_property, DropButton.pixel_properties) > -1 ? 'px' : '';
        var tab = '  ';
        return tab + css_property + ': ' + css_value + px_value + ';\n';
    };

    var render_box_shadow_line = function (h_off, v_off, blur, spread, color) {
        style_content = 'box-shadow: ' + h_off + 'px ' + v_off +'px '+ blur + 'px ' + spread +'px '+ color + ';';
        style_content += '-moz-' + style_content + '-webkit-' + style_content;

        return style_content;
    };

    var initMenu = function() {
        $('#btnList .btnItem .trash').unbind('click').on('click', function() {
            id_button = $(this).closest('li').data('id-button');
            bootbox.confirm(Joomla.JText._('COM_LAYERSLIDESHOW_JS_WANT_DELETE_BUTTON', 'Do you really want to delete this button?'), function(result) {
                if (result === true) {
                    $.ajax({
                        url: "index.php?option=com_dropeditor&task=button.delete&id_button=" + id_button,
                        type: 'POST',

                        success: function(response) {
                            result = jQuery.parseJSON(response);
                            if (result.status === true) {
                                $('#btnList li[data-id-button=' + id_button + ']').remove();

                            } else {
                                bootbox.alert(result.datas);
                            }
                        },
                        error: function(jqxhr, textStatus, error) {
                            bootbox.alert(textStatus + " : " + error);
                        }
                    });
                }
            });
            return false;
        });

        $('#btnList .btnItem .icon-edit').unbind('click').on('click', function() {
            var id_button = $(this).closest('li').data('id-button');
            DropButton.styles = $.extend({}, DropButton.default_styles, DropButtons[id_button]);
            var btnParams = DropButton.styles;
           
            $("#previewBtn").data('id-button', id_button);
            $('#previewBtn').html( $('#btn-'+ id_button).text() );
            populateParams(btnParams);
            setLink(DropLinks[id_button]);
            update_styles();
        });
       
        $('#btnList .btnItem .insert').unbind('click').on('click', function() { 
            id_button = $(this).closest('li').data('id-button');
            btnParams = DropButtons[id_button];
         
            insertButton(btnParams, $('#btn-'+ id_button).text().trim(),  DropLinks[id_button] );
        });
       
    };
    initMenu();
   
    var populateParams = function(params) {
        $.each(params, function(css_prop, css_val){
            if($('[data-css-prop="'+css_prop+'"]').hasClass('minicolors-input')) {
                $('[data-css-prop="'+css_prop+'"]').minicolors('value', css_val).change();
            } else {
                $('[data-css-prop="'+css_prop+'"]').val(css_val);
            }
       });
    };
   
   var getLink = function() {
       var href= $("#link_custom_id").val();   
       var link_type = $("#link_type").val();
       if(link_type==='article'){
            href =  $('#link_content_article_link').val();
       } else if(link_type==='menuitem') {
            var menuitem = $('#link_content_menuitem_id').val();             
            if(menuitem.substring(0,4)==='www.'){
                  href = 'http://'+menuitem;
            }else {
                href = menuitem;
            }
            
       }else {
           if(href !=='' & href.substring(0,4)==='www.'){
                  href = 'http://'+href;
            }else if(href !=='' &  href.indexOf('//') === -1) {
                  href = 'http://'+href;
            }
       }
       return href;
   };
   
   var setLink = function(url, type) {
      if(typeof type === 'undefined' || (type !='article' && type != 'menuitem') )  {
          type='custom';
      }
      
      $("#link_type").val(type);
      $('.link_content_block').hide();
      if(type=='custom') {          
          $("#link_custom_id").val(url);
          $('#link_custom').show();
      }else if(type=='article') {
          $("#link_content_article_id_name").val(url);
          $("#link_content_article_link").val(url);
           $('#link_content_article').show();
          
      }else if(type=='menuitem') {
           segs =  url.split("Itemid=");
           var itemId = segs.pop();
           $('#link_content_menuitem_id').val(itemId);
           $('#link_content_menuitem').show();
      }
      
   };
   
   var updateButton = function(id_button, callBack) {
        if(typeof id_button == 'undefined') {
            addButton();
            return;
        }
       
        //var params= DropButton;
        var params = $.extend({}, DropButton.default_styles, DropButton.styles);
        var jsonVar = {
            jform: {
                title: $("#jform_button_label").val(), 
                link:  getLink(), 
                btnstyle: $("#button_style").val(),                 
                params: params //JSON.stringify()           
            },
            id: id_button
        };
       
        
        $.ajax({
            url: "index.php?option=com_dropeditor&task=button.update",
            dataType: "json",
            type: "POST",
            data: jsonVar,
            success: function(response) {
                if (response.status === true) {
                    autosaveNotification = setTimeout(function() {
                        $('#savedInfo').fadeIn(200).delay(2000).fadeOut(1000);
                    }, 1000);
                   
                   $('#btnList li[data-id-button="'+id_button+'"]').html(
                                             '<a class="dropbtn" id="btn-'+ id_button +'" >'
                                            + jsonVar.jform.title +'</a><br/>'
                                            + '<div style="margin-left: 6px;"><a class="insert" title="Insert"><i class="icon-plus"></i></a> <a class="edit"><i class="icon-edit"></i></a><a class="trash"><i class="icon-trash"></i></a></div>'
                                            );
                    
                    DropButtons[jsonVar.id] = params;                  
                    DropLinks[jsonVar.id] = jsonVar.jform.link;                    
                    render_styles_btns();
                    
                    initMenu();
                    
                    if(typeof callBack =='function') {
                        callBack();
                    }
                } else {
                    bootbox.alert(response.status);
                }
            },
            error: function(jqxhr, textStatus, error) {
                bootbox.alert(textStatus + " : " + error);
            }
        });
   };
     
   var addButton = function(callBack) {
       var params = $.extend({}, DropButton.default_styles, DropButton.styles);
       var jsonVar = {
           jform: {
               title: $("#jform_button_label").val(),
               btnstyle: $("#button_style").val(),
               link:  getLink(),
               params: params //JSON.stringify()
           }
       };
    
       $.ajax({
            url: "index.php?option=com_dropeditor&task=button.add",
            dataType: "json",
            type: "POST",
            data: jsonVar,
            success: function(response) {
                if (response.status === true) {
                    autosaveNotification = setTimeout(function() {
                        $('#savedInfo').fadeIn(200).delay(2000).fadeOut(1000);
                    }, 1000);
                  
                    $('#btnList').append('<li class="btnItem" data-id-button="'+ response.datas.id + '">' 
                                            + '<a class="dropbtn" id="btn-'+ response.datas.id +'">'
                                            + jsonVar.jform.title +'</a><br/>'
                                            + '<div style="margin-left: 6px;"><a class="insert" title="Insert"><i class="icon-plus"></i></a> <a class="edit"><i class="icon-edit"></i></a><a class="trash"><i class="icon-trash"></i></a></div>'
                                            + '</li>');
                    DropButtons[response.datas.id] = params;
                    DropLinks[response.datas.id] = jsonVar.jform.link;
                    $("#previewBtn").data('id-button', response.datas.id);
                    render_styles_btns();
                    initMenu();
                    
                    if(typeof callBack =='function') {
                        callBack();
                    }
                } else {
                    bootbox.alert(response.status);
                }
            },
            error: function(jqxhr, textStatus, error) {
                bootbox.alert(textStatus + " : " + error);
            }
        });
   };

   var initButtonParams =  function() {
        if(typeof window.parent.CKEDITOR !== 'undefined') {
            var ckEditor = window.parent.CKEDITOR.instances[e_name];             
            el = ckEditor.getSelection().getStartElement();               
            if(typeof el != "undefined" && el != null ) {
                if(el.$.tagName=='A' && el.hasClass("dropbtn") ) {
                    var id_button =  el.getAttribute("data-id-button");
                  
                    url = el.getAttribute("href");
                    text = el.$.textContent ;
                    $("#jform_button_label").val(text).change();

                    editingStyle = {};
                    editingStyle["font-size"] =  el.getAttribute("data-font-size");
                    editingStyle["color"] =  el.getAttribute("data-color");
                    editingStyle["background"]   = el.getAttribute("data-background");
                    editingStyle["background-hover"]   = el.getAttribute("data-background-hover");
                    editingStyle["border-color"]   = el.getAttribute("data-border-color");
                    editingStyle["border-radius"]   = el.getAttribute("data-border-radius");
                    editingStyle["border-width"]   = el.getAttribute("data-border-width");
                    editingStyle["padding-bottom"]   = el.getAttribute("data-padding-bottom");
                    editingStyle["padding-left"]   = el.getAttribute("data-padding-left");
                    editingStyle["padding-right"]   = el.getAttribute("data-padding-right");
                    editingStyle["padding-top"]   = el.getAttribute("data-padding-top");
                    editingStyle["text-hover"]   = el.getAttribute("data-text-hover");
                    editingStyle["box-shadow-color-hover"]   = el.getAttribute("data-box-shadow-color-hover");
                    editingStyle["box-shadow-vert-hover"]   = el.getAttribute("data-box-shadow-vert-hover");
                    editingStyle["box-shadow-horz-hover"]   = el.getAttribute("data-box-shadow-horz-hover");
                    editingStyle["box-shadow-blur-hover"]   = el.getAttribute("data-box-shadow-blur-hover");
                    editingStyle["box-shadow-spread-hover"]   = el.getAttribute("data-box-shadow-spread-hover");

                    try {
                        DropButton.styles = $.extend({}, DropButton.default_styles, editingStyle );
                        populateParams(DropButton.styles);
                        setLink( url);
                        //console.log('update style', DropButton.styles);
                        update_styles();
                    }catch(err) {
                        console.log(err);
                    }
                }
            }
                   
        }
   };
   
   initButtonParams();
   
   function insertButton(styles, btn_text, btn_link) {
        if(typeof styles == 'undefined') {
            styles = DropButton.styles;
            btn_text = $('#jform_button_label').val();
            btn_link = getLink();   
        }
        
        var output= '';
        var id= guid();
         
        var styles_markup = generate_style_markup(styles);
        styles_markup = '#btn_'+ id  + '{\n' + styles_markup + '}';

        var styles_hover_markup = generate_style_markup_hover(styles);
        if(styles_hover_markup !== '') {
             styles_hover_markup = '#btn_'+ id + ':hover {\n' + styles_hover_markup + '}';             
        }
        output +=  styles_markup +  '\n' + styles_hover_markup + '\n';
        var style_tag = '<style id="btn-style-'+id+'" type="text/css">' + output + '</style>';
   
        var data_attr = generate_data_attr(styles) ;
        if( $("#previewBtn").data('id-button') ) data_attr +=  ' data-id-button="'+ $("#previewBtn").data('id-button') + '" ';
        var btnHtml = '<a type="button" id="btn_'+id+'" '+data_attr+ ' href="' + btn_link +'" class="dropbtn">'+ btn_text +'</a>';
        if(editMode=='update') {
            var ckEditor = window.parent.CKEDITOR.instances[e_name];             
            var el = ckEditor.getSelection().getStartElement();

            // Remove old block
            elm_id = el.getAttribute('id');
            style_id = elm_id.replace('btn_', 'btn-style-');
            style_block = ckEditor.document.getById(style_id);
            if (style_block) style_block.remove();
            el.remove();

            // Insert new one
            window.parent.jInsertEditorText(btnHtml + '\n'+ style_tag,e_name)
        }else {
            if (window.parent) {
                window.parent.jInsertEditorText(btnHtml + '\n'+ style_tag,e_name)                    
            }
        }
   }

   render_styles_btns();
   
    var generate_data_attr = function(styles) {
        var data_attr = '';   
    
        $.each(styles, function(css_property, css_value){                    
           data_attr += 'data-' + css_property+'="' + css_value+'" ' ;
        });
    
        return data_attr;
    };

    function guid() {
        function s4() {
            return Math.floor((1 + Math.random()) * 0x10000)
            .toString(16)
            .substring(1);
        }
        return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
          s4() + '-' + s4() + s4() + s4();
    }

    $(function () {
        // Get default properties if user doesn't change anything and insert
        setTimeout(function () {
            $('.observeBtnChanges, .minicolors').each(function (e) {
                var css_property = $(this).data('css-prop');
                DropButton.styles[css_property] = $(this).val();
                update_styles();
            })
        }, 500);
    });
});