/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


jQuery(document).ready(function($) {
    if (typeof (DropBulleted) == 'undefined') {
        DropBulleted = {};
    }

    if (typeof (DropBulleted.styles) == 'undefined') {
        DropBulleted.styles = {};
    }
    DropBulleted.styles_markup = '';
    DropBulleted.styles_text = '';
    DropBulleted.pixel_properties = ['font-size', 'line-height', 'margin', 'padding','text-size'];
    DropBulleted.default_styles = {'font-size': 13, 'padding':'5','margin':'5','line-height':'15','text-size': 13};


    if (typeof (Dropeditor.bulleted) == 'undefined') {
        Dropeditor.bulleted = {};
    }

    $('#btn_add').unbind('click').click(function(e) {
        insertBulleted();
    });
    $('#btn_save').unbind('click').click(function(e) {
        updateBulleted($("#previewList").data('id-bulleted'));
    });


    $('.incr').unbind('click').click(function(e) {
        var id = $(this).attr('id').replace('_incr','');
        var current_value = $('#jform_'+id).val();
        if (current_value == "") {
            current_value = 0;
        }
        $('#jform_'+id).val((parseInt(current_value || 0)) + 1).trigger('change');
    });

    $('.decr').unbind('click').click(function() {
        var id = $(this).attr('id').replace('_decr','');
        var current_value = $('#jform_'+id).val();
        if (current_value == "") {
            current_value = '0';
        }
        if (current_value === '0')
            return;
        $('#jform_'+id).val(Math.abs(parseInt(current_value) - 1)).trigger('change');
    });

    $('#bulleted_icon').ddslick({
        onSelected: function(selectedData) {
            //callback function: do something with selectedData;
            $("#previewList").removeClass();
            if (selectedData.selectedData.value !== "") {
                $("#previewList").addClass("droplist " + selectedData.selectedData.value);
                $('.observeListChanges').each(function (e) {
                    var css_property = $(this).data('css-prop');
                    DropBulleted.styles[css_property] = $(this).val();
                    if(css_property=='text-size'){
                        DropBulleted.styles_text = 'font-size:'+ $(this).val() + 'px';
                    }
                    update_styles();
                });
            }
        },
        width: 215
    });

    $('.observeListChanges').on('input propertychange change click', function(e) {
        var css_property = $(this).data('css-prop');
        DropBulleted.styles[css_property] = $(this).val() ;
        if(css_property=='text-size'){
            DropBulleted.styles_text = 'font-size:'+ $(this).val() + 'px';
        }
        update_styles();

    });

    var update_styles = function() {
        DropBulleted.styles_markup = generate_style_markup(DropBulleted.styles);
        DropBulleted.styles_markup =  '#previewList li {\n' + DropBulleted.styles_text + '}' + '#previewList li:before {\n' + DropBulleted.styles_markup + '}' ; // wrap the style markups in proper css calls

        render_styles();
    };

    var render_styles = function(){
        var output = DropBulleted.styles_markup ;
        var style_tag = '<style id="dynamic-styles" type="text/css">' + output + '</style>';
        $('#dynamic-styles').replaceWith(style_tag);
    };

    var generate_style_markup = function(styles) {
        var styles_markup = '';

        $.each(styles, function(css_property, css_value){
            styles_markup += render_style_line(css_property, css_value);
        });

        return styles_markup;
    };

    var render_styles_bulleteds = function() {
        var output = '',
            styles_markup =  '';
        $.each(DropBulleteds, function(btnId, btn_styles){
            if(btn_styles != null & btn_styles != '') {
                styles_markup = generate_style_markup(btn_styles);
                styles_markup = '#bul-'+ btnId + ' li:before {\n' + styles_markup + '}';

                output +=  styles_markup +  '\n' ;
            }
        });

        var style_tag = '<style id="bulleted-styles" type="text/css">' + output + '</style>';
        $('#bulleted-styles').replaceWith(style_tag);
    };

    /**
     * Renders an individual style line
     */
    var render_style_line = function(css_property, css_value){
        // check if "px" should appended to the style
        var px_value = $.inArray(css_property, DropBulleted.pixel_properties) > -1 ? 'px' : '';
        var tab = '  ';
        return tab + css_property + ': ' + css_value + px_value + ';\n';
    };

    var initMenu = function() {

        $('#btnList .btnItem .trash').unbind('click').on('click', function() {

            id_bulleted = $(this).closest('li').data('id-bulleted');
            bootbox.confirm(Joomla.JText._('COM_DROPEDITOR_JS_WANT_DELETE_BUTTON', 'Do you really want to delete this bulleted?'), function(result) {
                if (result === true) {
                    $.ajax({
                        url: "index.php?option=com_dropeditor&task=bulleted.delete&id_bulleted=" + id_bulleted,
                        type: 'POST',
                        //  data: Dropeditor.token + '=1',
                        success: function(response) {
                            result = jQuery.parseJSON(response);
                            if (result.status === true) {
                                $('#btnList li[data-id-bulleted=' + id_bulleted + ']').remove();

                            } else {
                                bootbox.alert(result.datas);
                            }
                        },
                        error: function(jqxhr, textStatus, error) {
                            bootbox.alert(textStatus + " : " + error);
                        }
                    });
                }
            });
            return false;
        });

        $('#btnList .btnItem .icon-edit').unbind('click').on('click', function() {
            id_bulleted = $(this).closest('li').data('id-bulleted');
            btnParams = DropBulleteds.styles = DropBulleteds[id_bulleted] ;
            populateParams(btnParams);
            var $clone =  $(this).closest('li').find('.dropbtn').clone();
            $clone.attr('id','previewList');
            $("#preview").html($clone);
            var clas = $('#btnList ul[data-id-bulleted="'+ id_bulleted +'"]').attr('class');
            var prev = '<ul id="previewList" class="'+ clas +'" data-id-bulleted="'+ id_bulleted +'">'+
                '<li>List item</li>'+
                '<li>List item</li>'+
                '</ul>';
            $("#preview").append(prev);
        });

        $('#btnList .btnItem .insert').unbind('click').on('click', function() {
            id_bulleted = $(this).closest('li').data('id-bulleted');
            bulClass = $(this).closest('li').find('ul').attr('class');
            bulParams = DropBulleteds[id_bulleted] ;
            insertBulleted(bulParams, bulClass);
        });
    };
    initMenu();

    var getBulletedParams =  function() {
        Dropeditor.bulleted.icon = $(".dd-selected-value").val();
        Dropeditor.bulleted.color = $("#jform_bulleted_color").val();
        Dropeditor.bulleted.font_size = $("#jform_bulleted_font_size").val();
        Dropeditor.bulleted.text_size = $("#jform_bulleted_text_size").val();
        Dropeditor.bulleted.line_height = $("#jform_bulleted_line_height").val();
        Dropeditor.bulleted.padding = $("#jform_bulleted_padding").val();
        Dropeditor.bulleted.margin = $("#jform_bulleted_margin").val();
    };
    getBulletedParams();

    var populateParams = function(params) {
        var clas = $('#btnList ul[data-id-bulleted="'+ id_bulleted +'"]').attr('class');
        var val = clas.replace('droplist ','');
        var index = $('#bulleted_icon li:has(input[value="'+ val +'"])').index();
        if(index < 0) index = 0;
        $('#bulleted_icon').ddslick('select', {index: index}).change();
        $('.minicolors-input').minicolors('value',params.color?params.color:'#000000').change();
        $("#jform_bulleted_font_size").val(params['font-size']).change();
        $("#jform_bulleted_text_size").val(params['text-size']).change();
        $("#jform_bulleted_line_height").val(params['line-height']).change();
        $("#jform_bulleted_padding").val(params.padding).change();
        $("#jform_bulleted_margin").val(params.margin).change() ;
    };


    var updateBulleted = function(id_bulleted, callBack) {
        if(typeof id_bulleted == 'undefined') {
            addBulleted();
            return;
        }

        var params = $.extend(true, DropBulleted.default_styles, DropBulleted.styles);
        var jsonVar = {
            jform: {
                icon: $(".dd-selected-value").val(),
                title: "",
                params: params //JSON.stringify()           
            },
            id: id_bulleted
        };

        $.ajax({
            url: "index.php?option=com_dropeditor&task=bulleted.update",
            dataType: "json",
            type: "POST",
            data: jsonVar,
            success: function(response) {
                if (response.status === true) {
                    autosaveNotification = setTimeout(function() {
                        $('#savedInfo').fadeIn(200).delay(2000).fadeOut(1000);
                    }, 1000);
                    var btnCss = $("#previewList").attr('style');
                    $('#btnList li[data-id-bulleted="'+id_bulleted+'"]').find('ul').removeClass();
                    if( jsonVar.jform.icon !== "") {
                        $('#btnList li[data-id-bulleted="'+id_bulleted+'"]').find('ul').addClass("droplist "+ jsonVar.jform.icon);
                    }
                    DropBulleteds[id_bulleted] = params;
                    render_styles_bulleteds();

                    if(typeof callBack =='function') {
                        callBack();
                    }
                } else {
                    bootbox.alert(response.status);
                }
            },
            error: function(jqxhr, textStatus, error) {
                bootbox.alert(textStatus + " : " + error);
            }
        });
    };

    var addBulleted = function(callBack) {
        var params = $.extend(true, DropBulleted.default_styles, DropBulleted.styles);
        var jsonVar = {
            jform: {
                title: "",
                icon: $(".dd-selected-value").val(),
                params: params //JSON.stringify()           
            }
        };

        $.ajax({
            url: "index.php?option=com_dropeditor&task=bulleted.add",
            dataType: "json",
            type: "POST",
            data: jsonVar,
            success: function(response) {
                if (response.status === true) {
                    autosaveNotification = setTimeout(function() {
                        $('#savedInfo').fadeIn(200).delay(2000).fadeOut(1000);
                    }, 1000);

                    $('#btnList').append('<li class="btnItem" data-id-bulleted="'+ response.datas.id + '">'
                        + '<ul id="bul-'+ response.datas.id+'" class="droplist '+ jsonVar.jform.icon +'" data-id-bulleted="'+ response.datas.id + '" >'
                        + '<li>List item</li>' +'</ul><br/>'
                        + '<div style="margin-left: 6px;"><a class="trash"><i class="icon-trash"></i></a><a class="edit"><i class="icon-edit"></i></a><a class="insert" title="Insert"><i class="icon-plus"></i></a></div>'
                        + '</li>');
                    DropBulleteds[response.datas.id] = params;
                    $("#previewList").data('id-bulleted', response.datas.id);
                    render_styles_bulleteds();
                    initMenu();

                    if(typeof callBack =='function') {
                        callBack();
                    }
                } else {
                    bootbox.alert(response.status);
                }
            },
            error: function(jqxhr, textStatus, error) {
                bootbox.alert(textStatus + " : " + error);
            }
        });
    };

    function insertBulleted(styles, cls) {
        if (typeof styles == 'undefined') {
            styles = DropBulleted.styles;
            cls = $(".dd-selected-value").val();
        }

        var id = guid();

        if(cls !== "") cls = "droplist " + cls;

        var style_tag = '';
        var data_attr = '';
        if (!jQuery.isEmptyObject(styles)) {
            data_attr = generate_data_attr(styles);
            var text_indent = parseInt(styles['font-size']) + parseInt(styles.margin)*2 + parseInt(styles.padding)*2;

            styles_markup = generate_style_markup(styles);
            styles_markup = '#bul-'+ id + ' li ' + '{\n font-size: '+ styles["text-size"] +'px;' + '\n'
                + 'margin-left: ' + text_indent + 'px;' + '\n'
                + 'text-indent: -' + text_indent + 'px;' + '\n'
                + '}' +  '\n'
                + '#bul-'+ id + ' li:before ' + '{\n' + styles_markup + '}\n';
            style_tag = '<style id="style-bul-'+ id +'" class="style-bul" type="text/css">' + styles_markup + '</style>';
        }

        var ckEditor = window.parent.CKEDITOR.instances[e_name];
        var el = ckEditor.getSelection().getStartElement();
        if (el && el.getText() !=='') {
            item_text = el.getText();
        } else {
            item_text = 'List item';
        }

        var lst = null;
        while (el) {
            if (el.getName() == 'ul')
            {
                lst = el;
                break;
            }

            el = el.getParent();
        }

        if(typeof lst != "undefined" && lst != null )  { //update
            var innerHtml = lst.getHtml();

            //remove old style
            var lstId = lst.getAttribute('id'), styleId= "";
            if(lstId != null && lstId != "" ) styleId= "style-" + lstId;
            if(styleId != "") {
                var styleElement = ckEditor.document.getById(styleId );
                if (styleElement) styleElement.remove();
            }

            //Replace old node
            listHtml = '<ul id="bul-' +id + '" class="'+ cls +'" '+ data_attr + ' >'+innerHtml+'</ul>'; // + '\n'+ style_tag;
            var new_node = window.parent.CKEDITOR.dom.element.createFromHtml( listHtml );
            new_node.replace(lst);

            //add new style
            if (style_tag) {
                var styleNode = window.parent.CKEDITOR.dom.element.createFromHtml(style_tag);
                styleNode.insertAfter(new_node);
            }


            var ckDialog = window.parent.CKEDITOR.dialog.getCurrent();
            if (ckDialog) {
                ckDialog.hide();
            }
        } else { //insert

            listHtml = '<ul id="bul-' +id + '" class="'+ cls +'" '+ data_attr + ' ><li>'+item_text+'</li></ul>';
            if (typeof window.parent != 'undefined' && style_tag) {
                window.parent.jInsertEditorText(listHtml + '\n'+ style_tag,e_name);
            }
        }
    }

    //open from ckeditor window  => check and populate params
    if (typeof window.parent.CKEDITOR != 'undefined') {
        var ckEditor = window.parent.CKEDITOR.instances[e_name];
        el = ckEditor.getSelection().getStartElement();
        var lst = null;
        while (el) {
            if (el.getName() == 'ul' && el.hasClass("droplist")) {
                lst = el;
                break;
            }

            el = el.getParent();
        }
        if (typeof lst != "undefined" && lst != null ) {
            var id_bulleted =  lst.getAttribute("data-id-bulleted");
            if (typeof id_bulleted != 'undefined' && id_bulleted != "" && id_bulleted != null)  {
                $('#btnList li[data-id-bulleted=' + id_bulleted + '] .icon-edit').click();
            } else {
                icon = lst.getAttribute("class");
                icon = icon.replace(/droplist /g, '');
                var index = $('#bulleted_icon li:has(input[value="'+ icon +'"])').index();
                $('#bulleted_icon').ddslick('select', {index: index});
                font_size =  lst.getAttribute("data-font-size");
                text_size =  lst.getAttribute("data-text-size");
                line_height =  lst.getAttribute("data-line-height");
                margin =  lst.getAttribute("data-margin");
                padding = lst.getAttribute("data-padding");
                color = lst.getAttribute("data-color");

                $("#jform_bulleted_font_size").val((font_size)?font_size:'13').change();
                $("#jform_bulleted_text_size").val((text_size)?text_size:'13').change();
                $('#jform_bulleted_line_height').val((line_height)?line_height:'15').change();
                $('#jform_bulleted_margin').val((margin)?margin:'5').change();
                $('.minicolors-input').val(color).change();
                $('#jform_bulleted_padding').val((padding)?padding:'5').change();
            }
        }
    }


    var generate_data_attr = function(styles) {
        var data_attr = '';

        $.each(styles, function(css_property, css_value){
            data_attr += 'data-' + css_property+'="' + css_value+'" ' ;
        });

        return data_attr;
    };

    render_styles_bulleteds();

    function guid() {
        function s4() {
            return Math.floor((1 + Math.random()) * 0x10000)
                .toString(16)
                .substring(1);
        }
        return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
            s4() + '-' + s4() + s4() + s4();
    }
});