(function () {
    parent.jQuery('.cke_dialog_contents_body').css('padding', 0);
})();

jQuery(document).ready(function($) {
    // Find out whether we have any anchors in the editor.
    // Get all IMG elements in CK document.
    var editor = parent.CKEDITOR.currentInstance,
        elements = editor.document.getElementsByTag('img'),
        realAnchors = new parent.CKEDITOR.dom.nodeList(editor.document.$.anchors),
        anchors = [];

    for (var i = 0; i < elements.count() ; i++) {
        var item = elements.getItem(i);
        if (item.data('cke-realelement') && item.data('cke-real-element-type') === 'anchor')
            anchors.push( editor.restoreRealElement(item) );
    }

    for (i = 0 ; i < realAnchors.count() ; i++)
        anchors.push(realAnchors.getItem(i));

    // Prepare anchors data for tree view
    for (i = 0 ; i < anchors.length ; i++) {
        item = anchors[i];
        anchors[i] = {
            text : item.getAttribute('name'),
            aid : item.getAttribute('id'),
            type: 'item'
        };
    }

    // Group them in a root category
    var all_anchors = {
        text: 'Anchors',
        pid: 0,
        type: 'root',
        children: anchors
    };

    $('#link_type').ddslick({
        onSelected: function (data) {
            $('.link_content_block').hide();
            $(".childContent").hide();
            var selectedValue = data.selectedData.value;
            $("#"+selectedValue+"Frame").show();
            loadTree(selectedValue);

            if (selectedValue !== 'custom' && selectedValue !== 'mailto' && selectedValue !== 'menuitem') {
                avaiHeight = parent.window.innerHeight - 28 - 34 - 5;
                parent.jQuery('.cke_dialog_contents_body').css('height', Math.min(avaiHeight, 600));
                if (Math.min(avaiHeight, 600) === avaiHeight) {
                    parent.jQuery('.cke_dialog').css('top', 0);
                }
            }

            switch(selectedValue){
                case 'article':
                    $('#link_content_article').show();
                    break;
                case 'menuitem':
                    $('#link_content_menuitem').show();
                    break;
                case 'custom':
                    $('#link_custom').show();
                    break;
                case 'k2':
                    $('#link_content_k2').show();
                    break;
                case 'dropfiles':
                    $('#link_content_dropfiles').show();
                    break;
                case 'flexi':
                    $('#link_content_flexi').show();
                    break;
                case 'anchor':
                    $('#link_content_anchor').show();
                    break;
                case 'mailto':
                    $('#mail_to_link').show();
                    break;
            }
        },
        width: 210
    });

    $('#link_target').ddslick({width: 210});

    // Load tree view
    function loadTree(component) {
        var data = {
            'url': 'index.php?option=com_dropeditor&task=link.getItems',
            'dataType': 'json',
            'data': function (node) {
                var thisComp = this.element[0].dataset.comp;
                var thisID = node.id;
                if (node.id !== '#') {
                    thisID = node.original.pid;
                }

                return {'id': thisID, 'comp': thisComp}
            },
            'check_callback': false     // Prevent tree modification
        };
        if (component === 'anchor') data = all_anchors;

        $('#' + component + 'Tree').jstree({
            'plugins': ['search', 'types', 'dnd'],
            'core': {
                'data': data,
                'themes': {
                    'stripes': true
                },
                'multiple': false
            },
            'types': {
                'default': {'icon': 'dropicon-folder'},
                'category': {'icon': 'dropicon-folder'},
                'item': {'valid_chidren': [], 'icon': 'dropicon-file'}
            },
            'search': {
                'case_insensitive': true,
                'show_only_matches': true
            }
        });

        $('#'+component+'Tree').on('search.jstree', function (event, matches) {
            if (matches.res.length === 0) {
                $('#'+component+'Tree').jstree(true).hide_all();
            }
        });

        $('#'+component+'Tree').on('activate_node.jstree', function (e, data) {
            var name = data.node.original.text;
            if (component !== 'dropfiles') {
                if (data.node.original.type === 'root') {
                    $('#link_content_'+component+'_name').val('');
                } else {
                    $('#link_content_' + component + '_name').val(name);
                }
            }

            // Setup the link url to insert
            if (data.node.type === 'category') {
                var id = data.node.original.pid;
                var link_url = '';
                switch (component) {
                    case 'article':
                        link_url = '?option=com_content&view=category&id='+id;
                        break;
                    case 'dropfiles':
                        $('#link_content_dropfiles_name').val('');
                        break;
                    case 'k2':
                        link_url = 'index.php/component/k2/itemlist/category/'+id;
                        break;
                    case 'flexi':
                        link_url = 'index.php/content_page/'+id;
                        break;
                }
                $('#link_content_'+component+'_link').val(link_url);
            } else if (data.node.type === 'item') {
                var aid = data.node.original.aid;
                var url_link = '';
                switch (component) {
                    case 'article':
                        url_link = '?option=com_content&view=article&id='+aid;
                        break;
                    case 'dropfiles':
                        $('#link_content_dropfiles_name').val(name);
                        url_link = data.node.original.url;
                        break;
                    case 'k2':
                        url_link = 'index.php/component/k2/item/'+aid;
                        break;
                    case 'flexi':
                        var pid = data.node.original.parent_id;
                        url_link = 'index.php/content_page/'+pid+'/'+aid;
                        break;
                    case 'anchor':
                        url_link = '#'+aid;
                        break;
                }
                $('#link_content_'+component+'_link').val(url_link);
            }
        });

        // Search function for the tree
        $('#'+component+'-search').on('keypress keyup', function () {
            $('#'+component+'Tree').jstree(true).show_all();
            $('#'+component+'Tree').jstree('search', $(this).val());
        });
        $('#'+component+'-search-submit').unbind('click').on('click', function () {
            $('#'+component+'Tree').jstree(true).show_all();
            $('#'+component+'Tree').jstree('search', $('#'+component+'-search').val());
        });
    }

    // Get link element params when open from editor
    var element = parent.CKEDITOR.plugins.link.getSelectedLink(editor),
        thisText = '',
        thisHref = '',
        thisTitle = '',
        thisTarget = '',
        thisType = '';

    if (element) {
        thisText  = element.getText();
        thisHref = element.getAttribute('href');
        thisTitle = element.getAttribute('title');
        thisTarget = element.getAttribute('target');
        thisType = element.getAttribute('data-link-type');
    } else {
        var sel = editor.getSelection();
        if(sel.getType() == parent.CKEDITOR.SELECTION_NONE) {
            //do nothing
        }else if (sel.getType() == parent.CKEDITOR.SELECTION_TEXT) {
            thisText = sel.getSelectedText();
        }else if (sel.getType() == parent.CKEDITOR.SELECTION_ELEMENT) {
            thisText = sel.getSelectedElement().getOuterHtml();
        }
    }

    if (thisType === 'mailto') {
        thisHref = thisHref.replace('mailto:', '');
    }

    // Populate params to right fields
    $('#link_text').val(thisText);
    $('#link_title').val(thisTitle);
    switch (thisType) {
        case 'custom':
            $('#link_custom_id').val(thisHref);
            break;
        case 'mailto':
            $('#email_input').val(thisHref);
            break;
        default:
            $('#link_content_'+thisType+'_name').val(thisText);
            break;
    }
    if (thisTarget) {
        var targetIndex = $('#link_target li:has(input[value="'+ thisTarget +'"])').index();
        $('#link_target').ddslick('select', {index: targetIndex}).change();
    }
    if (thisType) {
        typeIndex = $('#link_type li:has(input[value="'+ thisType +'"])').index();
        $('#link_type').ddslick('select', {index: typeIndex}).change();
    }
});

var editMode ='insert';
function getLink() {
    var $ = jQuery;
    var link_type =  $("#link_type input").val();
    var href= $("#link_custom_id").val();
    switch (link_type) {
        case 'article':
            href =  $('#link_content_article_link').val();
            break;
        case 'menuitem':
            var menuitem = $('#link_content_menuitem_id').val();
            if(menuitem.substring(0,4)==='www.'){
                href = 'http://'+menuitem;
            } else  {
                href = menuitem;
            }
            break;
        case 'k2':
            href = $('#link_content_k2_link').val();
            break;
        case 'dropfiles':
            href = $('#link_content_dropfiles_link').val();
            break;
        case 'flexi':
            href = $('#link_content_flexi_link').val();
            break;
        case 'anchor':
            href = $('#link_content_anchor_link').val();
            break;
        case 'mailto':
            href = $('#email_input').val();
            if (href.indexOf('mailto:') === -1) {
                href = 'mailto:' + href;
            }
            break;
        default: // When using custom link
            if(href.substring(0,4)==='www.'){
                href = 'http://'+href;
            }else if(href.indexOf('//') === -1) {
                href = 'http://'+href;
            }
            break;
    }

    return href;
}
function getLinkHtml() {
    var $ = jQuery;
    var href= getLink();
    var link_type =  $("#link_type input").val();
    var link_text = $('#link_text').val().trim();
    if (link_text == '') {
        switch (link_type) {
            case 'article':
                link_text = $('#link_content_article_name').val();
                break;
            case 'menuitem':
                link_text = $("#link_content_menuitem_id option:selected").text().replace( /-/g, "" ).trim() ;
                break;
            case 'k2':
                link_text = $('#link_content_k2_name').val();
                break;
            case 'dropfiles':
                link_text = 'Download file';
                break;
            case 'flexi':
                link_text = $('#link_content_flexi_name').val();
                break;
            case 'anchor':
                link_text = $('#link_content_anchor_name').val();
                break;
            case 'mailto':
                link_text = 'Send email';
                break;
            default: // When using custom link
                link_text = href;
                break;
        }
    }

    var result='<a ';
    result += 'href="'+ href + '" ';
    result += 'target="'+ $("#link_target input").val() + '" ';
    result += 'title="'+ $("#link_title").val().trim() + '" ';
    result += 'data-link-type="'+ link_type + '" ';
    result += '>';
    result += link_text + '</a>';

    return result;
}