jQuery(document).ready(function ($) {
    var video_datas = {},
        yt_video_datas = {},
        vm_video_datas = {},
        editor = window.parent.CKEDITOR.currentInstance;

    $('.submit-btn').addClass('disabled').attr('disabled', true);

    $('.video-url').on('change', function (e) {
        var thisUrl = $(this).val().trim(),
            videoType = $(this).attr('id'),
            video_id = '';
        videoType = videoType.replace('-video-url', '');

        $('#insert-'+videoType).addClass('disabled').attr('disabled', true);
        $('#'+videoType+'-video-title').text('');
        $('#'+videoType+'-video').html('');

        if (thisUrl == "") {
            return false;
        }

        if (!checkValidUrl(thisUrl, videoType)) {
            alert('Invalid '+videoType+' url!');
            return false;
        }

        switch (videoType) {
            case 'youtube':
                if (thisUrl.indexOf('youtu.be') !== -1) {
                    video_id = thisUrl.split('/');
                    video_id = video_id[video_id.length - 1];

                    break;
                }
                video_id = thisUrl.split('v=');
                video_id = video_id[1];
                var ampPos = video_id.indexOf('&');
                if(ampPos !== -1) {
                    video_id = video_id.substring(0, ampPos);
                }

                break;
            case 'vimeo':
                video_id = thisUrl.split('/');
                video_id = video_id[video_id.length - 1];

                var ampPos = video_id.indexOf('&');
                if(ampPos !== -1) {
                    video_id = video_id.substring(0, ampPos);
                }

                break;
            default:
                break;
        }

        $('#'+videoType+'-video').html('<div data-type="'+videoType+'" data-video-id="'+video_id+'"></div>');
        var player = plyr.setup('#'+videoType+'-video');
        player = player[0];
        player.on('ready', function () {
            $.ajax({
                url: 'index.php?option=com_dropeditor&task=media.getVideoInfo',
                method: 'POST',
                dataType: 'json',
                data: {
                    video_id: video_id,
                    video_type: videoType
                },
                success: function (res, stt) {
                    if (res.status === true) {
                        if (videoType == 'youtube') {
                            yt_video_datas = $.extend({}, res.datas);
                        } else {
                            vm_video_datas = $.extend({}, res.datas);
                        }
                        $('#'+videoType+'-video-title').text(res.datas.title);
                        $('#insert-'+videoType).removeClass('disabled').removeAttr('disabled');
                    } else {
                        bootbox.alert(res.datas.msg);
                    }
                }
            });
        });
    });

    function loadTreeItems() {
        $('.treeBlock').jstree({
            'plugins': ['search', 'types', 'dnd'],
            'core': {
                'data': {
                    'url': 'index.php?option=com_dropeditor&task=media.getItemsList',
                    'dataType': 'json',
                    'data': function (node) {
                        var type = this.element[0].id.replace('-tree', '');
                        var cFolder = node.text;
                        var cParent = '';
                        if (node.original) {
                            cParent = node.original.parentPath;
                        }

                        return {'cFolder': cFolder, 'cParent': cParent, 'cType': type}
                    },
                    'check_callback': false     // Prevent tree modification
                },
                'themes': {
                    'stripes': true
                },
                'multiple': false
            },
            'types': {
                'default': {'icon': 'dropicon-folder'},
                'folder': {'icon': 'dropicon-folder'},
                'video': {'valid_chidren': [], 'icon': 'dropicon-video'},
                'sound': {'valid_chidren': [], 'icon': 'dropicon-sound'}
            },
            'search': {
                'case_insensitive': true,
                'show_only_matches': true
            }
        });

        $('.treeBlock').on('activate_node.jstree', function (e, data) {
            type = $(this).attr('id').replace('-tree', '');
            if (data.node.type !== 'folder') {
                name = data.node.original.text;
                path = '';
                if (data.node.original.parentPath) {
                    path = data.node.original.parentPath + '/';
                    jroot_media_strip = jroot_media.slice(0, -1);
                }
                path = jroot_media_strip + path + name;
                htmlTag = '';
                if (type === 'video') {
                    htmlTag += '<video controls><source src="' + path + '" /></video>';
                } else if (type === 'sound') {
                    htmlTag += '<audio controls><source src="' + path + '"></audio>';
                }

                $('#' + type + '-local-file').val(name);
                $('#' + type + '-local-src').val(path);
                $('#' + type + '-video').html(htmlTag);
                var player = plyr.setup('#'+type+'-video');
                player = player[0];
                player.on('ready', function (ev) {
                    $('#insert-' + type).removeClass('disabled').removeAttr('disabled');
                })
            } else {
                $('#insert-' + type).addClass('disabled').attr('disabled', true);
                $('#' + type + '-local-file').val('');
                $('#' + type + '-local-src').val('');
                $('#' + type + '-video').html('');
            }
        })
    }
    loadTreeItems();

    $('.load-type').on('change', function () {
        videoType = $(this).attr('id');
        videoType = videoType.replace('-load-type', '');
        loadType = $(this).val();
        if (loadType === 'popup') {
            $('#'+videoType+'-video-thumb').show();
        } else {
            $('#'+videoType+'-video-thumb').hide();
        }
    });

    $('.video-max-width').on('input', function () {
        var max_width = parseInt($(this).val()) || 'none',
            videoType = $(this).attr('id');
        videoType = videoType.replace('-video-max-width', '');

        $('#'+videoType+'-preview-block').css('max-width', max_width);
    });

    // Insert Youtube or Vimeo to article
    $('.submit-btn:not(.local-file)').unbind('click').click(function () {
        var cEditor = window.parent.CKEDITOR.currentInstance,
            videoType = $(this).attr('id').replace('insert-', '');
        if (videoType === 'youtube') {
            video_datas = yt_video_datas;
        } else {
            video_datas = vm_video_datas;
        }
        video_datas['loadType'] = $('#'+videoType+'-load-type').val();
        video_datas['maxWidth'] = parseInt($('#'+videoType+'-video-max-width').val()) || 'none';
        video_datas['url'] = $('#'+videoType+'-video-url').val();
        vid_max_width = (video_datas.maxWidth === 'none') ? '100%' : video_datas.maxWidth+'px';
        vid_thumb = video_datas.thumbnail;
        custom_thumb = $('#'+videoType+'-video-thumb input#jform_dropmediaThumbnail').val();

        if (video_datas.loadType === 'popup') {
            vid_thumb = custom_thumb || video_datas.thumbnail;
        }

        imgTag = '<img';
        imgTag += ' src="'+ vid_thumb + '"';
        imgTag += ' style="max-width: '+ vid_max_width + '; min-width: 200px; display: block;"';
        imgTag += ' data-dropmedia="true"';
        imgTag += ' data-host="'+ video_datas.type + '"';
        imgTag += ' data-video-id="'+ video_datas.id + '"';
        imgTag += ' data-video-title="'+ video_datas.title + '"';
        imgTag += ' data-max-width="'+ video_datas.maxWidth + '"';
        imgTag += ' data-load-type="'+ video_datas.loadType + '"';
        imgTag += ' data-direct-link="'+ video_datas.directLink + '"';
        imgTag += ' data-video-url="'+ video_datas.url + '"';
        imgTag += ' />';

        var imgHtml = new window.parent.CKEDITOR.dom.element.createFromHtml(imgTag);
        cEditor.insertElement(imgHtml);

        var ckDialog = window.parent.CKEDITOR.dialog.getCurrent();
        if(ckDialog) {
            ckDialog.hide();
        }
    });

    // Insert local medias to article
    $('.submit-btn.local-file').unbind('click').click(function () {
        var cEditor = window.parent.CKEDITOR.currentInstance,
            htmlWrapper = '';
            videoType = $(this).attr('id').replace('insert-', '');
        file_data = {};
        file_data['src'] = $('#'+videoType+'-local-src').val();
        file_data['name'] = $('#'+videoType+'-local-file').val();
        file_data['loadType'] = $('#'+videoType+'-load-type').val();
        file_data['maxWidth'] = parseInt($('#'+videoType+'-video-max-width').val()) || 'none';
        vid_max_width = (file_data.maxWidth === 'none') ? '100%' : file_data.maxWidth+'px';

        htmlWrapper = '<img';
        htmlWrapper += ' style="max-width: '+ vid_max_width + '; min-width: 200px; display: block;"';
        htmlWrapper += ' data-dropmedia="true"';
        htmlWrapper += ' data-host="'+ videoType + '"';
        htmlWrapper += ' data-max-width="'+ file_data.maxWidth + '"';
        htmlWrapper += ' data-load-type="'+ file_data.loadType + '"';
        htmlWrapper += ' data-video-title="'+ file_data.name + '"';
        htmlWrapper += ' data-local-file="'+ file_data.src + '"';
        if (videoType === 'video') {
            vid_thumb = $('#video-video-thumb input#jform_dropmediaThumbnail').val() || dropeditor_img_folder + 'video_placeholder.png';
            if (file_data.loadType === 'content') vid_thumb = dropeditor_img_folder + 'video_placeholder.png';
            htmlWrapper += ' src="'+ vid_thumb + '"';
        } else if (videoType === 'sound') {
            htmlWrapper += ' src="'+ dropeditor_img_folder + 'audio_placeholder.png"';
        }
        htmlWrapper += ' />';

        var imgHtml = new window.parent.CKEDITOR.dom.element.createFromHtml(htmlWrapper);
        cEditor.insertElement(imgHtml);

        var ckDialog = window.parent.CKEDITOR.dialog.getCurrent();
        if(ckDialog) {
            ckDialog.hide();
        }
    });

    // Open from CKEDITOR to edit inserted media
    if (editor) {
        elm = editor.getSelection().getStartElement();
        if (elm && elm.getAttribute('data-dropmedia') === 'true') {
            // Get all information needed
            editingMedia = {};
            editingMedia['host'] = elm.getAttribute('data-host');
            editingMedia['videoURL'] = elm.getAttribute('data-video-url');
            editingMedia['videoTitle'] = elm.getAttribute('data-video-title');
            editingMedia['videoSrc'] = elm.getAttribute('data-local-file');
            editingMedia['loadType'] = elm.getAttribute('data-load-type');
            editingMedia['maxWidth'] = elm.getAttribute('data-max-width');
            editingMedia['thumbnail'] = elm.getAttribute('src');
            if (editingMedia['maxWidth'] === 'none') editingMedia['maxWidth'] = '';

            // Populate them to right places
            $('.tabs .tab a[href="#'+editingMedia.host+'-tab"]').trigger('click');
            $('#'+editingMedia.host+'-load-type').val(editingMedia.loadType).trigger('change');
            $('#'+editingMedia.host+'-video-max-width').val(editingMedia.maxWidth).trigger('input');

            if (editingMedia.thumbnail.indexOf('http') === -1) {
                $('#'+editingMedia.host+'-video-thumb input#jform_dropmediaThumbnail').val(editingMedia.thumbnail);
            }

            if (editingMedia.host === 'youtube' || editingMedia.host === 'vimeo') {
                $('#' + editingMedia.host + '-video-url').val(editingMedia.videoURL).trigger('change');
            } else {
                $('#'+editingMedia.host+'-local-file').val(editingMedia.videoTitle);
                $('#'+editingMedia.host+'-local-src').val(editingMedia.videoSrc);
                $('#insert-'+editingMedia.host).removeClass('disabled').removeAttr('disabled');
            }
        }
    }

    function checkValidUrl(url, host) {
        if (host == 'youtube') {
            return (url.match(/youtube.com|youtu.be/));
        } else {
            return (url.match(/vimeo.com/));
        }
    }
});