<?php
/**
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die;

JHtml::_('behavior.tooltip');
JHtml::_('behavior.formvalidation');
JHtml::_('behavior.keepalive');
JHtml::_('behavior.framework');
JHtml::_('behavior.colorpicker');
JHtml::_('formbehavior.chosen', '.chzn-select');

JText::script('COM_DROPEDITOR_JS_SAMPLE_TEXT');

JText::script('COM_DROPEDITOR_JS_ARE_YOU_SURE');
JText::script('COM_DROPEDITOR_JS_DELETE');
JText::script('COM_DROPEDITOR_JS_EDIT');
JText::script('COM_DROPEDITOR_JS_DBLCLICK_TO_EDIT_TITLE');
JText::script('COM_DROPEDITOR_JS_WANT_DELETE');
JText::script('COM_DROPEDITOR_JS_CANCEL');
JText::script('COM_DROPEDITOR_JS_OK');
JText::script('COM_DROPEDITOR_JS_CONFIRM');
JText::script('COM_DROPEDITOR_JS_SAVE');

$doc = JFactory::getDocument();
$doc->addScriptDeclaration('e_name="' . JRequest::getString('e_name') . '";');
$update = JRequest::getInt('update', 0);
$baseUlr = JUri::root() . '/plugins/editors/dropeditor/fonts/svg/';
?>
<div class="container" id="bulleted_creator">
    <div class="row-fluid">
        <div class="span4">
            <div class="form-inline" >

                <div class=" control-group" style="margin-bottom: 20px;">
                    <div class="control-label">
                        <label id="filter_element-lbl" for="filter_element" style="font-weight: bold">
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON'); ?>
                        </label>
                    </div>
                    <div class="controls">
                        <select name="bulleted_icon" id="bulleted_icon" class="input-medium" >			
                            <option value="" data-imagesrc="">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_0'); ?></option>
                            <option value="drop-pushpin" data-imagesrc="<?php echo $baseUlr . 'pushpin.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_1'); ?></option>
                            <option value="drop-cog" data-imagesrc="<?php echo $baseUlr . 'cog.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_2'); ?></option>
                            <option value="drop-flag" data-imagesrc="<?php echo $baseUlr . 'flag.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_3'); ?></option>
                            <option value="drop-star" data-imagesrc="<?php echo $baseUlr . 'star.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_4'); ?></option>
                            <option value="drop-checkmark" data-imagesrc="<?php echo $baseUlr . 'checkmark.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_5'); ?></option>
                            <option value="drop-minus" data-imagesrc="<?php echo $baseUlr . 'minus.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_6'); ?></option>  
                            <option value="drop-plus"  data-imagesrc="<?php echo $baseUlr . 'plus.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_7'); ?></option>
                            <option value="drop-play" data-imagesrc="<?php echo $baseUlr . 'play.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_8'); ?></option>
                            <option value="drop-arrow-right" data-imagesrc="<?php echo $baseUlr . 'arrow-right.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_9'); ?></option>
                            <option value="drop-checkbox-checked" data-imagesrc="<?php echo $baseUlr . 'checkbox-checked.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_10'); ?></option>
                            <option value="drop-radio-checked" data-imagesrc="<?php echo $baseUlr . 'radio-checked.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_11'); ?></option>  
                            <option value="drop-radio-unchecked" data-imagesrc="<?php echo $baseUlr . 'radio-unchecked.svg'; ?>">
                                <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_ICON_12'); ?></option>

                        </select>
                    </div>
                </div>

                <div class=" control-group">
                    <div class="control-label">
                        <label  for="jform_button_fontsize">
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_FONT_SIZE'); ?> :
                        </label>

                    </div>
                    <div class="controls">                       
                            <input name="jform[jform_button_font_size]" data-css-prop="font-size" class="mini-input observeListChanges" id="jform_bulleted_font_size" value="13" type="text">
                            <button class="btn incr" type="button" id="bulleted_font_size_incr">+</button>
                            <button class="btn decr" type="button" id="bulleted_font_size_decr">-</button>                        
                    </div>

                </div>
                
                <div class=" control-group">
                    <div class="control-label">
                        <label  for="jform_color_image">
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_COLOR_IMAGE'); ?> :
                        </label>

                    </div>
                    <div class="controls">                       
                            <input name="jform[jform_color_image]" data-css-prop="color" id="jform_bulleted_color"
                               class="minicolors minicolors-input observeListChanges"
                               data-position="left" data-control="hue"
                               type="text" value="#000000" size="7" />                        
                    </div>

                </div>
                
                <div class=" control-group">
                    <div class="control-label">
                        <label  for="jform_button_textsize">
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_TEXT_SIZE'); ?> :
                        </label>

                    </div>
                    <div class="controls">                       
                            <input name="jform[jform_button_textsize]" data-css-prop="text-size" class="mini-input observeListChanges" id="jform_bulleted_text_size" value="13" type="text">
                            <button class="btn incr" type="button" id="bulleted_text_size_incr">+</button>
                            <button class="btn decr" type="button" id="bulleted_text_size_decr">-</button>                        
                    </div>

                </div>

                <div class=" control-group">
                    <div class="control-label">
                        <label id="jform_bulleted_line_height-lbl" for="jform_bulleted_line_height">
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_BULLETED_LINE_HEIGHT'); ?> :
                        </label>
                    </div>
                    <div class="controls">                                               
                            <input name="jform[jform_bulleted_line_height]" data-css-prop="line-height" class="mini-input observeListChanges" id="jform_bulleted_line_height" value="15" type="text">
                            <button class="btn incr" type="button" id="bulleted_line_height_incr">+</button>
                            <button class="btn decr" type="button" id="bulleted_line_height_decr">-</button>                        
                    </div>
                </div>


                <div class="control-group">
                    <div class="control-label">
                        <label id="jform_bulleted_margin-lbl" for="jform_bulleted_margin">
                            Margins :
                        </label>
                    </div>
                    <div class="controls">                        
                            <input name="jform[jform_bulleted_margin]" data-css-prop="margin" class="mini-input observeListChanges" id="jform_bulleted_margin" value="5" type="text">
                            <button class="btn incr" type="button" id="bulleted_margin_incr">+</button>
                            <button class="btn decr" type="button" id="bulleted_margin_decr">-</button>                                             
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label id="jform_bulleted_padding-lbl" for="jform_bulleted_padding">
                            Paddings :
                        </label>
                    </div>
                    <div class="controls">                        
                            <input name="jform[jform_bulleted_padding]" data-css-prop="padding" class="mini-input observeListChanges" id="jform_bulleted_padding" value="5" type="text">
                            <button class="btn incr" type="button" id="bulleted_padding_incr">+</button>
                            <button class="btn decr" type="button" id="bulleted_padding_decr">-</button>                                             
                    </div>
                </div>
            </div>



        </div>
        <div class="span8">
            <div class="form-inline" style="margin-left: 20px" >
                <label style="font-weight: bold"><?php echo JText::_("COM_DROPEDITOR_VIEW_BULLETED_PREVIEW"); ?></label>
                <div id="preview" style="padding:20px 0 25px 0; border: 1px solid #ccc;">
                    <ul id="previewList" class="droplist">
                        <li><?php echo JText::_("COM_DROPEDITOR_VIEW_BULLETED_TEXT"); ?></li>
                        <li><?php echo JText::_("COM_DROPEDITOR_VIEW_BULLETED_TEXT"); ?></li>
                    </ul>

                </div>

                <p style="height: 20px"> <span id="savedInfo" style="display:none;"><?php echo JText::_('COM_DROPEDITOR_VIEW_SAVED'); ?></span></p>
            </div>

            <div class="form-inline" style="text-align: center;">

                <button class="btn btn-success" id="btn_add"  style="margin:20px 10px;">
                    <?php echo JText::_("COM_DROPEDITOR_VIEW_BULLETED_INSERT"); ?>
                </button>
               
                <button class="btn " id="btn_save"  style="margin:20px auto;">
                    <?php echo JText::_("COM_DROPEDITOR_VIEW_BULLETED_SAVE"); ?>
                </button>                
            </div>

            <script>
                var DropBulleteds = {};
                var editMode = '<?php echo ($update) ? 'update' : 'insert'; ?>';

<?php if (count($this->bulleteds) > 0) : ?>
    <?php for ($i = 0; $i < count($this->bulleteds); $i++): ?>
                        DropBulleteds[<?php echo $this->bulleteds[$i]->id; ?>] = JSON.parse('<?php echo $this->bulleteds[$i]->params; ?>');
    <?php endfor; ?>
<?php endif; ?>
            </script>            

            <div class="form-inline">  
                <p><strong> <?php echo JText::_("COM_DROPEDITOR_VIEW_BULLETED_SAVED"); ?></strong></p>
                <ul id="btnList">    
                    <?php if (count($this->bulleteds) > 0) : ?>
                        <?php for ($i = 0; $i < count($this->bulleteds); $i++) : $bulleted = $this->bulleteds[$i]; ?>
                            <li class="btnItem" data-id-bulleted="<?php echo $bulleted->id; ?>">
                                <ul id="bul-<?php echo $bulleted->id; ?>" data-id-bulleted="<?php echo $bulleted->id; ?>" class="droplist <?php echo $bulleted->cssClass; ?>">
                                    <li><?php echo JText::_("COM_DROPEDITOR_VIEW_BULLETED_TEXT"); ?></li>
                                </ul>
                                                           
                                <br/>
                                <div style="margin-left: 6px;">
                                    <a class="trash" title="Trash"><i class="icon-trash"></i></a>
                                    <a class="edit" title="Edit"><i class="icon-edit"></i></a>                                 
                                    <a class="insert" title="Insert"><i class="icon-plus"></i></a>
                                </div>                                
                            </li>                           
                        <?php endfor; ?>                                                
                    <?php else: ?>
                        <p><?php echo JText::_("COM_DROPEDITOR_VIEW_BULLETED_NO_BULLETED"); ?></p>
                    <?php endif; ?>
                </ul>


            </div>

        </div>
    </div>  

</div>

<style>
    #bulleted_creator .control-label { width: 90px;}
</style>
<style id="dynamic-styles"></style>

<style id="bulleted-styles" ></style>

<script >
    var buttonPreviewText = '<?php echo JText::_("COM_DROPEDITOR_VIEW_BULLETED_TEXT"); ?>';
    jQuery(document).ready(function($) {

        $('.minicolors-input').minicolors('settings', {
            control: jQuery(this).attr('data-control') || 'hue',
            position: jQuery(this).attr('data-position') || 'right',
            theme: 'bootstrap',
            change: function() {
                jQuery(this).trigger('change');
            }
        }).attr('maxlength', '7');
    });



    function getBtnHtml() {
        var $ = jQuery;
        var $clone = $("#previewBtn").clone();
        $clone.removeAttr('id').wrap('<div>');

        var link = $("#jform_bulleted_link").val();
        $clone.attr('onclick', "location.href='" + link + "';");
        $clone.attr('contenteditable', "true");
        $clone.attr('data-url', link);
        $clone.attr('data-btnstyle', $('#bulleted_style').val());
        $clone.attr('data-color', $('#jform_bulleted_color').val());

        return $clone.parent().html();

    }


    function insertButton() {
        if (editMode == 'update') {
            updateButton();
        } else {
            if (window.parent) {
                window.parent.jInsertEditorText(getBtnHtml()
                        , '<?php echo JFactory::getApplication()->input->getVar('e_name'); ?>')
            }
        }
    }

    function updateButton() {
        var ckEditor = window.parent.CKEDITOR.instances[e_name];
        el = ckEditor.getSelection().getStartElement();
        el.getParent().setHtml(getBtnHtml());
        var ckDialog = window.parent.CKEDITOR.dialog.getCurrent();
        if (ckDialog) {
            ckDialog.hide();
        }
    }
</script>