<?php
/**
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die;

JHtml::_('behavior.keepalive');
JHtml::_('behavior.framework');
JText::script('COM_DROPTEDITOR_JS_VIEW_COLUMNS_CHANGE');
?>
<div class="container" id="htmlTemplate">

     <div class="row-fluid">
        <div class="span8">

                <div class=" control-group">
                    <div class="control-label">
                        <label id="template_name-lbl" for="template_name">
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_HTMLTEMPLATES_SAVE_LABEL'); ?>
                        </label>
                    </div>
                    <div class="controls">
                          <input class="inputbox" type="text" name="jform[template_name]" id="jform_template_name" placeholder="<?php echo JText::_("COM_DROPEDITOR_VIEW_HTMLTEMPLATES_SAVE_PLACEHOLDER"); ?>"  />                   
                          <button id="saveBtn" class="btn btn-success"><?php echo JText::_("COM_DROPEDITOR_VIEW_HTMLTEMPLATES_SAVE_BTN"); ?></button>
                    </div>
                    <div class="description">
                        <span> <?php echo JText::_('COM_DROPEDITOR_VIEW_HTMLTEMPLATES_SAVE_DESC'); ?></span>
                    </div>
                </div>
                
            <div id="templateContent" style="display: none;"></div>    
          </div>  
     </div>
    
    <div class="row-fluid" style="margin-top: 20px">
        <div class="span8">
            <div class=" control-group">
                    <div class="control-label">
                        <label id="listTemplate-lbl" for="listTemplate">
                            <?php echo JText::_('COM_DROPEDITOR_VIEW_HTMLTEMPLATES_LOAD_LABEL'); ?>
                        </label>
                    </div>
                 <div class="description">
                        <span> <?php echo JText::_('COM_DROPEDITOR_VIEW_HTMLTEMPLATES_LOAD_DESC'); ?></span>
                  </div>
           </div>
           <ul class="list-item-content" id="listTemplate">
               <?php if(count($this->items))  {
                   foreach($this->items as $item) { ?>
                        <li id="template-<?php echo $item->id;?>" data-id-template="<?php echo $item->id;?>">
                            <a class="title"><?php echo $item->title;?></a>
                            <a class="trash"><i class="icon-trash"></i></a>                    
                        </li>
                   <?php }
               } ?>
              
            </ul>
        </div>
    </div>
</div>

<script>
    jQuery(document).ready(function($) {    
        function initActions() {
            $('#listTemplate li a.title').unbind('click').on('click', function() {
                id_template = $(this).parents('li').data('id-template');
                $.ajax({
                    url: "index.php?option=com_dropeditor&task=htmltemplates.load&id=" + id_template,
                    type: "POST",
                    dataType: "json",
                    success: function(result) {
                        if (result.status === true) {                            
                            if (window.parent) {
                                window.parent.jInsertEditorText(result.datas.data
                                    ,'<?php echo JFactory::getApplication()->input->getVar('e_name');?>')
                            }
                        }
                    }
                });
            });

            $('#listTemplate li a.trash').unbind('click').on('click', function() {
                that = this;
                id_template = $(this).parents('li').data('id-template');
                $.ajax({
                    url: "index.php?option=com_dropeditor&task=htmltemplates.delete&id=" + id_template,
                    type: "POST",
                    dataType: "json",
                    success: function(result) {
                        if (result.status === true) {
                             $("li#template-"+id_template).remove();
                        }
                    }
                });
            });
        };
    
        initActions();
        $("#saveBtn").click(function() { 
            var htmlTemplate = $("#templateContent").html();
            var title =  $("#jform_template_name").val();
            $.ajax({
                url     :   "index.php?option=com_dropeditor&task=htmltemplates.add",
                type    : 'POST',
                data    :   {'title': title, 'template': htmlTemplate}
            }).done(function(data){
                result = $.parseJSON(data);                
                if (result.status == true) {                    
                    var newItem = '<li data-id-template="'+ result.datas.id +'" id="template-'+result.datas.id+'">'
                         + '<a class="title">'+ result.datas.name+ '</a>'
                         + '<a class="trash"><i class="icon-trash"></i></a>'  
                         + '</li>';
                    $("#listTemplate").append(newItem);
                    initActions();
                } else {
                     bootbox.alert(result.datas.response);                      
                }
                
            });
            
            
        })
    })
   
</script>    