<?php
/**
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined('_JEXEC') or die;

JHtml::_('behavior.tooltip');
JHtml::_('behavior.formvalidation');
JHtml::_('behavior.keepalive');
JHtml::_('behavior.framework');
JHtml::_('behavior.colorpicker');
JHtml::_('formbehavior.chosen', '.dropeditor-chosen-select', null, array("disable_search_threshold"=>5));
  
JText::script('COM_DROPEDITOR_JS_SAMPLE_TEXT');

JText::script('COM_DROPEDITOR_JS_ARE_YOU_SURE');
JText::script('COM_DROPEDITOR_JS_DELETE');
JText::script('COM_DROPEDITOR_JS_EDIT');
JText::script('COM_DROPEDITOR_JS_DBLCLICK_TO_EDIT_TITLE');
JText::script('COM_DROPEDITOR_JS_WANT_DELETE');
JText::script('COM_DROPEDITOR_JS_CANCEL');
JText::script('COM_DROPEDITOR_JS_OK');
JText::script('COM_DROPEDITOR_JS_CONFIRM');
JText::script('COM_DROPEDITOR_JS_SAVE');

$doc = JFactory::getDocument();
$doc->addScriptDeclaration('e_name="'.JRequest::getString('e_name').'";');
$update = JRequest::getInt('update',0);
$published = true;
$model = $this->getModel();
?>
<div class="container">
    <div class="row-fluid">
        <div class="span12">
            <div class="form-inline" id="parentContent">
                <div class="control-group w100pc">
                    <div class="control-label w90">
                      <?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TYPE'); ?>
                    </div>
                    <div class="controls">
                         <select type="text" name="link_type" id="link_type">
                             <option value="menuitem"><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TYPE_MENU'); ?></option>
                             <option value="article"><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TYPE_ARTICLE'); ?></option>
	                         <?php if (ckeditorHelper::checkComponentExist("com_dropfiles")) : ?>
                                 <option value="dropfiles"><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TYPE_DROPFILES'); ?></option>
	                         <?php endif; ?>
                             <option value="custom"><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TYPE_CUSTOM'); ?></option>
                             <option value="mailto"><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TYPE_MAIL'); ?></option>
                             <option value="anchor"><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TYPE_ANCHOR'); ?></option>
	                         <?php if (ckeditorHelper::checkComponentExist("com_k2")) : ?>
                                 <option value="k2"><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TYPE_K2'); ?></option>
	                         <?php endif; ?>
	                         <?php if (ckeditorHelper::checkComponentExist("com_flexicontent")) : ?>
                                 <option value="flexi"><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TYPE_FLEXI'); ?></option>
	                         <?php endif; ?>
                         </select>

                        <span id="link_content_article" class="link_content_block" style="display: none;">
                            <input type="text" class="inputbox" id="link_content_article_name" value="" disabled="disabled" size="35" />
                            <input type="hidden" id="link_content_article_id" class="required modal-value" name="jform[request][id]" value="2" aria-required="true" required="required">
                            <input type="hidden" id="link_content_article_link" name="jform[request][link]" value="">
                        </span>

                        <span id="link_content_anchor" class="link_content_block" style="display: none;">
                            <input type="text" class="inputbox" id="link_content_anchor_name" value="" disabled="disabled" size="35" />
                            <input type="hidden" id="link_content_anchor_id" class="required modal-value" name="jform[request][id]" value="2" aria-required="true" required="required">
                            <input type="hidden" id="link_content_anchor_link" name="jform[request][link]" value="">
                        </span>

                        <span id="link_content_dropfiles" class="link_content_block" style="display: none;">
                            <input type="text" class="inputbox" id="link_content_dropfiles_name" value="" disabled="disabled" size="35" />
                            <input type="hidden" id="link_content_dropfiles_id" class="required modal-value" name="jform[request][id]" value="2" aria-required="true" required="required">
                            <input type="hidden" id="link_content_dropfiles_link" name="jform[request][link]" value="">
                        </span>

                        <span id="link_content_k2" class="link_content_block" style="display: none;">
                            <input type="text" class="inputbox" id="link_content_k2_name" value="" disabled="disabled" size="35" />
                            <input type="hidden" id="link_content_k2_id" class="required modal-value" name="jform[k2request][id]" value="2" aria-required="true" required="required">
                            <input type="hidden" id="link_content_k2_link" name="jform[request][link]" value="">
                        </span>

                        <span id="link_content_flexi" class="link_content_block" style="display: none;">
                            <input type="text" class="inputbox" id="link_content_flexi_name" value="" disabled="disabled" size="35" />
                            <input type="hidden" id="link_content_flexi_id" class="required modal-value" name="jform[k2request][id]" value="2" aria-required="true" required="required">
                            <input type="hidden" id="link_content_flexi_link" name="jform[request][link]" value="">
                        </span>

                        <span id="link_content_menuitem" class="link_content_block" style="display:none;">
                            <select style="width:212px;" name="link_content_menuitem" class="dropeditor-chosen-select" id="link_content_menuitem_id">
                                <option value=""><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_SELECT') ?></option>
                                <?php echo JHtml::_('select.options', $this->menuItems);?>
                            </select>
                        </span>

                        <span id="link_custom" class="link_content_block" >
                            <input type="text" class="inputbox" id="link_custom_id" placeholder="http://" size="35" />
                        </span>
                        <span id="mail_to_link" class="link_content_block" style="display: none">
                            <input type="text" class="inputbox" id="email_input" placeholder="Email" size="35" />
                        </span>

                        <button class="btn" id="btn_insert" onclick='insertLink()'  style="margin-left:15px">
		                    <?php echo JText::_("COM_DROPEDITOR_LAYOUT_LINK_BTN_INSERT"); ?>
                        </button>
                    </div>
                </div>

                <div class="control-group w100pc">
                    <div class="control-label w90">
			            <?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TEXT'); ?>
                    </div>
                    <div class="controls">
                        <input class="inputbox" type="text" name="jform[link_label]" id="link_text" placeholder="<?php echo JText::_("COM_DROPEDITOR_LAYOUT_LINK_PARAM_TEXT"); ?>"  />
                    </div>
                    <div class="controls" style="margin-left: 10px">
                        <input class="inputbox" type="text" id="link_title" placeholder="<?php echo JText::_("COM_DROPEDITOR_LAYOUT_LINK_PARAM_TITLE"); ?>"  />
                    </div>
                </div>

                <div class="control-group w100pc">
                    <div class="control-label w90">
                      <?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TARGET'); ?>
                    </div>
                    <div class="controls">
                        <select type="text" name="link_target" id="link_target">
                            <option value="_self"><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TARGET_CURRENT'); ?></option>
                            <option value="_blank"><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TARGET_BLANK'); ?></option>
                            <option value="_parent"><?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_PARAM_TARGET_PARENT'); ?></option>
                        </select>
                    </div>
                </div>
            </div>

            <!--Iframe to show list of anchors -->
            <div id="anchorFrame" class="childContent">
                <div id="anchor-search-block" class="search-block">
                    <div class="btn-wrapper input-append">
                        <input type="text" id="anchor-search" class="search-input" placeholder="<?php echo JText::_('JSEARCH_FILTER_SUBMIT') ?>"/>
                        <button type="button" class="btn search-submit" id="anchor-search-submit">
                            <span class="icon-search"></span>
                        </button>
                    </div>
                </div>

                <div id="anchorTree" class="treeContent"></div>
            </div>

            <!--Iframe to show list of article items -->
            <div id="articleFrame" class="childContent">
                <div id="article-search-block" class="search-block">
                    <div class="btn-wrapper input-append">
                        <input type="text" id="article-search" class="search-input" placeholder="<?php echo JText::_('JSEARCH_FILTER_SUBMIT') ?>"/>
                        <button type="button" class="btn search-submit" id="article-search-submit">
                            <span class="icon-search"></span>
                        </button>
                    </div>
                </div>

                <div id="articleTree" class="treeContent" data-comp="com_content"></div>
            </div>

            <!--Iframe to show list of Dropfiles items -->
            <?php if (ckeditorHelper::checkComponentExist("com_dropfiles")) : ?>
            <div id="dropfilesFrame" class="childContent">
                <div id="dropfiles-search-block">
                    <div class="btn-wrapper input-append">
                        <input type="text" id="dropfiles-search" class="search-input" name="dropfiles-search" placeholder="<?php echo JText::_('JSEARCH_FILTER_SUBMIT') ?> Dropfiles"/>
                        <button type="button" class="btn search-submit" id="dropfiles-search-submit">
                            <span class="icon-search"></span>
                        </button>
                    </div>
                </div>

                <div id="dropfilesTree" class="treeContent" data-comp="com_dropfiles"></div>
            </div>
            <?php endif; ?>

            <!--Iframe to show list of K2 items-->
	        <?php if (ckeditorHelper::checkComponentExist("com_k2")) : ?>
            <div id="k2Frame" class="childContent">
                <div id="k2-search-block">
                    <div class="btn-wrapper input-append">
                        <input type="text" id="k2-search" name="k2-search" class="search-input" placeholder="<?php echo JText::_('JSEARCH_FILTER_SUBMIT') ?> K2"/>
                        <button type="button" class="btn search-submit" id="k2-search-submit">
                            <span class="icon-search"></span>
                        </button>
                    </div>
                </div>

                <div id="k2Tree" class="treeContent" data-comp="com_k2"></div>
            </div>
            <?php endif; ?>

            <!--Iframe to show list of Flexi items-->
	        <?php if (ckeditorHelper::checkComponentExist("com_flexicontent")) : ?>
                <div id="flexiFrame" class="childContent">
                    <div id="flexi-search-block">
                        <div class="btn-wrapper input-append">
                            <input type="text" id="flexi-search" name="flexi-search" class="search-input" placeholder="<?php echo JText::_('JSEARCH_FILTER_SUBMIT') ?> Flexi"/>
                            <button type="button" class="btn search-submit" id="flexi-search-submit">
                                <span class="icon-search"></span>
                            </button>
                        </div>
                    </div>

                    <div id="flexiTree" class="treeContent" data-comp="com_flexicontent"></div>
                </div>
            <?php endif; ?>
        </div>
    </div>
</div>

<script>
function insertLink() {
    var $ = jQuery;
    if (window.parent) {
        var link_type = $("#link_type input").val();
        if (link_type === 'mailto') {
            href = getLink();
            if (href.indexOf('@') === -1) {
                alert('<?php echo JText::_('COM_DROPEDITOR_LAYOUT_LINK_INVALID_EMAIL') ?>');
                return false;
            }
        }
        var editor = window.parent.CKEDITOR.instances['<?php echo JFactory::getApplication()->input->getVar('e_name');?>'];
        var element = window.parent.CKEDITOR.plugins.link.getSelectedLink( editor );
        var selection = editor.getSelection();
        if ( element )
        {
            var href = getLink();
            var link_text = $('#link_text').val().trim();
            element.$.removeAttribute( 'data-cke-saved-href' );
            element.setAttribute('href', href);
            element.setAttribute('target', $("#link_target input").val());
            element.setAttribute('title', $("#link_title").val().trim());
            element.setAttribute('data-link-type', link_type);
            if (link_text !== '')
                element.setHtml(link_text);

            selection.selectElement(element);
        } else {
            var link = new window.parent.CKEDITOR.dom.element.createFromHtml( getLinkHtml());
            editor.insertElement( link );
            selection.selectElement(link);
        }

        var ckDialog = window.parent.CKEDITOR.dialog.getCurrent();
        if(ckDialog) {
           ckDialog.hide();
        }
    }
}
</script>