<?php
/** 
 * Dropeditor
 * 
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropeditor
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


defined('_JEXEC') or die;


class DropeditorViewStyle extends JViewLegacy
{
	protected $state;
	protected $item;
	protected $form;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		$this->state	= $this->get('State');
		$this->item		= $this->get('Item');
		$this->form		= $this->get('Form');
		$this->form->setFieldAttribute('source', 'syntax', 'js');
		$this->source = $this->get('Source');
              
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		$this->addToolbar();
		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 */
	protected function addToolbar()
	{
		JRequest::setVar('hidemainmenu', false);

		$user		= JFactory::getUser();
		$isNew		= ($this->item->id == 0);
        if (isset($this->item->checked_out)) {
		    $checkedOut	= !($this->item->checked_out == 0 || $this->item->checked_out == $user->get('id'));
        } else {
            $checkedOut = false;
        }
		$canDo		= DropeditorHelper::getActions();

		JToolBarHelper::title(JText::_('COM_DROPEDITOR_TITLE_STYLE'), 'style.png');

		// If not checked out, can save the item.
		if (!$checkedOut && ($canDo->get('core.edit')||($canDo->get('core.create'))))
		{
			JToolBarHelper::apply('style.apply', 'JTOOLBAR_APPLY');
			JToolBarHelper::save('style.save', 'JTOOLBAR_SAVE');
		}
		
		if (empty($this->item->id)) {
			JToolBarHelper::cancel('style.cancel', 'JTOOLBAR_CANCEL');
		}
		else {
			JToolBarHelper::cancel('style.cancel', 'JTOOLBAR_CLOSE');
		}
	}
}